      subroutine doFcn(a,b,natom,x,y,z,r,idtype,v,Fcn,dFcn,Fcng,dFcng)
!c34567
      use params
      use grad
      
      implicit none
      integer a,b,natom,v,idtype(natom),m,n,o,i
      double precision g(0:2),gam,d,Fcng(natom),Ha,Hb
      double precision dFcng(natom,natom,3),dHa(natom,3)
      double precision dHb(natom,3),tmp
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom)
      double precision Fcn,dFcn(natom,3)

c      save
c      save Fcng,dFcng
      
!c v determines which parameter set to use
!c V(li-alpha,lj-beta,lambda)
!c    v=1 => V000
!c    v=2 => V010
!c    v=3 => V110
!c    v=4 => V111
!c Repulsive Interaction
!c    v=5: Vrep(alpha,beta)
!c V(l) in H(ii)(aa)
!c    v=6 => V0 (l=0)
!c    v=7 => V1 (l=1)
!c234567
      m=min(idtype(a),idtype(b))
      n=max(idtype(a),idtype(b))

      do 12 o=0,2
         g(o)=pargee(m,n,o)
 12   continue
      gam=parFcn(m,n,2,v)
      d=parFcn(m,n,1,v)

c      if(.not.flag(1))call Fcnsetup(natom,x,y,z,r,g(1),g(2),Fcng,dFcng)
c      write(*,*)'Fcng(1) = ',Fcng(1)

      if(d.eq.0.0d0)then
         Fcn=1.0d0
	 dFcn=0.0d0
	 flag(2)=.false.
	 return
      endif
      flag(2)=.true.

      do 2 i=1,natom
      do 2 m=1,3
         dFcn(i,m)=dFcng(a,i,m)
c Borrowing dFcn to use as a dummy variable - will for real define later
 2    continue
      call doHa(a,b,natom,x,y,z,r,Fcng(a),dFcn,g(0),g(1),g(2),
     &   gam,Ha,dHa)

c      Fcn=Ha
c      if(dograd)then
c         do 111 n=1,natom
c	 do 111 m=1,3
c	    dFcn(n,m)=dHa(n,m)
c 111     continue
c      endif
c      return
     
c      write(*,*)'Found Ha'
      do 3 i=1,natom
      do 3 m=1,3
         dFcn(i,m)=dFcng(b,i,m)
c Borrowing dFcn to use as a dummy variable - will for real define later
 3    continue
      call doHa(b,a,natom,x,y,z,r,Fcng(b),dFcn,g(0),g(1),g(2),
     &   gam,Hb,dHb)
c      write(*,*)'Found Hb'

      Fcn=1.0d0-d*(1.0d0-Ha*Hb)
c      write(*,*)'Ha=',Ha,'Hb=',Hb,'dHaHb=',d*Ha*Hb

      dFcn=0.0d0
      if(dograd)then
         do 1 n=1,natom
	 do 1 m=1,3
	    tmp=Ha*dHb(n,m)+Hb*dHa(n,m)
	    dFcn(n,m)=d*tmp
 1       continue
      endif

      write(*,*)'Fcn v = ',v,' Fcn = ',Fcn

      end subroutine doFcn

      subroutine doFg(i,j,natom,x,y,z,r,g1,g2,Fg,dFg)
      use grad
      implicit none
      integer i,j,natom
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),g1,g2,e,den
      double precision Fg,dFg(2,3),rij
      double precision el,em,en,elladmm,ellmimm,enn,tmp,t1,t2
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      
      dFg=0.0d0
      rij=r(i,j)
      if(rij.lt.g2)then
         e=(g1*g2)/(rij-g2)
         Fg=dexp(g1+e)
	 if(dograd)then
	    call lmndlm(i,j,natom,x,y,z,r)
	    e=g1*g2*Fg
	    den=rij-g2
	    den=den*den
	    e=-e/den
	    dFg(1,1)=e*el
	    dFg(1,2)=e*em
	    dFg(1,3)=e*en
	    dFg(2,1)=-e*el
	    dFg(2,2)=-e*em
	    dFg(2,3)=-e*en
	 endif
      else
         Fg=0
      endif
      end subroutine doFg
     
      subroutine Fcnsetup(natom,x,y,z,r,Fcng,dFcng)

      use grad
      use params
      implicit none
      integer i,j,m,natom
      double precision Fcng(natom),Fg,dFg(2,3)
      double precision dFcng(natom,natom,3)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),g1,g2

      flag(1)=.true.
      Fcng=0.0d0
      dFcng=0.0d0

c For now just use Al values for gamma1 and gamma2
      g1=pargee(3,3,1)
      g2=pargee(3,3,2)
      
      do 1 i=1,natom
      do 2 j=1,natom
         if(i.eq.j)goto 2
	 call doFg(i,j,natom,x,y,z,r,g1,g2,Fg,dFg)
	 Fcng(i)=Fcng(i)+Fg
	 if(dograd)then
	    do m=1,3
	       dFcng(i,i,m)=dFcng(i,i,m)+dFg(1,m)
	       dFcng(i,j,m)=dFcng(i,j,m)+dFg(2,m)
	    enddo
	 endif
 2    continue
 1    continue

      end subroutine Fcnsetup

      subroutine doHa(a,b,natom,x,y,z,r,ga,dga,g0,g1,g2,gam,Ha,dHa)

      use grad
      implicit none
      integer natom,n,m,a,b
      double precision ga,dga(natom,3),g0,gam,Ha,dHa(natom,3)
      double precision Fg,dFg(2,3),t1,t2,g1,g2,t3
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom)

      dHa=0.0d0

      call doFg(a,b,natom,x,y,z,r,g1,g2,Fg,dFg)
      t3=(ga-Fg)/g0
      t1=t3**gam
      Ha=1.0d0/(1.0d0+t1)
c      write(*,*)'ga=',ga,'Fg=',Fg,'t1=',t1,'Ha=',Ha
      if(dograd)then
         t1=t3**(gam-1.0d0)
	 t2=1.0d0+t3**gam
	 t2=1.0d0/(t2*t2)
	 t1=-gam*t1*t2/g0
	 do 1 n=1,natom
	 do 1 m=1,3
	    if(n.eq.a)then
	       t2=dga(n,m)-dFg(1,m)
	       dHa(n,m)=t1*t2
	    elseif(n.eq.b)then
	       t2=dga(n,m)-dFg(2,m)
	       dHa(n,m)=t1*t2
	    else
	       dHa(n,m)=t1*dga(n,m)
	    endif
 1       continue 
      endif
      end subroutine doHa
