      subroutine doFs(a,b,natom,x,y,z,r,idtype,v,Fs,dFs)
!c34567
      use basics
      use params
      use grad 
      implicit none
      integer a,b,v,k,natom,idtype(natom),d,f,g,n,m
      double precision sum,bb(3),e,ee,eee,Xi,rho,drho,lad(3),rb3
      double precision x(natom),y(natom),z(natom),lab(3),lbd(3)
      double precision r(natom,natom),Fs,dFs(natom,3),dXi(natom,3)
      double precision el,em,en,elladmm,ellmimm,enn,tmp,t1,t2
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      
!c v determines which parameter set to use
!c V(li-alpha,lj-beta,lambda)
!c    v=1 => V000
!c    v=2 => V010
!c    v=3 => V110
!c    v=4 => V111
!c Repulsive Interaction
!c    v=5: Vrep(alpha,beta)
!c V(l) in H(ii)(aa)
!c    v=6 => V0 (l=0)
!c    v=7 => V1 (l=1)
!c       b(i,v,h,al) (i=1,3) (v=1,3) !beta(1) beta(2) beta(3) for ea. V
!c234567
      if(a.eq.b)write(*,*)'With v=',v
      if(a.eq.b)write(*,*)'where a=b=',a
      if(a.eq.b)Stop 'Bad call to doFs: a=b'
      Fs=0.0
      d=min(idtype(a),idtype(b))
      f=max(idtype(a),idtype(b))
      do 12 g=1,3
         bb(g)=parBeta(icase,d,f,g,v)
 12   continue
      Xi=0.0
      dFs=0.0
      dXi=0.0
!c first check to see whether Fmb term has been deemed significant
      if(bb(1).eq.0.0d0)then
         Fs=1.0
	 flag(2)=.false.
      else
       flag(2)=.true.
       Fs=0.0
       do 10 d=1,natom
          if((d.ne.a).and.(d.ne.b))then
             rho=(r(a,d)+r(b,d))/r(a,b)
	     rb3=rho**bb(3)
c	     write(2,*)'debug rho**b3 =',rho**bb(3)
             ee=dexp(-bb(2)*rb3)
	     if(dograd)tmp=ee*rb3/r(a,b)
             Xi=Xi+ee
c	     write(2,*)'debug i j k ee:',a,b,d,ee
	     if(dograd)then
                do 100 n=1,natom
		  call lmndlm(a,d,natom,x,y,z,r)
		  if(a.eq.n)then
		     lad(1)=el
		     lad(2)=em
		     lad(3)=en
		  elseif(d.eq.n)then
		     lad(1)=-el
		     lad(2)=-em
		     lad(3)=-en
		  else
		     lad(1)=0.0d0
		     lad(2)=0.0d0
		     lad(3)=0.0d0
		  endif
		  call lmndlm(a,b,natom,x,y,z,r)
		  if(a.eq.n)then
		     lab(1)=el
		     lab(2)=em
		     lab(3)=en
		  elseif(b.eq.n)then
		     lab(1)=-el
		     lab(2)=-em
		     lab(3)=-en
		  else
		     lab(1)=0.0d0
		     lab(2)=0.0d0
		     lab(3)=0.0d0
		  endif
		  call lmndlm(b,d,natom,x,y,z,r)
		  if(b.eq.n)then
		     lbd(1)=el
		     lbd(2)=em
		     lbd(3)=en
		  elseif(d.eq.n)then
		     lbd(1)=-el
		     lbd(2)=-em
		     lbd(3)=-en
		  else
		     lbd(1)=0.0d0
		     lbd(2)=0.0d0
		     lbd(3)=0.0d0
		  endif
		  do 101 m=1,3
		     t1=(lad(m)+lbd(m))/rho
		     t1=t1-lab(m)
		     dXi(n,m)=dXi(n,m)+tmp*t1
c		     t1=r(a,d)+r(b,d)
c		     t1=-t1*lab(m)/(r(a,b)*r(a,b))
c		     t2=(lad(m)+lbd(m))/r(a,b)
c		     drho=t1+t2
c		     dXi(n,m)=dXi(n,m)+ee*tmp*drho
 101              continue
 100            continue
             endif
          endif !if((d.ne.a)...
 10    continue
       Xi=Xi*bb(1)
       if(dograd)dXi=-dXi*bb(2)*bb(3)*bb(1)

c       Fs=Xi
c       if(dograd)then
c       do n=1,natom
c       do m=1,3
c         dFs(n,m)=dXi(n,m)
c       enddo
c       enddo
c       endif
c       return
cc       write(2,*)'debug Xi = ',Xi

       tmp=mtanh(Xi)
       Fs=1.0d0-tmp

       if(dograd)then
c d(-tanh) = -sech^2
c          tmp=-msech2(Xi)
          tmp=1.0d0-tmp*tmp
	  do 110 n=1,natom
	  do 110 m=1,3
	     dFs(n,m)=-tmp*dXi(n,m)
 110      continue
       endif
      endif
c      if(debug2)write(2,*)'In Fs v=',v,' i=',a,' j=',b,' Fs(i,j)=',Fs
      end subroutine doFs
