      module basics
      implicit none
      integer basii,maxid2,subsiz
      parameter(maxid2=9,subsiz=6)
      double precision norbit(maxid2),nelem(maxid2)
      double precision fact(0:12)
      double precision vsip_exp(maxid2,2)
      character*2 id2symb(maxid2)
c      common /factorial/ fact
c      common /coulom/ vsip
c      common /atdata/ norbit,nelem
      data fact/1.0,1.0,2.0,6.0,24.0,120.0,720.0,5040.0,40320.0,
     *          362880.0,3628800.0,39916800.0,479001600.0/
c
c   valence state ionization potentials in eV 
c
c      data (vsip(1,basii),basii=1,2) /- 8.83, 0.00/   H
c      data (vsip(2,basii),basii=1,2) /-18.62,-8.33/   C
c      data (vsip(3,basii),basii=1,2) /-12.30,-6.5/    Al
c      data (vsip(3,basii),basii=1,2) /-10.62,-5.986/  Al after 11/13/02 
c
c   valence state ionization potentials in a.u.
c
      data (vsip_exp(1,basii),basii=1,2)
     &           /-0.32449375830d0,-0.00000000000d0/
      data (vsip_exp(2,basii),basii=1,2)
     &           /-0.68426656620d0,-0.30611925330d0/
      data (vsip_exp(3,basii),basii=1,2)
     &           /-0.3902744862d0,-0.21997957386d0/
      data (vsip_exp(4,basii),basii=1,2)
     &           /-0.30134188200d0,-0.33441599100d0/
      data (vsip_exp(5,basii),basii=1,2)
     &           /-0.31787893650d0,-0.34360324350d0/
      data (vsip_exp(6,basii),basii=1,2)
     &           /-0.29950443150d0,-0.33625344150d0/
      data (vsip_exp(7,basii),basii=1,2)
     &           /-0.31787893650d0,-0.34727814450d0/
      data (vsip_exp(8,basii),basii=1,2)
     &           /-0.29582953050d0,-0.33992834250d0/
      data (vsip_exp(9,basii),basii=1,2)
     &           /-0.31787893650d0,-0.35462794650d0/

      data norbit /1,4,4,6,6,6,6,6,6/
      data nelem  /1,4,3,10,11,10,11,10,11/
      data id2symb /'H ','C ','Al','Ni','Cu','Pd','Ag','Pt','Au'/

      contains

      double precision function mtanh(Xi)

      implicit none

      double precision Xi,ep

c      ep=dexp(2*Xi)
c      mtanh=(ep-1.0d0)/(ep+1.0d0)

      ep=dexp(-2.0d0*Xi)
      mtanh=(1.0d0-ep)/(1.0d0+ep)

      end function mtanh

      double precision function msech(Xi)

      implicit none

      double precision Xi,ep,em

      ep=dexp(Xi)
      em=1.0d0/ep
      msech=2.0d0/(ep+em)

      end function msech

      double precision function msech2(Xi)

      implicit none

      double precision Xi,ep,em

      ep=dexp(2.0d0*Xi)
      em=1.0d0/ep
      msech2=4.0d0/(ep+em+2.0d0)

      end function msech2

      end module basics

      module printing
      implicit none
      double precision unite,unitd
      integer funit,printlev
      character*8 unitesym
      character*4 unitdsym
      double precision cutCi,cutMO,cutEj
      end module printing

      module grad
      implicit none
      logical dograd,doS,flag(2)
      integer ndimdH,ndimS,ndimdS1,ndimdS2,ndimat
c Flag definitions
c (1) Fcn: false - call Fcnsetup
c (2) Fmb: true - Fmb calculated
      end module grad

      module params
      implicit none
      integer mc,maxid,icase
      parameter (mc=25,maxid=9)
c      parameter (mc=4,maxid=3,icase=1)
      double precision parKsss(mc,maxid,maxid),parKsps(mc,maxid,maxid)
      double precision parKpps(mc,maxid,maxid),parKppp(mc,maxid,maxid)
      double precision parZsss(mc,maxid,maxid),parZsps(mc,maxid,maxid)
      double precision parZpps(mc,maxid,maxid),parZppp(mc,maxid,maxid)
      double precision parA(mc,maxid,maxid),parB(mc,maxid,maxid)
      double precision paru(mc,maxid,maxid),pardelta(mc)
      double precision parAlpha(mc,maxid),pard(mc,maxid,maxid)
      double precision parvsip(mc,3,2),parUpen(9:mc)
      double precision parBeta(14:20,3:3,3:3,3,7)
      double precision parKappa(3:3,3:3,4,7)
      double precision pargee(3:3,3:3,0:2),parFcn(3:3,3:3,2,7)
      double precision pardeltasp(3:3,3:3,14:22,6:7)
      double precision parDDeltasp(3:3,3:3,14:22,6:7)
      double precision parTzero(mc)

c  icase     method
c  -----------------
c    1       TBCI-S
c   2-4      TBCI-S, for future use
c    5       TBCI-SPD
c   6-7      TBCI-SPD, for future use
c    8       TB+U
c    9       TB-WH, PRB 0.07 eV Upen
c   10       TB-WH, JCTC, 0.00 eV Upen
c   11       TB-WH, JCTC, 0.04 eV Upen
c   12       TB-EWH, PRB 0.07 eV Upen
c   13       TB-OWH, PRB 0.07 eV Upen
c   14       TB-S, PRB 0.07 eV Upen
c   15       TB-SIP, JCTC 0.00 eV Upen
c   16       TB-SR, JCTC 0.00 eV Upen
c   17       TB-SOD, JCTC 0.00 eV Upen
c   18       NOTB-SIP, JCTC 0.00 eV Upen
c   19       NOTB-SR, JCTC 0.00 eV Upen
c   20       NOTB-SOD, JCTC 0.00 eV Upen
c   21       TB-CN, PRB 0.07 eV Upen
c   22       TB-BA, PRB 0.07 eV Upen
c   23       NOTB-WH, JCTC 0.00 eV Upen
c   24       NOTB-WH, JCTC 0.20 eV Upen
c   25       TB-WH for TM+CH, Liu, 0.64 eV Upen

c    1       TBCI-S, DELTA=0.10 eV
      data parKsss(1,3,3) / 0.52569d-1/
      data parKsps(1,3,3) / 0.37467d0 /
      data parKpps(1,3,3) / 0.18041d1 /
      data parKppp(1,3,3) / 0.12179d1 /
      data parZsss(1,3,3) / 1.3724d0 /
      data parZsps(1,3,3) / 1.3638d0 /
      data parZpps(1,3,3) / 1.3552d0/
      data parZppp(1,3,3) / 1.3552d0 /
      data parA(1,3,3)    / 21.058d0 /
      data parB(1,3,3)    / 1.4077d0 /
      data paru(1,3,3)    / 0.0d0 /
      data parAlpha(1,3)  / 7.1440d0 /
      data pard(1,3,3)    / 1.0d0 /
      data pardelta(1)    / 0.18375d-2/
      data parvsip(1,3,1) / -0.25030d0/
      data parvsip(1,3,2) / -0.76328d-1/
      data parTzero(1)    / -0.58619d0 /

c  c    5       TBCI-SPD
      data parKsss(5,3,3) / 0.33858d-1/
      data parKsps(5,3,3) / 0.19876d-1/
      data parKpps(5,3,3) / 0.16238d1 /
      data parKppp(5,3,3) / 0.19347d1 /
      data parZsss(5,3,3) / 1.3724d0 /
      data parZsps(5,3,3) / 1.3638d0 /
      data parZpps(5,3,3) / 1.3552d0/
      data parZppp(5,3,3) / 1.3552d0 /
      data parA(5,3,3)    / 29.254d0 /
      data parB(5,3,3)    / 1.4931d0 /
      data paru(5,3,3)    / 0.0d0 /
      data parAlpha(5,3)  / 7.1440d0 /
      data pard(5,3,3)    / 1.0d0 /
      data pardelta(5)    / 0.18375d-2 /
      data parvsip(5,3,1) / -0.25030d0 /
      data parvsip(5,3,2) / -0.76328d-1 /
      data parTzero(5)    / -0.58249d0 /
c  c    8       TBCI+U
      data parKsss(8,3,3) / 0.45132d-1/
      data parKsps(8,3,3) / 0.54078d0 /
      data parKpps(8,3,3) / 0.14896d1 /
      data parKppp(8,3,3) / 0.15931d1 /
      data parZsss(8,3,3) / 1.3724d0 /
      data parZsps(8,3,3) / 1.3638d0 /
      data parZpps(8,3,3) / 1.3552d0/
      data parZppp(8,3,3) / 1.3552d0 /
      data parA(8,3,3)    / 20.732d0 /
      data parB(8,3,3)    / 1.3618d0 /
      data paru(8,3,3)    / 0.0d0 /
      data parAlpha(8,3)  / 7.1440d0 /
      data pard(8,3,3)    / 1.0d0 /
      data pardelta(8)    / 0.18375d-2 /
      data parvsip(8,3,1) / -0.25030d0 /
      data parvsip(8,3,2) / -0.76328d-1 /
      data parTzero(8)    / -0.58249d0 /
c    9       TB-WH
        data parKsss(9,3,3) / 0.39280d0 /
        data parKsps(9,3,3) / 0.39280d0 /
        data parKpps(9,3,3) / 0.39280d0 /
        data parKppp(9,3,3) / 0.39280d0 /
        data parZsss(9,3,3) / 1.3724d0 /
        data parZsps(9,3,3) / 1.3638d0 /
        data parZpps(9,3,3) / 1.35520d0 /
        data parZppp(9,3,3) / 1.35520d0 /
        data parA(9,3,3)    / 42.747d0 /
        data parB(9,3,3)    / 1.5459d0 /
        data paru(9,3,3)    / 0.029360d0 /
	data parUpen(9) / 0.0025724307d0 /
c    10      TB-WH from JCTC 0.00 eV penalty energy
        data parKsss(10,3,3) / 0.4051204299372249d0 /
        data parKsps(10,3,3) / 0.4051204299372249d0 /
        data parKpps(10,3,3) / 0.4051204299372249d0 /
        data parKppp(10,3,3) / 0.4051204299372249d0 /
        data parZsss(10,3,3) / 1.3724d0 /
        data parZsps(10,3,3) / 1.3638d0 /
        data parZpps(10,3,3) / 1.35520d0 /
        data parZppp(10,3,3) / 1.35520d0 /
        data parA(10,3,3)    / 906.691667408825310d0 /
        data parB(10,3,3)    / 2.70850450709996204d0 /
        data paru(10,3,3)    / 0.212088805931172603d0 /
	data parUpen(10)      / 0.00d0 /
c    11      TB-WH from JCTC 0.?? eV penalty energy
        data parKsss(11,3,3) / 0.409579083732282745d0 /
        data parKsps(11,3,3) / 0.409579083732282745d0 /
        data parKpps(11,3,3) / 0.409579083732282745d0 /
        data parKppp(11,3,3) / 0.409579083732282745d0 /
        data parZsss(11,3,3) / 1.3724d0 /
        data parZsps(11,3,3) / 1.3638d0 /
        data parZpps(11,3,3) / 1.35520d0 /
        data parZppp(11,3,3) / 1.35520d0 /
        data parA(11,3,3)    / 877.678372436119162d0 /
        data parB(11,3,3)    / 2.76282579465115008d0 /
        data paru(11,3,3)    / 0.00320907269706668203d0 /
	data parUpen(11) / 0.00155498940223d0 /
c    12       TB-EWH
        data parKsss(12,3,3) / 0.14604d0 /
        data parKsps(12,3,3) / 0.15809d0 /
        data parKpps(12,3,3) / 0.070843d0 /
        data parKppp(12,3,3) / 0.021941d0 /
        data parZsss(12,3,3) / 1.3724d0 /
        data parZsps(12,3,3) / 1.3638d0 /
        data parZpps(12,3,3) / 1.3552d0 /
        data parZppp(12,3,3) / 1.3552d0 /
        data parA(12,3,3)    / 25.117d0 /
        data parB(12,3,3)    / 1.3838d0 /
        data paru(12,3,3)    / 0.065780d0 /
	data parUpen(12) / 0.0025724307d0 /
c    13       TB-OWH
        data parKsss(13,3,3) / 0.15308d0 /
        data parKsps(13,3,3) / 0.095139d0 /
        data parKpps(13,3,3) / 0.094412d0 /
        data parKppp(13,3,3) / 1.30530d0 /
        data parZsss(13,3,3) / 1.0038d0 /
        data parZsps(13,3,3) / 0.96784d0 /
        data parZpps(13,3,3) / 2.0513d0 /
        data parZppp(13,3,3) / 3.3225d0 /
        data parA(13,3,3)    / 119.87d0 /
        data parB(13,3,3)    / 1.8773d0 /
        data paru(13,3,3)    / 0.095543d0 /
	data parUpen(13) / 0.0025724307d0 /
c    14       MBTB-S
        data parKsss(14,3,3) / 0.3577d0 /
        data parKsps(14,3,3) / 0.2806d0 /
        data parKpps(14,3,3) / 0.2926d0 /
        data parKppp(14,3,3) / 0.1990d0 /
        data parZsss(14,3,3) / 0.88700d0 /
        data parZsps(14,3,3) / 0.94438d0 /
        data parZpps(14,3,3) / 1.3601d0/
        data parZppp(14,3,3) / 1.3657d0 /
        data parA(14,3,3)    / 209.32d0 /
        data parB(14,3,3)    / 2.0615d0 /
        data paru(14,3,3)    / 0.38349d0 /
	data parBeta(14,3,3,1,1) / 0.037227d0 /
	data parBeta(14,3,3,2,1) / 0.92029d0 /
	data parBeta(14,3,3,3,1) / 0.74127d0 /
	data parBeta(14,3,3,1,2) / 2.3998d0 /
	data parBeta(14,3,3,2,2) / 0.99128d0 /
	data parBeta(14,3,3,3,2) / 2.2524d0 /
	data parBeta(14,3,3,1,3) / 0.0d0 /
	data parBeta(14,3,3,2,3) / 0.0d0 /
	data parBeta(14,3,3,3,3) / 0.0d0 /
	data parBeta(14,3,3,1,4) / 0.0d0 /
	data parBeta(14,3,3,2,4) / 0.0d0 /
	data parBeta(14,3,3,3,4) / 0.0d0 /
	data parBeta(14,3,3,1,5) / 0.0d0 /
	data parBeta(14,3,3,2,5) / 0.0d0 /
	data parBeta(14,3,3,3,5) / 0.0d0 /
	data parBeta(14,3,3,1,6) / 0.0d0 /
	data parBeta(14,3,3,2,6) / 0.0d0 /
	data parBeta(14,3,3,3,6) / 0.0d0 /
	data parBeta(14,3,3,1,7) / 0.61485d0 /
	data parBeta(14,3,3,2,7) / 1.1767d0 /
	data parBeta(14,3,3,3,7) / 1.3692d0 /
	data parDDeltasp(3,3,14,6) / 0.22855d0 /
	data parDDeltasp(3,3,14,7) / 0.082999d0 /
	data pardeltasp(3,3,14,6) / 1.7966d0 /
	data pardeltasp(3,3,14,7) / 0.60177d0 /
	data parUpen(14) / 0.0025724307d0 /
c    21       MBTB-CN
        data parKsss(21,3,3) / 0.5781d0 /
        data parKsps(21,3,3) / 0.1880d0 /
        data parKpps(21,3,3) / 0.3371d0 /
        data parKppp(21,3,3) / 0.1252d0 /
        data parZsss(21,3,3) / 0.86924d0 /
        data parZsps(21,3,3) / 0.93174d0 /
        data parZpps(21,3,3) / 1.3420d0/
        data parZppp(21,3,3) / 1.1172d0 /
        data parA(21,3,3)    / 119.60d0 /
        data parB(21,3,3)    / 1.8539d0 /
        data paru(21,3,3)    / 0.41247d0 /
	data pargee(3,3,0)   / 0.0002d0 /
	data pargee(3,3,1)   / 1.6917d0 /
	data pargee(3,3,2)   / 15.108d0/
	data parFcn(3,3,1,1) / 0.12900d0 /
	data parFcn(3,3,2,1) / 4.1719d0 /
	data parFcn(3,3,1,2) / 0.020609d0 /
	data parFcn(3,3,2,2) / 3.1250d0 /
	data parFcn(3,3,1,3) / 0.096560d0 /
	data parFcn(3,3,2,3) / 4.2367d0 /
	data parFcn(3,3,1,4) / 0.17679d0 /
	data parFcn(3,3,2,4) / 4.1112d0 /
	data parFcn(3,3,1,5) / 0.13771d0 /
	data parFcn(3,3,2,5) / 2.1194d0 /
	data parFcn(3,3,1,6) / 0.90019d0 /
	data parFcn(3,3,2,6) / 2.6656d0 /
	data parFcn(3,3,1,7) / 0.89967d0 /
	data parFcn(3,3,2,7) / 1.8384d0 /
	data parDDeltasp(3,3,21,6) / 0.11087d0 /
	data parDDeltasp(3,3,21,7) / 0.082532d0 /
	data pardeltasp(3,3,21,6) / 1.9931d0 /
	data pardeltasp(3,3,21,7) / 0.61645d0 /
	data parUpen(21) / 0.0025724307d0 /
c    22       MBTB-BA
        data parKsss(22,3,3) / 0.2489d0 /
        data parKsps(22,3,3) / 0.3432d0 /
        data parKpps(22,3,3) / 0.2598d0 /
        data parKppp(22,3,3) / 0.1819d0 /
        data parZsss(22,3,3) / 0.75305d0 /
        data parZsps(22,3,3) / 1.1378d0 /
        data parZpps(22,3,3) / 1.2311d0/
        data parZppp(22,3,3) / 1.3154d0 /
        data parA(22,3,3)    / 179.44d0 /
        data parB(22,3,3)    / 2.0578d0 /
        data paru(22,3,3)    / 0.22539d0 /
	data parKappa(3,3,1,1)/ 2.8270d0 /
	data parKappa(3,3,2,1)/ 1.0484d0 /
	data parKappa(3,3,3,1)/ 1.9357d0 /
	data parKappa(3,3,4,1)/ 3.64677d0 /
	data parKappa(3,3,1,2)/ 0.18839d0 /
	data parKappa(3,3,2,2)/ 1.5270d0 /
	data parKappa(3,3,3,2)/ 1.6355d0 /
	data parKappa(3,3,4,2)/ 2.4757d0 /
	data parKappa(3,3,1,3)/ 0.0d0 /
	data parKappa(3,3,2,3)/ 0.0d0 /
	data parKappa(3,3,3,3)/ 0.0d0 /
	data parKappa(3,3,4,3)/ 0.0d0 /
	data parKappa(3,3,1,4)/ 0.0d0 /
	data parKappa(3,3,2,4)/ 0.0d0 /
	data parKappa(3,3,3,4)/ 0.0d0 /
	data parKappa(3,3,4,4)/ 0.0d0 /
	data parKappa(3,3,1,5)/ 0.0d0 /
	data parKappa(3,3,2,5)/ 0.0d0 /
	data parKappa(3,3,3,5)/ 0.0d0 /
	data parKappa(3,3,4,5)/ 0.0d0 /
	data parKappa(3,3,1,6)/ 0.95855d0 /
	data parKappa(3,3,2,6)/ 1.8893d0 /
	data parKappa(3,3,3,6)/ 1.8120d0 /
	data parKappa(3,3,4,6)/ 1.5924d0 /
	data parKappa(3,3,1,7)/ 0.0d0 /
	data parKappa(3,3,2,7)/ 0.0d0 /
	data parKappa(3,3,3,7)/ 0.0d0 /
	data parKappa(3,3,4,7)/ 0.0d0 /
	data parDDeltasp(3,3,22,6) / 0.16685d0 /
	data parDDeltasp(3,3,22,7) / 0.14256d0 /
	data pardeltasp(3,3,22,6) / 1.2383d0 /
	data pardeltasp(3,3,22,7) / 0.72432d0 /
	data parUpen(22) / 0.0025724307d0 /
c   23       NOTB-WH, JCTC 0.00 eV Upen
        data parKsss(23,3,3) / 0.3849d0 /
        data parKsps(23,3,3) / 0.3849d0 /
        data parKpps(23,3,3) / 0.3849d0 /
        data parKppp(23,3,3) / 0.3849d0 /
        data parZsss(23,3,3) / 1.3724d0 /
        data parZsps(23,3,3) / 1.3638d0 /
        data parZpps(23,3,3) / 1.3552d0 /
        data parZppp(23,3,3) / 1.3552d0 /
        data parA(23,3,3)    / 58.2071d0 /
        data parB(23,3,3)    / 1.4026d0 /
c        data parA(23,3,3)    / 1020.d0 /
c        data parB(23,3,3)    / 2.648d0 /
        data paru(23,3,3)    / 0.6915d0 /
	data parUpen(23) / 0.00d0 /
c    25       Tiqing Liu's TB for TM-C-H
        data parA(25,1,4) /11.1913661999d0/
        data parA(25,1,5) /19.6820626007d0/
        data parA(25,1,6) /20.8515264444d0/
        data parA(25,1,7) /39.6373936232d0/
        data parA(25,1,8) /17.7407109527d0/
        data parA(25,1,9) /35.7221203426d0/
	data parB(25,1,4) /1.75819046878d0/
	data parB(25,1,5) /1.93440639838d0/
	data parB(25,1,6) /1.90344954598d0/
	data parB(25,1,7) /2.41130067994d0/
	data parB(25,1,8) /1.75152283901d0/
	data parB(25,1,9) /2.29144209719d0/
	data paru(25,1,4) /0.14060231981d0/
	data paru(25,1,5) /0.05992929137d0/
	data paru(25,1,6) /0.09589744974d0/
	data paru(25,1,7) /0.54343828500d0/
	data paru(25,1,8) /0.15912880538d0/
	data paru(25,1,9) /0.26961566406d0/
        data parA(25,2,4) /128.202821096d0/
        data parA(25,2,5) /261.141137411d0/
        data parA(25,2,6) /200.329017538d0/
        data parA(25,2,7) /148.962887689d0/
        data parA(25,2,8) /189.289945531d0/
        data parA(25,2,9) /237.080321619d0/
	data parB(25,2,4) /2.32726737777d0/
	data parB(25,2,5) /2.87517720814d0/
	data parB(25,2,6) /2.22667083658d0/
	data parB(25,2,7) /2.28366319579d0/
	data parB(25,2,8) /2.40743768809d0/
	data parB(25,2,9) /2.40569140410d0/
	data paru(25,2,4) /0.15221246244d0/
	data paru(25,2,5) /0.63746774005d0/
	data paru(25,2,6) /0.10911099857d0/
	data paru(25,2,7) /0.38808251139d0/
	data paru(25,2,8) /0.57123065924d0/
	data paru(25,2,9) /0.42038d0/
c        data parA(25,4,4) /168.803d0/
c        data parA(25,5,5) /144.105d0/
c        data parA(25,6,6) /385.427d0/
c        data parA(25,7,7) /405.731d0/
c        data parA(25,8,8) /364.888d0/
c        data parA(25,9,9) /352.577d0/
        data parA(25,4,4) /318.991402597d0/
        data parA(25,5,5) /272.318406155d0/
        data parA(25,6,6) /728.352359816d0/
        data parA(25,7,7) /766.721051838d0/
        data parA(25,8,8) /689.539215976d0/
        data parA(25,9,9) /666.274941176d0/
	data parB(25,4,4) /2.32774363704d0/
	data parB(25,5,5) /2.22942255680d0/
	data parB(25,6,6) /2.08580392829d0/
	data parB(25,7,7) /2.04336393564d0/
	data parB(25,8,8) /2.05685794826d0/
	data parB(25,9,9) /1.94678913938d0/
	data paru(25,4,4) /0.50010927504d0/
	data paru(25,5,5) /0.59844093882d0/
	data paru(25,6,6) /0.26500653269d0/
	data paru(25,7,7) /0.21765577779d0/
	data paru(25,8,8) /0.52072071786d0/
	data paru(25,9,9) /0.33956227540d0/
	data parUpen(25) / 0.02351936640d0/
      end module params

      integer function met2icase(met)
      
      implicit none
      integer ic,met

      select case(met)
      case(11)
        ic=1
      case(12)
        ic=2
      case(13)
        ic=3
      case(21)
        ic=5
      case(22)
        ic=6
      case(23)
        ic=7
      case(31)
        ic=8
      case(41)
        ic=9
      case(42)
        ic=10
      case(43)
        ic=11
      case(44)
        ic=12
      case(45)
        ic=13
      case(46)
        ic=25
      case(51)
        ic=14
      case(52)
        ic=15
      case(53)
        ic=16
      case(54)
        ic=17
      case(55)
        ic=21
      case(56)
        ic=22
      case(61)
        ic=23
      case(62)
        ic=24
      case(63)
        ic=18
      case(64)
        ic=19
      case(65)
        ic=10
      case default
         Stop 'Undefined value for directive METHOD'
      end select

      met2icase=ic

      end function met2icase

      subroutine checkvalid(method,stoich)
      use basics
      use params
      use printing
      implicit none
      integer method,stoich(maxid)
      integer tmid,i

      select case(icase)
      case(25)
        if(stoich(3).ne.0)then
         write(funit,*)'ERROR: Method 46 does not allow for',
     *      ' Aluminum atoms.'
          write(funit,*)'Please choose an approprite method. Stopping.'
          stop 'ERROR: Method 46 does not allow for Aluminum atoms.'
        endif 
	do i=4,maxid
	  if(stoich(i).ne.0)then
	    if(tmid.eq.0)then
	      tmid=i
	    else
	      write(funit,*)'ERROR: Method 46 only allows for one (1) ',
     *         'type of transition metal atom.'
           write(funit,*)'Please choose an approprite method. Stopping.'
	      stop 'ERROR: Method 46 only allows for one (1) type of TM.'
	    endif
	  endif
	enddo
      case(1:24)
        do 1 i=1,maxid
	  if(i.eq.3)goto 1
	  if(stoich(i).ne.0)then
            write(funit,*)'ERROR: Method ',method,' only allows for',
     *      ' Aluminum atoms.'
             write(funit,*)'Please choose an approprite method.',
     *      ' Stopping.'
             stop 'ERROR: Method chosen only allows for Aluminum atoms.'
	  endif
 1      continue
      case default
        stop 'Invalid case in subroutine checkvalid?'
      end select
      
      end subroutine checkvalid

      subroutine surf(natom,ndim,nElect,Tzero,x,y,z,idtype,
     &   dEdx,dEdy,dEdz,VV)
      use basics
      use grad
      use params
      use printing
      implicit real*8 (a-h,o-z)
c      character v,u
      logical lflag
      dimension idtype(natom)
      dimension x(natom),y(natom),z(natom)
      dimension hamil(subsiz,subsiz),hamilt(ndim,ndim)
      dimension ap(ndim*(ndim+1)/2),work(3*ndim)
      double precision op(ndimS*(ndimS+1)/2)
      dimension evec(ndim,ndim),eva(ndim)
c      dimension nocc(ndim),nocci(ndim)
      dimension nocc(ndim),vsip(maxid,2)
      dimension dhamlt(ndimdH,ndimdH,3),dhamil(subsiz,subsiz,3)
      double precision dhamilmb(subsiz,subsiz,natom,3)
      dimension dhamltmb(ndimdH,ndimdH,natom,3)
      double precision dVl(ndimat,3)
      dimension dEdx(natom),dEdy(natom),dEdz(natom)
      dimension drepul(3),drepulmb(natom,3),r(natom,natom)
      double precision Fmb,dFmb(natom,3)
      double precision Sij(ndimS,ndimS),dSij(ndimdS1,ndimdS1,3)
      double precision Sij2(subsiz,subsiz),dSij2(subsiz,subsiz,3)
      double precision dSij2mb(subsiz,subsiz,ndimdS2,3)
      double precision dSijmb(ndimdS1,ndimdS1,ndimdS2,3)
      double precision Fcng(natom),dFcng(natom,natom,3)
      integer ndim2
      double precision dt(natom,3)
      double precision el,em,en,elladmm,ellmimm,enn,tmp,t1,t2
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      common /vsips/ vsip
      double precision Ecomp(3)
      common/ecomps/Ecomp,ndim2
c      parameter(ionpar=0)
ccFs      common /rcrc/ rc
ccFs      integer jci,ici
ccFs      common /cmat/ jci,ici
ccFs      double precision Fs,dFs(natom,3)

c      unite1=0.03674901d0
      ndim2=ndim

      call alldist(natom,x,y,z,r)

c Do model specific start-up stuff
      select case(icase)
      case(21)
       call Fcnsetup(natom,x,y,z,r,Fcng,dFcng)
      case default
         continue
      end select

c      call doFcn(1,3,natom,x,y,z,r,idtype,2,Fmb,dFmb,Fcng,dFcng)
c      VV=Fmb
c      if(dograd)then
c        do n=1,natom
c	  dEdx(n)=dFmb(n,1)
c	  dEdy(n)=dFmb(n,2)
c	  dEdz(n)=dFmb(n,3)
c	enddo
c      endif
c      return

      dhamlt=0.0d0
      dhamltmb=0.0d0
      dSij=0.0d0
      dSijmb=0.0d0

      nrdim=0
      do 30 i=1,natom
        ip=idtype(i)
        ncdim=0
        do 31 j=1,natom
          jp=idtype(j)
          if (j.eq.i) then
            do 32 ii=1,norbit(ip)
              do 33 jj=1,norbit(jp)
                if (ii.eq.jj) then
                  if (ii .eq. 1) then
		    select case(icase)
		    case(14:22)
c i.e. all MBTB and MB-NOTB methods
		       Vl=0.0d0
		       dVl=0.0d0
		       CDD=parDDeltasp(ip,ip,icase,6)
		       DD=pardeltasp(ip,ip,icase,6)
		       do 700 k=1,natom
		           if(i.eq.k)goto 700
			   tmp=CDD*dexp(-DD*r(i,k))
		           call doFMB(i,k,natom,x,y,z,r,idtype,6,Fmb,
     *                           dFmb,Fcng,dFcng)
			   Vl=Vl+tmp*Fmb
			   if(dograd)then
			     dtmp=-DD*tmp
			     call lmndlm(i,k,natom,x,y,z,r)
			     dVl(i,1)=dVl(i,1)+dtmp*el*Fmb
			     dVl(i,2)=dVl(i,2)+dtmp*em*Fmb
			     dVl(i,3)=dVl(i,3)+dtmp*en*Fmb
			     dVl(k,1)=dVl(k,1)-dtmp*el*Fmb
			     dVl(k,2)=dVl(k,2)-dtmp*em*Fmb
			     dVl(k,3)=dVl(k,3)-dtmp*en*Fmb
			   endif
			   if(flag(2))then
			     do 701 n=1,natom
			     do 701 m=1,3
			        dVl(n,m)=dVl(n,m)+tmp*dFmb(n,m)
 701                       continue
			   endif
c			   VV=Vl
c			   if(dograd)then
c			     do n=1,natom
c			       dEdx(n)=dVl(n,1)
c			       dEdy(n)=dVl(n,2)
c			       dEdz(n)=dVl(n,3)
c			     enddo
c			   endif
c			   return
 700                   continue
		       hamilt(nrdim+ii,ncdim+jj)=vsip(ip,1)+Vl
		       if(dograd)then
		         do 203 n=1,natom
			 do 203 m=1,3
			    dhamltmb(nrdim+ii,ncdim+jj,n,m)=dVl(n,m)
 203                     continue
		       endif 
		       if(doS)then
			   Sij(nrdim+ii,ncdim+jj)=1.0d0
c assuming orthonormality
		           if(dograd)then
			     do n=1,natom
		              dSijmb(nrdim+ii,ncdim+jj,n,1)=0.0d0
		              dSijmb(nrdim+ii,ncdim+jj,n,2)=0.0d0
		              dSijmb(nrdim+ii,ncdim+jj,n,3)=0.0d0
			     enddo
		           endif
		       endif
c      VV=hamilt(1,1)
c      if(dograd)then
c        do n=1,natom
c	  dEdx(n)=dhamltmb(1,1,n,1)
c	  dEdy(n)=dhamltmb(1,1,n,2)
c	  dEdz(n)=dhamltmb(1,1,n,3)
c	enddo
c      endif
c      return
		    case default
c i.e. all TB and TBCI methods
                       hamilt(nrdim+ii,ncdim+jj)=vsip(ip,1)
		       if(doS)then
c assuming orthonormality
		         Sij(nrdim+ii,ncdim+jj)=1.0d0
		         if(dograd)then
		           dSij(nrdim+ii,ncdim+jj,1)=0.0d0
		           dSij(nrdim+ii,ncdim+jj,2)=0.0d0
		           dSij(nrdim+ii,ncdim+jj,3)=0.0d0
		         endif
		       endif
		    end select
                  else !if(ii.eq.1)
		    select case(icase)
		    case(14:22)
c i.e. all MBTB and MB-NOTB methods
		       Vl=0.0d0
		       dVl=0.0d0
		       CDD=parDDeltasp(ip,ip,icase,7)
		       DD=pardeltasp(ip,ip,icase,7)
		       do 702 k=1,natom
		           if(i.eq.k)goto 702
			   tmp=CDD*dexp(-DD*r(i,k))
		           call doFMB(i,k,natom,x,y,z,r,idtype,7,Fmb,
     *                          dFmb,Fcng,dFcng)
c			   write(2,*)'debug Fmb(i,k)',i,k,Fmb
			   Vl=Vl+tmp*Fmb
			   if(dograd)then
			     dtmp=-DD*tmp
			     call lmndlm(i,k,natom,x,y,z,r)
			     dVl(i,1)=dVl(i,1)+dtmp*el*Fmb
			     dVl(i,2)=dVl(i,2)+dtmp*em*Fmb
			     dVl(i,3)=dVl(i,3)+dtmp*en*Fmb
			     dVl(k,1)=dVl(k,1)-dtmp*el*Fmb
			     dVl(k,2)=dVl(k,2)-dtmp*em*Fmb
			     dVl(k,3)=dVl(k,3)-dtmp*en*Fmb
			   endif
			   if(flag(2))then
			     do 703 n=1,natom
			     do 703 m=1,3
			        dVl(n,m)=dVl(n,m)+tmp*dFmb(n,m)
 703                       continue
			   endif
 702                   continue
		       hamilt(nrdim+ii,ncdim+jj)=vsip(ip,2)+Vl
		       if(doS)then
			   Sij(nrdim+ii,ncdim+jj)=1.0d0
c assuming orthonormality
		           if(dograd)then
			     do n=1,natom
		              dSijmb(nrdim+ii,ncdim+jj,n,1)=0.0d0
		              dSijmb(nrdim+ii,ncdim+jj,n,2)=0.0d0
		              dSijmb(nrdim+ii,ncdim+jj,n,3)=0.0d0
			     enddo
		           endif
		       endif
		       if(dograd)then
		         do 704 n=1,natom
			 do 704 m=1,3
			    dhamltmb(nrdim+ii,ncdim+jj,n,m)=dVl(n,m)
 704                     continue
		       endif 
		    case default
c i.e. all TB and TBCI methods
                       hamilt(nrdim+ii,ncdim+jj)=vsip(ip,2)
		       if(doS)then
c assuming orthonormality
		         Sij(nrdim+ii,ncdim+jj)=1.0d0
		         if(dograd)then
		           dSijmb(nrdim+ii,ncdim+jj,i,1)=0.0d0
		           dSijmb(nrdim+ii,ncdim+jj,i,2)=0.0d0
		           dSijmb(nrdim+ii,ncdim+jj,i,3)=0.0d0
		         endif
		       endif
		    end select
                  endif !if(ii.eq.1)
                else !if(ii.eq.jj)
                  hamilt(nrdim+ii,ncdim+jj)=0.0
c assuming orthonormality
c remember that dhamilt and dSij (incl. MB version) were initially zeroed
		  if(doS)Sij(nrdim+ii,ncdim+jj)=0.0d0
                endif !if(ii.eq.jj)
 33           continue
 32         continue
            goto 39
          else
            call lmndlm(i,j,natom,x,y,z,r)
  	    select case(icase)
	    case(14:22)
c i.e. all MBTB and MB-NOTB methods
              call genrhd_mb(i,j,natom,x,y,z,r,idtype,hamil,dhamilmb,
     &              Sij2,dSij2mb,Fcng,dFcng)
              do 34 ii=1,norbit(ip)
              do 34 jj=1,norbit(jp)
                hamilt(nrdim+ii,ncdim+jj)=hamil(ii,jj)
		if(doS)Sij(nrdim+ii,ncdim+jj)=Sij2(ii,jj)
		if(dograd)then
		do 204 n=1,natom
		do 204 iii=1,3
		   dhamltmb(nrdim+ii,ncdim+jj,n,iii)=dhamilmb(ii,jj,n,iii)
		   if(doS)dSijmb(nrdim+ii,ncdim+jj,n,iii)=dSij2mb(ii,jj,n,iii)
 204            continue
		endif
 34         continue
	    case default
c i.e. all TB and TBCI methods
	      call genrhd(ip,jp,r(i,j),hamil,dhamil,Sij2,dSij2)
              do 35 ii=1,norbit(ip)
              do 35 jj=1,norbit(jp)
                  hamilt(nrdim+ii,ncdim+jj)=hamil(ii,jj)
		  if(doS)Sij(nrdim+ii,ncdim+jj)=Sij2(ii,jj)
		  if(dograd)then
		  do iii=1,3
		     dhamlt(nrdim+ii,ncdim+jj,iii)=dhamil(ii,jj,iii)
		     if(doS)dSij(nrdim+ii,ncdim+jj,iii)=dSij2(ii,jj,iii)
		  enddo
		  endif
 35           continue
	    end select
          endif
 39       ncdim=ncdim+norbit(jp)
 31     continue
        nrdim=nrdim+norbit(ip)
 30   continue

c      VV=hamilt(4,1)
c      if(dograd)then
c        do n=1,natom
c	  dEdx(n)=dhamltmb(4,1,n,1)
c	  dEdy(n)=dhamltmb(4,1,n,2)
c	  dEdz(n)=dhamltmb(4,1,n,3)
c	enddo
c      endif
c      return
      

c      if(icase.le.8)then
c           do i=1,ndim
c           hamilt(i,i)=hamilt(i,i)*(1d0+i*10d-07/(.75*natom))
c           enddo
c      endif
c
c If required print Hamiltonian and Overlap matrices
       if(printlev.ge.4)call printHS(natom,ndim,hamilt,Sij)
c Set up the uppermatrix to do eigenvalue calculations.
c
      do 40 i =1,ndim 
        do 41 j=i,ndim
          ap(i+(j-1)*j/2)=hamilt(i,j)
          if(doS)op(i+(j-1)*j/2)=Sij(i,j)
 41     continue 
 40   continue

      work=0.0d0

      if(doS)then
         call dspgv(1,'v','u',ndim,ap,op,eva,evec,ndim,work,info)
      else
         call dspev( 'v','u',ndim,ap,eva,evec,ndim,work,info) 
      endif

c
c         write(66,*)'Geometry in main file'
c         do ii=1,natom
c	    write(66,667)x(ii),y(ii),z(ii)
c	 enddo
c         write(66,*)'dograd = ',dograd
c 667  format(' Al ',3(1x,F18.10))

      if(dograd)then
        dEdx=0.0d0
        dEdy=0.0d0
        dEdz=0.0d0
      endif
      
c        select case(icase)
c        case(1:14)
c         call filloc(natom,ndim,ndimdH,nElect,eva,etb,evec,
         call filloc(natom,ndim,nElect,eva,etb,evec,nocc,dhamlt,dSij,
     & dhamltmb,dSijmb,dEdx,dEdy,dEdz,x,y,z,r,idtype)
c        case(9:14)
c           call filloc_TB(natom,ndim,ndimdH,nElect,eva,etb,evec,
c       &    nocc,dhamlt,dEdx,dEdy,dEdz,x,y,z,r,idtype)
c        case default
c           write(*,*)'icase = ',icase,' not defined!'
c  	 Stop 'Stopping'
c        end select

c         VV=etb
c	 write(*,*)'debugging until after fillloc'
c	 return

c
c   calculate ionization energy
c
c      if(ionpar.eq.0) goto 402
c      nElecti=nElect-1
c      lflag=dograd
c      dograd=.false.
c      call filloc(natomg,ndim,ndimdH,nElecti,eva,etbi,evec,
c     &    nocci,dhamlt,dEdx,dEdy,dEdz,x,y,z,r,idtype)
c      dograd=lflag
c
c      poti=etbi-etb
c  402 continue
c
        eerep=0.0
        nrdim=0
c
      select case(icase)
      case(14:22)
c i.e. MBTB, MB-NOTB
        do 510 i=1,natom
          ip=idtype(i)
          do 520 j=1,natom
            jp=idtype(j)
            if(j.eq.i)goto 590
            call genrrp_mb(i,j,natom,x,y,z,r,idtype,repul,drepulmb,
     *              Fcng,dFcng)
c            eerep=eerep+repul/2.0
            eerep=eerep+repul

c            if((i.eq.1).and.(j.eq.2))then
c	    VV=repul
c	    if(dograd)then
c	    do n=1,natom
c	      dEdx(n)=drepulmb(n,1)
c	      dEdy(n)=drepulmb(n,2)
c	      dEdz(n)=drepulmb(n,3)
c	    enddo
c	    endif
c	    return
c	    endif

	    if(dograd)then
	      do n=1,natom
	       dEdx(n)=dEdx(n)+drepulmb(n,1)
	       dEdy(n)=dEdy(n)+drepulmb(n,2)
	       dEdz(n)=dEdz(n)+drepulmb(n,3)
	      enddo
	    endif
 590       continue
 520      continue
 510    continue
      case default
        do 51 i=1,natom
          ip=idtype(i)
          do 52 j=1,natom
            jp=idtype(j)
            if(j.eq.i)goto 59
            call lmndlm(i,j,natom,x,y,z,r)
            call genrrp(ip,jp,r(i,j),repul,drepul)            
            eerep=eerep+repul/2.0d0
	    if(dograd)then
	       dEdx(i)=dEdx(i)+drepul(1)
	       dEdy(i)=dEdy(i)+drepul(2)
	       dEdz(i)=dEdz(i)+drepul(3)
	    endif
 59        continue
 52       continue
 51     continue
      end select
      VV=etb+eerep-(Tzero)
      Ecomp(1)=etb
      Ecomp(2)=Tzero
      Ecomp(3)=eerep

c If needed, print out results (Energy, Energy breakdown, Energy gradients)
      if(printlev.ge.1)then
         write(funit,*)
	 write(funit,*)'******************'
	 write(funit,*)'Results from TBPAC'
	 write(funit,*)'******************'
	 write(funit,*)
	 write(funit,1000)'Total Energy = ',VV/unite,unitesym

	 if(printlev.ge.2)then
	    write(funit,*)
	    write(funit,*)'Breakdown of the Energy Composition'
	    write(funit,*)
	    select case(icase)
	    case(1:8)
	       write(funit,1000)'Eval+Eci = ',Ecomp(1)/unite,unitesym
	    case default
	       write(funit,1000)'Eval = ',Ecomp(1)/unite,unitesym
	    end select
	    write(funit,1000)'Erep = ',Ecomp(3)/unite,unitesym
	    write(funit,1000)'E(0) = ',Ecomp(2)/unite,unitesym
	 endif

	 if(dograd)then
	    write(funit,*)
            write(funit,*)'********************'
	    write(funit,*)'  Energy Gradients'
            write(funit,*)'********************'
	    write(funit,*)
	    i=index(unitesym,' ')
	    write(funit,*)'Gradients in units of ',unitesym(1:i-1),'/',
     *            unitdsym
	    write(funit,*)
	    write(funit,*)'============================================='
	    write(funit,*)'No. Symbol  dE/dx       dE/dy        dE/dz'
	    write(funit,*)'---------------------------------------------'
	    do i=1,natom
	       write(funit,22)i,id2symb(idtype(i)),dEdx(i)*unitd/unite,
     *            dEdy(i)*unitd/unite,dEdz(i)*unitd/unite
	    enddo
	    write(funit,*)'============================================='
	 endif
      endif

 12   format(A,' ',F6.4)
 6680 format(1X,F5.3,12(1X,F20.10))
 22   format(I4,2X,A2,3(2X,F10.5))


  105 format(6d14.6)

 95   format (T5,A,T10,3f10.5)
 97   format (T1,A,T13,A,T39,A)
 98   format (T1,I3,T9,f12.4,T30,A)
 99   format(T1,A8,8(f9.4))
 100  format(T1,A3,I3,8(f9.4))
 101  format(T3,A,T10,5(f10.5))
 102  format(T1,A,T26,f8.5,T34,A,T46,f10.3,T57,A,T61,f10.3,T71,A)
 103  format(T1,A8,8(I9))
 1000 format(T1,A,F10.5,' ',A)
c
      end subroutine surf

      subroutine alldist(natom,x,y,z,r)
      use printing
      implicit real*8(a-h,o-z)
      dimension x(natom),y(natom),z(natom),r(natom,natom)
c
c   calculate distances between atoms, r
c
      do 1 i=1,natom-1
      r(i,i)=0.0d0
      do 1,j=i+1,natom
      dx=x(i)-x(j)
      dy=y(i)-y(j)
      dz=z(i)-z(j)
      r(i,j)=dsqrt(dx*dx+dy*dy+dz*dz)
      r(j,i)=r(i,j)
      if(r(i,j).lt.1d-8)then
	 write(funit,*)'*******************************************'
         write(funit,*)'* Error in input geometry!                *'
	 write(funit,*)'* Atoms ',i,' and ',j,' are superimposed!    *'
	 write(funit,*)'* Stop TBPAC run!                         *'
	 write(funit,*)'*******************************************'
	 stop 'Error - superimposed atoms.'
      endif
 1    continue
      r(natom,natom)=0.0d0
      end subroutine alldist

c
      subroutine h_h_hd (r,hamil,dhamil)
      use basics
      use grad
      use params
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision t,dt(3),r
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
c
      select case(icase)
      case(25)
c
c Hopping parameters for hydrogen-hydrogen
c
cMAI: need to convert to au for TBPAC
c      DATA r0 /0.7414d0/
c      DATA rt /4.176d0/
c      DATA sss0 /-4.842d0/
      DATA r0 /1.40104359780d0/
      DATA rt /7.89149995200d0/
      DATA sss0 /-0.17793870642d0/
cMAI the following appear to be unitless
      DATA sssna /2.049D0/
      DATA sssnb /1.762D0/
      DATA sssnc /5.609d0/
c
      call wangma(r,sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)

      case default
         call potssshh(r,sss,dsss)
      end select

c Project the two-center integral along the basis set.
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.

      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)
      end subroutine h_h_hd

c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine h_c_hd (r,hamil,dhamil)
      use basics
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision t,dt(3),r
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
      double precision sps0,   spsna,spsnb,   spsnc,sps,dsps
c
c Hopping parameters for hydrogen-carbon from Wang and Mak.
c
cMAI: converting to au for TBPAC
c      DATA r0 /1.09d0/
c      DATA rt /2.d0/
      DATA r0 /2.05980243000d0/
      DATA rt /3.77945400000d0/
c s s sigma
c      DATA sss0 /-6.921d0/
      DATA sss0 /-0.25433989821d0/
      DATA sssna /1.9000/
      DATA sssnb /1.9000/
      DATA sssnc /9.000/
c s p sigma
c      DATA sps0 /5.594d0/
      DATA sps0 /0.20557396194d0/
      DATA spsna /1.603d0/
      DATA spsnb /1.603d0/
      DATA spsnc /9.0/
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      call wangma(r,sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
      call wangma(r,sps0,r0,spsna,spsnb,rt,spsnc,sps,dsps)
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',sps,dsps,t,dt)       !s-px
      hamil(1,2)=t
      dhamil(1,2,1)=dt(1)
      dhamil(1,2,2)=dt(2)
      dhamil(1,2,3)=dt(3)

      call sxyz('y',sps,dsps,t,dt)       !s-py
      hamil(1,3)=t
      dhamil(1,3,1)=dt(1)
      dhamil(1,3,2)=dt(2)
      dhamil(1,3,3)=dt(3)

      call sxyz('z',sps,dsps,t,dt)       !s-pz
      hamil(1,4)=t
      dhamil(1,4,1)=dt(1)
      dhamil(1,4,2)=dt(2)
      dhamil(1,4,3)=dt(3)
 
      end subroutine h_c_hd

c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine c_h_hd (r,hamil,dhamil)
      use basics
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision r,t,dt(3)
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
      double precision pss0,   pssna,pssnb,   pssnc,pss,dpss
c
c Hopping parameters for carbon-hydrogen from Wang and Mak.
c
cMAI: converting to au for TBPAC
c      DATA r0 /1.09d0/
c      DATA rt /2.d0/
      DATA r0 /2.05980243000d0/
      DATA rt /3.77945400000d0/
c s s sigma
c      DATA sss0 /-6.921d0/
      DATA sss0 /-0.25433989821d0/
      DATA sssna /1.9000/
      DATA sssnb /1.9000/
      DATA sssnc /9.000/
c s p sigma
c      DATA pss0 /5.594d0/
      DATA pss0 /0.20557396194d0/
      DATA pssna /1.603d0/
      DATA pssnb /1.603d0/
      DATA pssnc /9.0/
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      call wangma(r,sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
      call wangma(r,pss0,r0,pssna,pssnb,rt,pssnc,pss,dpss)
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',pss,dpss,t,dt)       !px-s
      hamil(2,1)=t
      dhamil(2,1,1)=dt(1)
      dhamil(2,1,2)=dt(2)
      dhamil(2,1,3)=dt(3)

      call sxyz('y',pss,dpss,t,dt)       !py-s
      hamil(3,1)=t
      dhamil(3,1,1)=dt(1)
      dhamil(3,1,2)=dt(2)
      dhamil(3,1,3)=dt(3)

      call sxyz('z',pss,dpss,t,dt)       !pz-s
      hamil(4,1)=t
      dhamil(4,1,1)=dt(1)
      dhamil(4,1,2)=dt(2)
      dhamil(4,1,3)=dt(3)
 
      end subroutine c_h_hd

c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine c_c_hd (r,hamil,dhamil)
      use basics
      implicit none
      character*5 tc
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision r,t,dt(3)
      double precision sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss
      double precision sps0,   spsna,spsnb,   spsnc,sps,dsps
      double precision pss0,   pssna,pssnb,   pssnc,pss,dpss
      double precision pps0,   ppsna,ppsnb,   ppsnc,pps,dpps
      double precision ppp0,   pppna,pppnb,   pppnc,ppp,dppp
c
c Hopping parameters for carbon-hydrogen from Wang and Mak.
c
cMAI: converting to au for TBPAC
c      DATA r0 /1.312d0/
c      DATA rt /2.d0/
      DATA r0 /2.47932182400d0/
      DATA rt /3.77945400000d0/
c s s sigma
c      DATA sss0 /-7.948d0/
      DATA sss0 /-0.29208113148d0/
      DATA sssna /1.29827d0/
      DATA sssnb /1.d0/
      DATA sssnc /5.d0/
c s p sigma
c     DATA sps0 /7.413d0/
      DATA sps0 /0.27242041113d0/
      DATA spsna /0.99055d0/
      DATA spsnb /1.d0/
      DATA spsnc /5.d0/
c p s sigma
c      DATA pss0 /-7.413d0/
      DATA pss0 /0.27242041113d0/
      DATA pssna /0.99055d0/
      DATA pssnb /1.d0/
      DATA pssnc /5.d0/
c p p sigma
c      DATA pps0 /6.224d0/
      DATA pps0 /0.22872583824d0/
      DATA ppsna / 1.01545d0/
      DATA ppsnb /1.d0/
      DATA ppsnc /5.d0/
c p p pi
c      DATA ppp0 /-2.980d0/
      DATA ppp0 /-0.10951204980d0/
      DATA pppna / 1.8246d0/
      DATA pppnb /1.d0/
      DATA pppnc /5.d0/
c  
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      call wangma(r,sss0,r0,sssna,sssnb,rt,sssnc,sss,dsss)
      call wangma(r,sps0,r0,spsna,spsnb,rt,spsnc,sps,dsps)
      call wangma(r,pss0,r0,pssna,pssnb,rt,pssnc,pss,dpss)
      call wangma(r,pps0,r0,ppsna,ppsnb,rt,ppsnc,pps,dpps)
      call wangma(r,ppp0,r0,pppna,pppnb,rt,pppnc,ppp,dppp)
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',sps,dsps,t,dt)       !s-px
      hamil(1,2)=t
      dhamil(1,2,1)=dt(1)
      dhamil(1,2,2)=dt(2)
      dhamil(1,2,3)=dt(3)

      call sxyz('y',sps,dsps,t,dt)       !s-py
      hamil(1,3)=t
      dhamil(1,3,1)=dt(1)
      dhamil(1,3,2)=dt(2)
      dhamil(1,3,3)=dt(3)

      call sxyz('z',sps,dsps,t,dt)       !s-pz
      hamil(1,4)=t
      dhamil(1,4,1)=dt(1)
      dhamil(1,4,2)=dt(2)
      dhamil(1,4,3)=dt(3)

      call sxyz('x',pss,dpss,t,dt)       !px-s
      hamil(2,1)=t
      dhamil(2,1,1)=dt(1)
      dhamil(2,1,2)=dt(2)
      dhamil(2,1,3)=dt(3)

      call xx('x',pps,dpps,ppp,dppp,t,dt)   !px-px
      hamil(2,2)=t
      dhamil(2,2,1)=dt(1)
      dhamil(2,2,2)=dt(2)
      dhamil(2,2,3)=dt(3)

      call xy('xy',pps,dpps,ppp,dppp,t,dt)  !px-py
      hamil(2,3)=t
      dhamil(2,3,1)=dt(1)
      dhamil(2,3,2)=dt(2)
      dhamil(2,3,3)=dt(3)

      call xy('xz',pps,dpps,ppp,dppp,t,dt)  !px-pz
      hamil(2,4)=t
      dhamil(2,4,1)=dt(1)
      dhamil(2,4,2)=dt(2)
      dhamil(2,4,3)=dt(3)

      call sxyz('y',pss,dpss,t,dt)          !py-s
      hamil(3,1)=t
      dhamil(3,1,1)=dt(1)
      dhamil(3,1,2)=dt(2)
      dhamil(3,1,3)=dt(3)

      call xy('xy',pps,dpps,ppp,dppp,t,dt)  !py-px
      hamil(3,2)=t
      dhamil(3,2,1)=dt(1)
      dhamil(3,2,2)=dt(2)
      dhamil(3,2,3)=dt(3)

      call xx('y',pps,dpps,ppp,dppp,t,dt)   !py-py
      hamil(3,3)=t
      dhamil(3,3,1)=dt(1)
      dhamil(3,3,2)=dt(2)
      dhamil(3,3,3)=dt(3)

      call xy('yz',pps,dpps,ppp,dppp,t,dt)  !py-pz
      hamil(3,4)=t
      dhamil(3,4,1)=dt(1)
      dhamil(3,4,2)=dt(2)
      dhamil(3,4,3)=dt(3)

      call sxyz('z',pss,dpss,t,dt)          !pz-s
      hamil(4,1)=t
      dhamil(4,1,1)=dt(1)
      dhamil(4,1,2)=dt(2)
      dhamil(4,1,3)=dt(3)

      call xy('xz',pps,dpps,ppp,dppp,t,dt)  !pz-px
      hamil(4,2)=t
      dhamil(4,2,1)=dt(1)
      dhamil(4,2,2)=dt(2)
      dhamil(4,2,3)=dt(3)

      call xy('yz',pps,dpps,ppp,dppp,t,dt)  !pz-py
      hamil(4,3)=t
      dhamil(4,3,1)=dt(1)
      dhamil(4,3,2)=dt(2)
      dhamil(4,3,3)=dt(3)

      call xx('z',pps,dpps,ppp,dppp,t,dt)   !pz-pz
      hamil(4,4)=t
      dhamil(4,4,1)=dt(1)
      dhamil(4,4,2)=dt(2)
      dhamil(4,4,3)=dt(3)

      end subroutine c_c_hd

c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between H and Ni.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine h_tr_hd (ip,r,hamil,dhamil)
      use basics
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision r,t,dt(3),vsip(8,2)
      integer ip,jp,i,j
      integer sN(6),dN(6)
      double precision szetapm(6),szeta(6)
      double precision sss,dsss,sds,dsds
      double precision kss(6),ksd(6)
      double precision tmp1,tmp2,intgr,dintgr
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)

      common /vsips/ vsip
c
c Because the original dovlap and ovlapd subroutine already work in au
c rather than Ang, as with most of TB 1.0.1, there is no need to convert
c the zeta values.
c
c STO parameters for hydrogen element
c
      DATA (szetapm(i),i=1,6) /1.22576,1.26397,1.21011,1.23966,
     &                         1.25792,1.12836/
c
c STO parameters for transition elements
c
      DATA (sN(i),i=1,6) /4,4,5,5,6,6/
      DATA (dN(i),i=1,6) /3,3,4,4,5,5/
      DATA (szeta(i),i=1,6) /1.76329,1.81529,2.03423,1.74711,
     &                       2.36819,2.12506/
      DATA (szeta(i),i=1,6) /1.76329,1.81529,2.03423,1.74711,
     &                       2.36819,2.12506/
      DATA (coef1(i),i=1,6) /0.57107,0.61029,0.53160,0.56239,
     &                       0.64119,0.66519/
      DATA (coef2(i),i=1,6) /0.63227,0.59085,0.64359,0.55836,
     &                       0.55808,0.55304/
      DATA (dzeta1(i),i=1,6) /5.68829,5.56529,5.82723,4.83011,
     &                       5.82719,5.68606/
      DATA (dzeta2(i),i=1,6) /1.93829,1.91529,2.45723,2.42511,
     &                       2.51109,2.31706/
c
c Wolfberg-Holmholz constants
c
      DATA (kss(i),i=1,6) /0.75730 ,0.80843,0.67048,0.57090,
     &                     0.91655 ,0.61968/
      DATA (ksd(i),i=1,6) /0.18030 ,0.02514,0.03081,0.05065,
     &                     0.31296 ,0.003524/
c
      jp=ip-3
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,1,0,szetapm(jp),sN(jp),0,0,szeta(jp),intgr,dintgr)
      sss=intgr
      dsss=dintgr

c s d sigma bonding overlap integral in z-axis
c        
      call ovlcon(r,1,0,szetapm(jp),dN(jp),2,0,dzeta1(jp),intgr,dintgr)
       sds= intgr*coef1(jp)
      dsds=dintgr*coef1(jp)

      call ovlcon(r,1,0,szetapm(jp),dN(jp),2,0,dzeta2(jp),intgr,dintgr)
       sds= intgr*coef2(jp)+ sds
      dsds=dintgr*coef2(jp)+dsds
c
c Multiply kmn with (Hm(Ni)+Hn(H))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(ip,1)+vsip(1,1))*kss(jp)/2.0
      tmp2=(vsip(ip,2)+vsip(1,1))*ksd(jp)/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxy('xy',sds,dsds,t,dt)       !s-dxy
      hamil(1,2)=t*tmp2
      dhamil(1,2,1)=dt(1)*tmp2
      dhamil(1,2,2)=dt(2)*tmp2
      dhamil(1,2,3)=dt(3)*tmp2

      call sxy('yz',sds,dsds,t,dt)       !s-dyz
      hamil(1,3)=t*tmp2
      dhamil(1,3,1)=dt(1)*tmp2
      dhamil(1,3,2)=dt(2)*tmp2
      dhamil(1,3,3)=dt(3)*tmp2

      call sxy('zx',sds,dsds,t,dt)       !s-dzx
      hamil(1,4)=t*tmp2
      dhamil(1,4,1)=dt(1)*tmp2
      dhamil(1,4,2)=dt(2)*tmp2
      dhamil(1,4,3)=dt(3)*tmp2

      call sxxyy(sds,dsds,t,dt)          !s-dx2_y2
      hamil(1,5)=t*tmp2
      dhamil(1,5,1)=dt(1)*tmp2
      dhamil(1,5,2)=dt(2)*tmp2
      dhamil(1,5,3)=dt(3)*tmp2

      call szz(sds,dsds,t,dt)            !s-dz2
      hamil(1,6)=t*tmp2
      dhamil(1,6,1)=dt(1)*tmp2
      dhamil(1,6,2)=dt(2)*tmp2
      dhamil(1,6,3)=dt(3)*tmp2

      end subroutine h_tr_hd

c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and Ni.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine c_tr_hd (ip,r,hamil,dhamil)
      use basics
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision t,dt(3),vsip(8,2)
      integer ip,jp,i
      integer sN(6),dN(6)
      double precision szetapm(6),pzetapm(6),szeta(6)
      double precision sss,dsss,sds,dsds,pss,dpss,pds,dpds,pdp,dpdp
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)
      double precision r,k(6),r0(6),mu0(6)
      double precision dkllp,kllp,x,param(20)
      double precision tmp1,tmp2,tmp3,tmp4,temp,intgr,dintgr

      common /coulom/ vsip
c
c Because the original dovlap and ovlapd subroutine already work in au
c rather than Ang, as with most of TB 1.0.1, there is no need to convert
c the zeta values.
c
c STO parameters for carbon element
c
      DATA (szetapm(i),i=1,6)/1.56068,1.13260,1.59663,1.52369,
     &                        1.57727,1.25328/
      DATA (pzetapm(i),i=1,6)/1.56068,1.13260,1.59663,1.52369,
     &                        1.57727,1.25328/
c
c STO parameters for transition element
c
      DATA (sN(i),i=1,6) /4,4,5,5,6,6/
      DATA (dN(i),i=1,6) /3,3,4,4,5,5/
      DATA (szeta(i),i=1,6) /1.46952,2.14462,1.75195,1.81756,
     &                       2.04336,2.53186/
      DATA (coef1(i),i=1,6) /0.58579,0.59552,0.54226,0.56019,
     &                       0.65678,0.64695/
      DATA (coef2(i),i=1,6) /0.64856,0.57655,0.65649,0.55617,
     &                       0.57165,0.53788/
      DATA (dzeta1(i),i=1,6) /5.39452,5.89462,5.54495 ,4.90056,
     &                       5.50236,5.89462/
      DATA (dzeta2(i),i=1,6) /1.64452,2.24462,2.17495,2.49556,
     &                        2.18536,2.24462/
c
c Wolfberg-Holmholz constants
c
      DATA (  k(i),i=1,6) /0.26441,0.18125,0.29889,0.20342,
     &                     0.34261,0.30277/
c MAI: converting Ang-1 to au-1 for TBPAC
c      DATA ( r0(i),i=1,6) /1.9928 ,1.2870 ,2.9265,1.5743,
c     &                     2.0176 ,2.9275/
      DATA ( r0(i),i=1,6) /1.05454385739d0,0.68105075495d0,
     &                     1.54863639034d0,0.83308329722d0,
     &                     1.06766744614d0,1.54916556730d0/
      DATA (mu0(i),i=1,6) /0.01756,1.27014,0.04703,1.37253,
     &                     0.01994,0.67298/
c
      jp=ip-3
c
      temp=k(jp)*(r/r0(jp))**mu0(jp)
      kllp=k(jp)+temp
      dkllp=mu0(jp)*temp/r
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
c Actually, the final result is the product of overlap integral and constant
c K (distance dependent).
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,2,0,szetapm(jp),sN(jp),0,0,szeta(jp),intgr,dintgr)
      dsss=dintgr*kllp+intgr*dkllp
       sss= intgr*kllp
c
c p s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,2,1,pzetapm(jp),sN(jp),0,0,szeta(jp),intgr,dintgr)
      dpss=dintgr*kllp+intgr*dkllp
       pss=intgr*kllp
c
c s d sigma bonding overlap integral in z-axis
c
      call ovlcon(r,2,0,szetapm(jp),dN(jp),2,0,dzeta1(jp),intgr,dintgr)
       sds= intgr*coef1(jp)
      dsds=dintgr*coef1(jp)

      call ovlcon(r,2,0,szetapm(jp),dN(jp),2,0,dzeta2(jp),intgr,dintgr)
       sds= intgr*coef2(jp)+ sds
      dsds=dintgr*coef2(jp)+dsds
c
      dsds=dsds*kllp+sds*dkllp
       sds= sds*kllp
c
c p d sigma bonding overlap integral in z-axis
c
      call ovlcon(r,2,1,pzetapm(jp),dN(jp),2,0,dzeta1(jp),intgr,dintgr)
       pds= intgr*coef1(jp)
      dpds=dintgr*coef1(jp)

      call ovlcon(r,2,1,pzetapm(jp),dN(jp),2,0,dzeta2(jp),intgr,dintgr)
       pds= intgr*coef2(jp)+ pds
      dpds=dintgr*coef2(jp)+dpds
c
      dpds=dpds*kllp+pds*dkllp
       pds= pds*kllp
c
c p d pi bonding overlap integral in z-axis
c
      call ovlcon(r,2,1,pzetapm(jp),dN(jp),2,1,dzeta1(jp),intgr,dintgr)
       pdp= intgr*coef1(jp)
      dpdp=dintgr*coef1(jp)

      call ovlcon(r,2,1,pzetapm(jp),dN(jp),2,1,dzeta2(jp),intgr,dintgr)
       pdp= intgr*coef2(jp)+ pdp
      dpdp=dintgr*coef2(jp)+dpdp
c
      dpdp=dpdp*kllp+pdp*dkllp
       pdp= pdp*kllp
c
c Multiply kmn with (Hm(Ni)+Hn(C))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(2,1)+vsip(ip,1))/2.0
      tmp2=(vsip(2,1)+vsip(ip,2))/2.0
      tmp3=(vsip(2,2)+vsip(ip,1))/2.0
      tmp4=(vsip(2,2)+vsip(ip,2))/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxy('xy',sds,dsds,t,dt)       !s-dxy
      hamil(1,2)=t*tmp2
      dhamil(1,2,1)=dt(1)*tmp2
      dhamil(1,2,2)=dt(2)*tmp2
      dhamil(1,2,3)=dt(3)*tmp2

      call sxy('yz',sds,dsds,t,dt)       !s-dyz
      hamil(1,3)=t*tmp2
      dhamil(1,3,1)=dt(1)*tmp2
      dhamil(1,3,2)=dt(2)*tmp2
      dhamil(1,3,3)=dt(3)*tmp2

      call sxy('zx',sds,dsds,t,dt)       !s-dzx
      hamil(1,4)=t*tmp2
      dhamil(1,4,1)=dt(1)*tmp2
      dhamil(1,4,2)=dt(2)*tmp2
      dhamil(1,4,3)=dt(3)*tmp2

      call sxxyy(sds,dsds,t,dt)          !s-dx2_y2
      hamil(1,5)=t*tmp2
      dhamil(1,5,1)=dt(1)*tmp2
      dhamil(1,5,2)=dt(2)*tmp2
      dhamil(1,5,3)=dt(3)*tmp2

      call szz(sds,dsds,t,dt)            !s-dz2
      hamil(1,6)=t*tmp2
      dhamil(1,6,1)=dt(1)*tmp2
      dhamil(1,6,2)=dt(2)*tmp2
      dhamil(1,6,3)=dt(3)*tmp2

      call sxyz('x',pss,dpss,t,dt)       !px-s 
      hamil(2,1)=t*tmp3
      dhamil(2,1,1)=dt(1)*tmp3
      dhamil(2,1,2)=dt(2)*tmp3
      dhamil(2,1,3)=dt(3)*tmp3

      call xxy('xy',pds,dpds,pdp,dpdp,t,dt)         !px-dxy
      hamil(2,2)=t*tmp4
      dhamil(2,2,1)=dt(1)*tmp4
      dhamil(2,2,2)=dt(2)*tmp4
      dhamil(2,2,3)=dt(3)*tmp4

      call xyz(pds,dpds,pdp,dpdp,t,dt)              !px-dyz
      hamil(2,3)=t*tmp4
      dhamil(2,3,1)=dt(1)*tmp4
      dhamil(2,3,2)=dt(2)*tmp4
      dhamil(2,3,3)=dt(3)*tmp4

      call xxy('xz',pds,dpds,pdp,dpdp,t,dt)         !px-dzx
      hamil(2,4)=t*tmp4
      dhamil(2,4,1)=dt(1)*tmp4
      dhamil(2,4,2)=dt(2)*tmp4
      dhamil(2,4,3)=dt(3)*tmp4

      call xxxyy(pds,dpds,pdp,dpdp,t,dt)            !px-dx2_y2
      hamil(2,5)=t*tmp4
      dhamil(2,5,1)=dt(1)*tmp4
      dhamil(2,5,2)=dt(2)*tmp4
      dhamil(2,5,3)=dt(3)*tmp4

      call xzz('x',pds,dpds,pdp,dpdp,t,dt)              !px-dz2
      hamil(2,6)=t*tmp4
      dhamil(2,6,1)=dt(1)*tmp4
      dhamil(2,6,2)=dt(2)*tmp4
      dhamil(2,6,3)=dt(3)*tmp4

      call sxyz('y',pss,dpss,t,dt)       !py-s 
      hamil(3,1)=t*tmp3
      dhamil(3,1,1)=dt(1)*tmp3
      dhamil(3,1,2)=dt(2)*tmp3
      dhamil(3,1,3)=dt(3)*tmp3

      call xxy('yx',pds,dpds,pdp,dpdp,t,dt)         !py-dxy
      hamil(3,2)=t*tmp4
      dhamil(3,2,1)=dt(1)*tmp4
      dhamil(3,2,2)=dt(2)*tmp4
      dhamil(3,2,3)=dt(3)*tmp4

      call xxy('yz',pds,dpds,pdp,dpdp,t,dt)         !py-dyz
      hamil(3,3)=t*tmp4
      dhamil(3,3,1)=dt(1)*tmp4
      dhamil(3,3,2)=dt(2)*tmp4
      dhamil(3,3,3)=dt(3)*tmp4

      call xyz(pds,dpds,pdp,dpdp,t,dt)              !py-dzx
      hamil(3,4)=t*tmp4
      dhamil(3,4,1)=dt(1)*tmp4
      dhamil(3,4,2)=dt(2)*tmp4
      dhamil(3,4,3)=dt(3)*tmp4

      call yxxyy(pds,dpds,pdp,dpdp,t,dt)            !py-dx2_y2
      hamil(3,5)=t*tmp4
      dhamil(3,5,1)=dt(1)*tmp4
      dhamil(3,5,2)=dt(2)*tmp4
      dhamil(3,5,3)=dt(3)*tmp4

      call xzz('y',pds,dpds,pdp,dpdp,t,dt)              !py-dz2
      hamil(3,6)=t*tmp4
      dhamil(3,6,1)=dt(1)*tmp4
      dhamil(3,6,2)=dt(2)*tmp4
      dhamil(3,6,3)=dt(3)*tmp4

      call sxyz('z',pss,dpss,t,dt)       !pz-s 
      hamil(4,1)=t*tmp3
      dhamil(4,1,1)=dt(1)*tmp3
      dhamil(4,1,2)=dt(2)*tmp3
      dhamil(4,1,3)=dt(3)*tmp3

      call xyz(pds,dpds,pdp,dpdp,t,dt)               !pz-dxy
      hamil(4,2)=t*tmp4
      dhamil(4,2,1)=dt(1)*tmp4
      dhamil(4,2,2)=dt(2)*tmp4
      dhamil(4,2,3)=dt(3)*tmp4

      call xxy('zy',pds,dpds,pdp,dpdp,t,dt)          !pz-dyz
      hamil(4,3)=t*tmp4
      dhamil(4,3,1)=dt(1)*tmp4
      dhamil(4,3,2)=dt(2)*tmp4
      dhamil(4,3,3)=dt(3)*tmp4

      call xxy('zx',pds,dpds,pdp,dpdp,t,dt)          !pz-dzx
      hamil(4,4)=t*tmp4
      dhamil(4,4,1)=dt(1)*tmp4
      dhamil(4,4,2)=dt(2)*tmp4
      dhamil(4,4,3)=dt(3)*tmp4

      call zxxyy(pds,dpds,pdp,dpdp,t,dt)             !pz-dx2_y2
      hamil(4,5)=t*tmp4
      dhamil(4,5,1)=dt(1)*tmp4
      dhamil(4,5,2)=dt(2)*tmp4
      dhamil(4,5,3)=dt(3)*tmp4

      call zzz(pds,dpds,pdp,dpdp,t,dt)               !pz-dz2
      hamil(4,6)=t*tmp4
      dhamil(4,6,1)=dt(1)*tmp4
      dhamil(4,6,2)=dt(2)*tmp4
      dhamil(4,6,3)=dt(3)*tmp4

      end subroutine c_tr_hd

c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between C and H.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine tr_h_hd (ip,r,hamil,dhamil)
      use basics
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision t,dt(3),vsip(8,2),r
      integer ip,jp,i
      integer sNp(6),dNp(6)
      double precision szetapm(6),szeta(6)
      double precision sss,dsss,dss,ddss
      double precision kss(6),kds(6)
      double precision tmp1,tmp2,intgr,dintgr
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)

      common /coulom/ vsip
c
c Because the original dovlap and ovlapd subroutine already work in au
c rather than Ang, as with most of TB 1.0.1, there is no need to convert
c the zeta values.
c
c STO parameters for transition element
c
      DATA (sNp(i),i=1,6) /4,4,5,5,6,6/
      DATA (dNp(i),i=1,6) /3,3,4,4,5,5/
      DATA (szetapm(i),i=1,6) /1.76329,1.81529,2.03423,1.74711,
     &                         2.36819,2.12506/
      DATA (coef1(i),i=1,6) /0.57107,0.61029,0.53160,0.56239,
     &                       0.64119,0.66519/
      DATA (coef2(i),i=1,6) /0.63227,0.59085,0.64359,0.55836,
     &                       0.55808,0.55304/
      DATA (dzeta1(i),i=1,6) /5.68829,5.56529,5.82723,4.83011,
     &                       5.82719,5.68606/
      DATA (dzeta2(i),i=1,6) /1.93829,1.91529,2.45723,2.42511,
     &                       2.51019,2.31706/
c
c STO parameters for hydrogen element
c
      DATA (szeta(i),i=1,6) /1.22576,1.26397,1.21011,1.23966,
     &                       1.25792,1.12836/
c
c Wolfberg-Hol relation k constant.
c
      DATA (kss(i),i=1,6) /0.75730 ,0.80843,0.67048,0.57090,
     &                     0.91655,0.61968/
      DATA (kds(i),i=1,6) /0.18030 ,0.02514,0.03081,0.05065,
     &                     0.31296,0.003524/
c
      jp=ip-3
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,sNp(jp),0,szetapm(jp),1,0,0,szeta(jp),intgr,dintgr)
       sss=intgr
      dsss=dintgr

c d s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,dNp(jp),2,dzeta1(jp),1,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef1(jp)
      ddss=dintgr*coef1(jp)

      call ovlcon(r,dNp(jp),2,dzeta2(jp),1,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef2(jp)+ dss
      ddss=dintgr*coef2(jp)+ddss
c
c Multiply kmn with (Hm(Ni)+Hn(H))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(ip,1)+vsip(1,1))*kss(jp)/2.0
      tmp2=(vsip(ip,2)+vsip(1,1))*kds(jp)/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)                          !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxy('xy',dss,ddss,t,dt)                    !dxy-s
      hamil(2,1)=t*tmp2
      dhamil(2,1,1)=dt(1)*tmp2
      dhamil(2,1,2)=dt(2)*tmp2
      dhamil(2,1,3)=dt(3)*tmp2

      call sxy('yz',dss,ddss,t,dt)                    !dyz-s
      hamil(3,1)=t*tmp2
      dhamil(3,1,1)=dt(1)*tmp2
      dhamil(3,1,2)=dt(2)*tmp2
      dhamil(3,1,3)=dt(3)*tmp2

      call sxy('zx',dss,ddss,t,dt)                    !dzx-s
      hamil(4,1)=t*tmp2
      dhamil(4,1,1)=dt(1)*tmp2
      dhamil(4,1,2)=dt(2)*tmp2
      dhamil(4,1,3)=dt(3)*tmp2

      call sxxyy(dss,ddss,t,dt)                       !dx2_y2-s
      hamil(5,1)=t*tmp2
      dhamil(5,1,1)=dt(1)*tmp2
      dhamil(5,1,2)=dt(2)*tmp2
      dhamil(5,1,3)=dt(3)*tmp2

      call szz(dss,ddss,t,dt)                         !dz2-s
      hamil(6,1)=t*tmp2
      dhamil(6,1,1)=dt(1)*tmp2
      dhamil(6,1,2)=dt(2)*tmp2
      dhamil(6,1,3)=dt(3)*tmp2

      end subroutine tr_h_hd


c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between Ni and C.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine tr_c_hd (ip,r,hamil,dhamil)
      use basics
      implicit none
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision t,dt(3),vsip(8,2)
      integer ip,jp,i
      integer sNp(6),dNp(6)
      double precision szetapm(6),szeta(6),pzeta(6)
      double precision sss,dsss,dss,ddss,sps,dsps,dps,ddps,dpp,ddpp
      double precision coef1(6),coef2(6),dzeta1(6),dzeta2(6)
      double precision r,k(6),r0(6),mu0(6)
      double precision dkllp,kllp,x
      double precision tmp1,tmp2,tmp3,tmp4,temp,intgr,dintgr
c
      common /coulom/ vsip
c
c Because the original dovlap and ovlapd subroutine already work in au
c rather than Ang, as with most of TB 1.0.1, there is no need to convert
c the zeta values.
c
c STO parameters for transition element
c
      DATA (sNp(i),i=1,6) /4,4,5,5,6,6/
      DATA (dNp(i),i=1,6) /3,3,4,4,5,5/
      DATA (szetapm(i),i=1,6) /1.46952,2.14462,1.75195,1.81756,
     &                         2.04336,2.53186/
      DATA (coef1(i),i=1,6) /0.58579,0.59552,0.54226,0.56019,
     &                       0.65678,0.64695/
      DATA (coef2(i),i=1,6) /0.64856,0.57655,0.65649,0.55617,
     &                       0.57165,0.53788/
      DATA (dzeta1(i),i=1,6) /5.39452,5.89462,5.54495,4.90056,
     &                       5.50236,6.09286/
      DATA (dzeta2(i),i=1,6) /1.64452,2.24462,2.17495,2.49556,
     &                       2.18536,2.72386/
c
c STO parameters for carbon element
c
      DATA (szeta(i),i=1,6) /1.56068,1.13260,1.59663,1.52369,
     &                       1.57727,1.25328/
      DATA (pzeta(i),i=1,6) /1.56068,1.13260,1.59663,1.52369,
     &                       1.57727,1.25328/
c
c Wolfberg-Holmholz constants
c
      DATA (  k(i),i=1,6) /0.26441,0.18125,0.29889,0.20342,
     &                     0.34261,0.30277/
c MAI: converting Ang-1 to au-1 for TBPAC
c      DATA ( r0(i),i=1,6) /1.9928 ,1.2870,2.9265,1.5743,
c     &                     2.0176 ,2.9275/
      DATA ( r0(i),i=1,6) /1.05454385739d0,0.68105075495d0,
     &                     1.54863639034d0,0.83308329722d0,
     &                     1.06766744614d0,1.54916556730d0/
      DATA (mu0(i),i=1,6) /0.01756,1.27014,0.04703,1.37253,
     &                     0.01994,0.67298/
c
      jp=ip-3
c
      temp=k(jp)*(r/r0(jp))**mu0(jp)
      kllp=k(jp)+temp
      dkllp=mu0(jp)*temp/r
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c Actually, the final result is the product of overlap integral and constant
c K (distance dependent).
c
c s s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,sNp(jp),0,szetapm(jp),2,0,0,szeta(jp),intgr,dintgr)
      dsss=dintgr*kllp+intgr*dkllp
       sss= intgr*kllp

c d s sigma bonding overlap integral in z-axis
c
      call ovlcon(r,dNp(jp),2,dzeta1(jp),2,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef1(jp)
      ddss=dintgr*coef1(jp)

      call ovlcon(r,dNp(jp),2,dzeta2(jp),2,0,0,szeta(jp),intgr,dintgr)
       dss= intgr*coef2(jp)+ dss
      ddss=dintgr*coef2(jp)+ddss
c
      ddss=ddss*kllp+dss*dkllp
       dss= dss*kllp
c
c s p sigma bonding overlap integral in z-axis
c
      call ovlcon(r,sNp(jp),0,szetapm(jp),2,1,0,pzeta(jp),intgr,dintgr)
      dsps=dintgr*kllp+intgr*dkllp
       sps=intgr*kllp

c d p sigma bonding overlap integral in z-axis
c
      call ovlcon(r,dNp(jp),2,dzeta1(jp),2,1,0,pzeta(jp),intgr,dintgr)
       dps= intgr*coef1(jp)
      ddps=dintgr*coef1(jp)

      call ovlcon(r,dNp(jp),2,dzeta2(jp),2,1,0,pzeta(jp),intgr,dintgr)
       dps= intgr*coef2(jp)+ dps
      ddps=dintgr*coef2(jp)+ddps
c
      ddps=ddps*kllp+dps*dkllp
       dps= dps*kllp

c d p pi bonding overlap integral in z-axis
c
      call ovlcon(r,dNp(jp),2,dzeta1(jp),2,1,1,pzeta(jp),intgr,dintgr)
       dpp= intgr*coef1(jp)
      ddpp=dintgr*coef1(jp)

      call ovlcon(r,dNp(jp),2,dzeta2(jp),2,1,1,pzeta(jp),intgr,dintgr)
       dpp= intgr*coef2(jp)+ dpp
      ddpp=dintgr*coef2(jp)+ddpp
c
      ddpp=ddpp*kllp+dpp*dkllp
       dpp= dpp*kllp
c
c Multiply kmn with (Hm(Ni)+Hn(C))/2 to make a Wolfsberg-Helmholtz relation.
c
      tmp1=(vsip(ip,1)+vsip(2,1))/2.0
      tmp2=(vsip(ip,1)+vsip(2,2))/2.0
      tmp3=(vsip(ip,2)+vsip(2,1))/2.0
      tmp4=(vsip(ip,2)+vsip(2,2))/2.0
c
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t*tmp1
      dhamil(1,1,1)=dt(1)*tmp1
      dhamil(1,1,2)=dt(2)*tmp1
      dhamil(1,1,3)=dt(3)*tmp1

      call sxyz('x',sps,dsps,t,dt)       !s-px 
      hamil(1,2)=t*tmp2
      dhamil(1,2,1)=dt(1)*tmp2
      dhamil(1,2,2)=dt(2)*tmp2
      dhamil(1,2,3)=dt(3)*tmp2

      call sxyz('y',sps,dsps,t,dt)       !s-py 
      hamil(1,3)=t*tmp2
      dhamil(1,3,1)=dt(1)*tmp2
      dhamil(1,3,2)=dt(2)*tmp2
      dhamil(1,3,3)=dt(3)*tmp2

      call sxyz('z',sps,dsps,t,dt)       !s-pz 
      hamil(1,4)=t*tmp2
      dhamil(1,4,1)=dt(1)*tmp2
      dhamil(1,4,2)=dt(2)*tmp2
      dhamil(1,4,3)=dt(3)*tmp2

      call sxy('xy',dss,ddss,t,dt)       !dxy-s
      hamil(2,1)=t*tmp3
      dhamil(2,1,1)=dt(1)*tmp3
      dhamil(2,1,2)=dt(2)*tmp3
      dhamil(2,1,3)=dt(3)*tmp3

      call xxy('xy',dps,ddps,dpp,ddpp,t,dt)         !dxy-px
      hamil(2,2)=t*tmp4
      dhamil(2,2,1)=dt(1)*tmp4
      dhamil(2,2,2)=dt(2)*tmp4
      dhamil(2,2,3)=dt(3)*tmp4

      call xxy('yx',dps,ddps,dpp,ddpp,t,dt)         !dxy-py
      hamil(2,3)=t*tmp4
      dhamil(2,3,1)=dt(1)*tmp4
      dhamil(2,3,2)=dt(2)*tmp4
      dhamil(2,3,3)=dt(3)*tmp4

      call xyz(dps,ddps,dpp,ddpp,t,dt)               !dxy-pz
      hamil(2,4)=t*tmp4
      dhamil(2,4,1)=dt(1)*tmp4
      dhamil(2,4,2)=dt(2)*tmp4
      dhamil(2,4,3)=dt(3)*tmp4

      call sxy('yz',dss,ddss,t,dt)       !dyz-s
      hamil(3,1)=t*tmp3
      dhamil(3,1,1)=dt(1)*tmp3
      dhamil(3,1,2)=dt(2)*tmp3
      dhamil(3,1,3)=dt(3)*tmp3

      call xyz(dps,ddps,dpp,ddpp,t,dt)              !dyz-px
      hamil(3,2)=t*tmp4
      dhamil(3,2,1)=dt(1)*tmp4
      dhamil(3,2,2)=dt(2)*tmp4
      dhamil(3,2,3)=dt(3)*tmp4

      call xxy('yz',dps,ddps,dpp,ddpp,t,dt)         !dyz-py
      hamil(3,3)=t*tmp4
      dhamil(3,3,1)=dt(1)*tmp4
      dhamil(3,3,2)=dt(2)*tmp4
      dhamil(3,3,3)=dt(3)*tmp4

      call xxy('zy',dps,ddps,dpp,ddpp,t,dt)          !dyz-pz
      hamil(3,4)=t*tmp4
      dhamil(3,4,1)=dt(1)*tmp4
      dhamil(3,4,2)=dt(2)*tmp4
      dhamil(3,4,3)=dt(3)*tmp4

      call sxy('zx',dss,ddss,t,dt)       !dzx-s
      hamil(4,1)=t*tmp3
      dhamil(4,1,1)=dt(1)*tmp3
      dhamil(4,1,2)=dt(2)*tmp3
      dhamil(4,1,3)=dt(3)*tmp3

      call xxy('xz',dps,ddps,dpp,ddpp,t,dt)         !dzx-px
      hamil(4,2)=t*tmp4
      dhamil(4,2,1)=dt(1)*tmp4
      dhamil(4,2,2)=dt(2)*tmp4
      dhamil(4,2,3)=dt(3)*tmp4

      call xyz(dps,ddps,dpp,ddpp,t,dt)              !dzx-py
      hamil(4,3)=t*tmp4
      dhamil(4,3,1)=dt(1)*tmp4
      dhamil(4,3,2)=dt(2)*tmp4
      dhamil(4,3,3)=dt(3)*tmp4

      call xxy('zx',dps,ddps,dpp,ddpp,t,dt)          !dzx-pz
      hamil(4,4)=t*tmp4
      dhamil(4,4,1)=dt(1)*tmp4
      dhamil(4,4,2)=dt(2)*tmp4
      dhamil(4,4,3)=dt(3)*tmp4

      call sxxyy(dss,ddss,t,dt)          !dx2_y2-s
      hamil(5,1)=t*tmp3
      dhamil(5,1,1)=dt(1)*tmp3
      dhamil(5,1,2)=dt(2)*tmp3
      dhamil(5,1,3)=dt(3)*tmp3

      call xxxyy(dps,ddps,dpp,ddpp,t,dt)            !dx2_y2-px
      hamil(5,2)=t*tmp4
      dhamil(5,2,1)=dt(1)*tmp4
      dhamil(5,2,2)=dt(2)*tmp4
      dhamil(5,2,3)=dt(3)*tmp4

      call yxxyy(dps,ddps,dpp,ddpp,t,dt)            !dx2_y2-py
      hamil(5,3)=t*tmp4
      dhamil(5,3,1)=dt(1)*tmp4
      dhamil(5,3,2)=dt(2)*tmp4
      dhamil(5,3,3)=dt(3)*tmp4

      call zxxyy(dps,ddps,dpp,ddpp,t,dt)             !dx2_y2-pz
      hamil(5,4)=t*tmp4
      dhamil(5,4,1)=dt(1)*tmp4
      dhamil(5,4,2)=dt(2)*tmp4
      dhamil(5,4,3)=dt(3)*tmp4

      call szz(dss,ddss,t,dt)            !dz2-s
      hamil(6,1)=t*tmp3
      dhamil(6,1,1)=dt(1)*tmp3
      dhamil(6,1,2)=dt(2)*tmp3
      dhamil(6,1,3)=dt(3)*tmp3

      call xzz('x',dps,ddps,dpp,ddpp,t,dt)              !dz2-px
      hamil(6,2)=t*tmp4
      dhamil(6,2,1)=dt(1)*tmp4
      dhamil(6,2,2)=dt(2)*tmp4
      dhamil(6,2,3)=dt(3)*tmp4

      call xzz('y',dps,ddps,dpp,ddpp,t,dt)              !dz2-py
      hamil(6,3)=t*tmp4
      dhamil(6,3,1)=dt(1)*tmp4
      dhamil(6,3,2)=dt(2)*tmp4
      dhamil(6,3,3)=dt(3)*tmp4

      call zzz(dps,ddps,dpp,ddpp,t,dt)               !dz2-pz
      hamil(6,4)=t*tmp4
      dhamil(6,4,1)=dt(1)*tmp4
      dhamil(6,4,2)=dt(2)*tmp4
      dhamil(6,4,3)=dt(3)*tmp4

      end subroutine tr_c_hd


c 88888888888888888888888888888888888888888888888888888888888888888888888
c This subroutine calculates the Hamiltonian elements and the first    
c derivatives of these Hamiltonian elements between two same transition
c metal atoms.
c If you want to some calculation between two different metal atoms, find
c the parameters first.
c 
c MAI: Currently implemented for icase=25 (i.e. Chi and Mack)
c MAI: Unlike Al-Al routines, this subroutine does not return the overlap matrix
c
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine tr_tr_hd (ip,r,hamil,dhamil)
      use basics
      implicit none
      integer i,ip,jp
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3)
      double precision t,dt(3),r
      double precision ssseta0(6),rd(6),d(6),ssstau,sssalpha(6),sss,dsss
      double precision sdseta0,             sdstau,sdsalpha(6),sds,dsds
      double precision dsseta0,             dsstau,dssalpha(6),dss,ddss
      double precision ddseta0,             ddstau,ddsalpha(6),dds,ddds
      double precision ddpeta0,             ddptau,ddpalpha(6),ddp,dddp
      double precision dddeta0,             dddtau,dddalpha(6),ddd,dddd
c
c Hopping parameters for metal and metal
c
cMAI: need to convert Ang & eV to au for TBPAC
c      DATA ( d(i),i=1,6) /2.4761,1.9606,2.8120,2.4307,2.5862,2.3083/
c      DATA (rd(i),i=1,6) /0.71,0.67,0.94,0.89,1.04,1.01/
      DATA ( d(i),i=1,6) /4.67915302470d0,3.70499875620d0,
     &                    5.31391232400d0,4.49335941890d0,
     &                    4.88721196740d0,4.36205683410d0/
      DATA (rd(i),i=1,6) /1.34170617000d0,1.26611709000d0,
     &                    1.77634338000d0,1.68185703000d0,
     &                    1.96531608000d0,1.90862427000d0/
c s s sigma
      DATA (ssseta0(i),i=1,6) /-0.4530,-0.5447,-0.5652,-0.4340,
     &                         -0.6322,-0.3817/
      DATA ssstau /0.d0/
c      DATA (sssalpha(i),i=1,6) /0.41132,0.60676,0.41411,0.50593,
c     &                          0.51571,0.58339/
      DATA (sssalpha(i),i=1,6) /0.21766106956d0,0.32108341575d0,
     &                          0.21913747330d0,0.26772650229d0,
     &                          0.27290185302d0,0.30871655006d0/
c s d sigma
      DATA sdseta0 /-3.16d0/
      DATA sdstau /1.5d0/
c      DATA (sdsalpha(i),i=1,6) /0.41132,0.60676,0.41411,0.50593,
c     &                          0.51571,0.58339/
      DATA (sdsalpha(i),i=1,6) /0.21766106956d0,0.32108341575d0,
     &                          0.21913747330d0,0.26772650229d0,
     &                          0.27290185302d0,0.30871655006d0/
c d s sigma
      DATA dsseta0 /-3.16d0/
      DATA dsstau /1.5d0/
c      DATA (dssalpha(i),i=1,6) /0.41132,0.60676,0.41411,0.50593,
c     &                          0.51571,0.58339/
      DATA (dssalpha(i),i=1,6) /0.21766106956d0,0.32108341575d0,
     &                          0.21913747330d0,0.26772650229d0,
     &                          0.27290185302d0,0.30871655006d0/
c d d sigma
      DATA ddseta0 /-16.2d0/
      DATA ddstau /3.d0/
c      DATA (ddsalpha(i),i=1,6) /0.41132,0.60676,0.41411,0.50593,
c     &                          0.51571,0.58339/
      DATA (ddsalpha(i),i=1,6) /0.21766106956d0,0.32108341575d0,
     &                          0.21913747330d0,0.26772650229d0,
     &                          0.27290185302d0,0.30871655006d0/
c d d pi
      DATA ddpeta0 /8.75d0/
      DATA ddptau /3.d0/
c      DATA (ddpalpha(i),i=1,6) /0.41132,0.60676,0.41411,0.50593,
c     &                          0.51571,0.58339/
      DATA (ddpalpha(i),i=1,6) /0.21766106956d0,0.32108341575d0,
     &                          0.21913747330d0,0.26772650229d0,
     &                          0.27290185302d0,0.30871655006d0/
      DATA (ddpalpha(i),i=1,6) /0.21766d0,0.32108d0,0.21914d0,
     &                          0.26773d0,0.27290d0,0.30872d0/
c d d delta
      DATA dddeta0 /0.0d0/
      DATA dddtau /3.d0/
c      DATA (dddalpha(i),i=1,6) /0.41132,0.60676,0.41411,0.50593,
c     &                          0.51571,0.58339/
      DATA (dddalpha(i),i=1,6) /0.21766106956d0,0.32108341575d0,
     &                          0.21913747330d0,0.26772650229d0,
     &                          0.27290185302d0,0.30871655006d0/
c
c Call subroutine to compute the two center integral of the two atoms when
c one atom is at the origin and the other atom is at z-axis.
c
      jp=ip-3
c
      call lathio(r,ssseta0(jp),rd(jp),d(jp),ssstau,sssalpha(jp),
     &            sss,dsss)
      call lathio(r,sdseta0,rd(jp),d(jp),sdstau,sdsalpha(jp),sds,dsds)
      call lathio(r,dsseta0,rd(jp),d(jp),dsstau,dssalpha(jp),dss,ddss)
      call lathio(r,ddseta0,rd(jp),d(jp),ddstau,ddsalpha(jp),dds,ddds)
      call lathio(r,ddpeta0,rd(jp),d(jp),ddptau,ddpalpha(jp),ddp,dddp)
      call lathio(r,dddeta0,rd(jp),d(jp),dddtau,dddalpha(jp),ddd,dddd)
c 
c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxy('xy',sds,dsds,t,dt)       !s-dxy
      hamil(1,2)=t
      dhamil(1,2,1)=dt(1)
      dhamil(1,2,2)=dt(2)
      dhamil(1,2,3)=dt(3)

      call sxy('yz',sds,dsds,t,dt)       !s-dyz
      hamil(1,3)=t
      dhamil(1,3,1)=dt(1)
      dhamil(1,3,2)=dt(2)
      dhamil(1,3,3)=dt(3)

      call sxy('zx',sds,dsds,t,dt)       !s-dzx
      hamil(1,4)=t
      dhamil(1,4,1)=dt(1)
      dhamil(1,4,2)=dt(2)
      dhamil(1,4,3)=dt(3)

      call sxxyy(sds,dsds,t,dt)          !s-dx2_y2
      hamil(1,5)=t
      dhamil(1,5,1)=dt(1)
      dhamil(1,5,2)=dt(2)
      dhamil(1,5,3)=dt(3)

      call szz(sds,dsds,t,dt)            !s-dz2
      hamil(1,6)=t
      dhamil(1,6,1)=dt(1)
      dhamil(1,6,2)=dt(2)
      dhamil(1,6,3)=dt(3)

      call sxy('xy',dss,ddss,t,dt)             !dxy-s
      hamil(2,1)=t
      dhamil(2,1,1)=dt(1)
      dhamil(2,1,2)=dt(2)
      dhamil(2,1,3)=dt(3)

      call xyxy('xy',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dxy-dxy
      hamil(2,2)=t
      dhamil(2,2,1)=dt(1)
      dhamil(2,2,2)=dt(2)
      dhamil(2,2,3)=dt(3)

      call xyyz('xz',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dxy-dyz
      hamil(2,3)=t
      dhamil(2,3,1)=dt(1)
      dhamil(2,3,2)=dt(2)
      dhamil(2,3,3)=dt(3)

      call xyyz('yz',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dxy-dzx
      hamil(2,4)=t
      dhamil(2,4,1)=dt(1)
      dhamil(2,4,2)=dt(2)
      dhamil(2,4,3)=dt(3)

      call xyxxyy(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dxy-dx2_y2
      hamil(2,5)=t
      dhamil(2,5,1)=dt(1)
      dhamil(2,5,2)=dt(2)
      dhamil(2,5,3)=dt(3)

      call xyzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dxy-dz2
      hamil(2,6)=t
      dhamil(2,6,1)=dt(1)
      dhamil(2,6,2)=dt(2)
      dhamil(2,6,3)=dt(3)

      call sxy('yz',dss,ddss,t,dt)                     !dyz-s
      hamil(3,1)=t
      dhamil(3,1,1)=dt(1)
      dhamil(3,1,2)=dt(2)
      dhamil(3,1,3)=dt(3)

      call xyyz('zx',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dyz-dxy
      hamil(3,2)=t
      dhamil(3,2,1)=dt(1)
      dhamil(3,2,2)=dt(2)
      dhamil(3,2,3)=dt(3)

      call xyxy('yz',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dyz-dyz
      hamil(3,3)=t
      dhamil(3,3,1)=dt(1)
      dhamil(3,3,2)=dt(2)
      dhamil(3,3,3)=dt(3)

      call xyyz('yx',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dyz-dzx
      hamil(3,4)=t
      dhamil(3,4,1)=dt(1)
      dhamil(3,4,2)=dt(2)
      dhamil(3,4,3)=dt(3)

      call yzxxyy(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dxy-dx2_y2
      hamil(3,5)=t
      dhamil(3,5,1)=dt(1)
      dhamil(3,5,2)=dt(2)
      dhamil(3,5,3)=dt(3)

      call yzzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dxy-dz2
      hamil(3,6)=t
      dhamil(3,6,1)=dt(1)
      dhamil(3,6,2)=dt(2)
      dhamil(3,6,3)=dt(3)

      call sxy('zx',dss,ddss,t,dt)                     !dzx-s
      hamil(4,1)=t
      dhamil(4,1,1)=dt(1)
      dhamil(4,1,2)=dt(2)
      dhamil(4,1,3)=dt(3)

      call xyyz('zy',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dzx-dxy
      hamil(4,2)=t
      dhamil(4,2,1)=dt(1)
      dhamil(4,2,2)=dt(2)
      dhamil(4,2,3)=dt(3)

      call xyyz('xy',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dzx-dyz
      hamil(4,3)=t
      dhamil(4,3,1)=dt(1)
      dhamil(4,3,2)=dt(2)
      dhamil(4,3,3)=dt(3)

      call xyxy('zx',dds,ddds,ddp,dddp,ddd,dddd,t,dt)  !dzx-dzx
      hamil(4,4)=t
      dhamil(4,4,1)=dt(1)
      dhamil(4,4,2)=dt(2)
      dhamil(4,4,3)=dt(3)

      call zxxxyy(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dzx-dx2_y2
      hamil(4,5)=t
      dhamil(4,5,1)=dt(1)
      dhamil(4,5,2)=dt(2)
      dhamil(4,5,3)=dt(3)

      call zxzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dzx-dz2
      hamil(4,6)=t
      dhamil(4,6,1)=dt(1)
      dhamil(4,6,2)=dt(2)
      dhamil(4,6,3)=dt(3)

      call sxxyy(sds,dsds,t,dt)                       !dx2_y2-s
      hamil(5,1)=t
      dhamil(5,1,1)=dt(1)
      dhamil(5,1,2)=dt(2)
      dhamil(5,1,3)=dt(3)

      call xyxxyy(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dx2_y2-dxy
      hamil(5,2)=t
      dhamil(5,2,1)=dt(1)
      dhamil(5,2,2)=dt(2)
      dhamil(5,2,3)=dt(3)

      call yzxxyy(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dx2_y2-dxy
      hamil(5,3)=t
      dhamil(5,3,1)=dt(1)
      dhamil(5,3,2)=dt(2)
      dhamil(5,3,3)=dt(3)

      call zxxxyy(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dx2_y2-dzx
      hamil(5,4)=t
      dhamil(5,4,1)=dt(1)
      dhamil(5,4,2)=dt(2)
      dhamil(5,4,3)=dt(3)

      call xxyy_2(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dx2_y2-dx2_y2
      hamil(5,5)=t
      dhamil(5,5,1)=dt(1)
      dhamil(5,5,2)=dt(2)
      dhamil(5,5,3)=dt(3)

      call xxyyzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dzx-dx2_y2
      hamil(5,6)=t
      dhamil(5,6,1)=dt(1)
      dhamil(5,6,2)=dt(2)
      dhamil(5,6,3)=dt(3)

      call szz(sds,dsds,t,dt)                          !dz2-s
      hamil(6,1)=t
      dhamil(6,1,1)=dt(1)
      dhamil(6,1,2)=dt(2)
      dhamil(6,1,3)=dt(3)

      call xyzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dz2-dxy
      hamil(6,2)=t
      dhamil(6,2,1)=dt(1)
      dhamil(6,2,2)=dt(2)
      dhamil(6,2,3)=dt(3)

      call yzzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dz2-dxy
      hamil(6,3)=t
      dhamil(6,3,1)=dt(1)
      dhamil(6,3,2)=dt(2)
      dhamil(6,3,3)=dt(3)

      call zxzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dz2-dzx
      hamil(6,4)=t
      dhamil(6,4,1)=dt(1)
      dhamil(6,4,2)=dt(2)
      dhamil(6,4,3)=dt(3)

      call xxyyzz(dds,ddds,ddp,dddp,ddd,dddd,t,dt)     !dz2-dx2_y2
      hamil(6,5)=t
      dhamil(6,5,1)=dt(1)
      dhamil(6,5,2)=dt(2)
      dhamil(6,5,3)=dt(3)

      call zz_2(dds,ddds,ddp,dddp,ddd,dddd,t,dt)       !dz2-dz2
      hamil(6,6)=t
      dhamil(6,6,1)=dt(1)
      dhamil(6,6,2)=dt(2)
      dhamil(6,6,3)=dt(3)

      end subroutine tr_tr_hd

      subroutine al_al_hd (ip,r,hamil,dhamil,Sij2,dSij2)
      use basics
      use grad
      implicit real*8(a-h,o-z)
      dimension hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3),dt(3)
      double precision Sij2(subsiz,subsiz),dSij2(subsiz,subsiz,3)
c
      call potsss(r,sss,dsss,Ssss,dSsss)
      call potsps(r,sps,dsps,Ssps,dSsps)
      call potpps(r,pps,dpps,Spps,dSpps)
      call potppp(r,ppp,dppp,Sppp,dSppp)

      pss=-sps
      dpss=-dsps
      Spss=-Ssps
      dSpss=-dSsps

c Project the two-center integral along the basis set.
c
      call ss(sss,dsss,t,dt)             !s-s
      hamil(1,1)=t
      dhamil(1,1,1)=dt(1)
      dhamil(1,1,2)=dt(2)
      dhamil(1,1,3)=dt(3)

      call sxyz('x',sps,dsps,t,dt)       !s-px
      hamil(1,2)=t
      dhamil(1,2,1)=dt(1)
      dhamil(1,2,2)=dt(2)
      dhamil(1,2,3)=dt(3)

      call sxyz('y',sps,dsps,t,dt)       !s-py
      hamil(1,3)=t
      dhamil(1,3,1)=dt(1)
      dhamil(1,3,2)=dt(2)
      dhamil(1,3,3)=dt(3)

      call sxyz('z',sps,dsps,t,dt)       !s-pz
      hamil(1,4)=t
      dhamil(1,4,1)=dt(1)
      dhamil(1,4,2)=dt(2)
      dhamil(1,4,3)=dt(3)

      call sxyz('x',pss,dpss,t,dt)       !px-s
      hamil(2,1)=t
      dhamil(2,1,1)=dt(1)
      dhamil(2,1,2)=dt(2)
      dhamil(2,1,3)=dt(3)

      call xx('x',pps,dpps,ppp,dppp,t,dt)   !px-px
      hamil(2,2)=t
      dhamil(2,2,1)=dt(1)
      dhamil(2,2,2)=dt(2)
      dhamil(2,2,3)=dt(3)

      call xy('xy',pps,dpps,ppp,dppp,t,dt)  !px-py
      hamil(2,3)=t
      dhamil(2,3,1)=dt(1)
      dhamil(2,3,2)=dt(2)
      dhamil(2,3,3)=dt(3)

      call xy('xz',pps,dpps,ppp,dppp,t,dt)  !px-pz
      hamil(2,4)=t
      dhamil(2,4,1)=dt(1)
      dhamil(2,4,2)=dt(2)
      dhamil(2,4,3)=dt(3)

      call sxyz('y',pss,dpss,t,dt)          !py-s
      hamil(3,1)=t
      dhamil(3,1,1)=dt(1)
      dhamil(3,1,2)=dt(2)
      dhamil(3,1,3)=dt(3)

      call xy('xy',pps,dpps,ppp,dppp,t,dt)  !py-px
      hamil(3,2)=t
      dhamil(3,2,1)=dt(1)
      dhamil(3,2,2)=dt(2)
      dhamil(3,2,3)=dt(3)

      call xx('y',pps,dpps,ppp,dppp,t,dt)   !py-py
      hamil(3,3)=t
      dhamil(3,3,1)=dt(1)
      dhamil(3,3,2)=dt(2)
      dhamil(3,3,3)=dt(3)

      call xy('yz',pps,dpps,ppp,dppp,t,dt)  !py-pz
      hamil(3,4)=t
      dhamil(3,4,1)=dt(1)
      dhamil(3,4,2)=dt(2)
      dhamil(3,4,3)=dt(3)

      call sxyz('z',pss,dpss,t,dt)          !pz-s
      hamil(4,1)=t
      dhamil(4,1,1)=dt(1)
      dhamil(4,1,2)=dt(2)
      dhamil(4,1,3)=dt(3)

      call xy('xz',pps,dpps,ppp,dppp,t,dt)  !pz-px
      hamil(4,2)=t
      dhamil(4,2,1)=dt(1)
      dhamil(4,2,2)=dt(2)
      dhamil(4,2,3)=dt(3)

      call xy('yz',pps,dpps,ppp,dppp,t,dt)  !pz-py
      hamil(4,3)=t
      dhamil(4,3,1)=dt(1)
      dhamil(4,3,2)=dt(2)
      dhamil(4,3,3)=dt(3)

      call xx('z',pps,dpps,ppp,dppp,t,dt)   !pz-pz
      hamil(4,4)=t
      dhamil(4,4,1)=dt(1)
      dhamil(4,4,2)=dt(2)
      dhamil(4,4,3)=dt(3)

      if(.not.doS)return

c Project the two-center integral along the basis set.
c
      call ss(Ssss,dSsss,t,dt)             !s-s
      Sij2(1,1)=t
      dSij2(1,1,1)=dt(1)
      dSij2(1,1,2)=dt(2)
      dSij2(1,1,3)=dt(3)

      call sxyz('x',Ssps,dSsps,t,dt)       !s-px
      Sij2(1,2)=t
      dSij2(1,2,1)=dt(1)
      dSij2(1,2,2)=dt(2)
      dSij2(1,2,3)=dt(3)

      call sxyz('y',Ssps,dSsps,t,dt)       !s-py
      Sij2(1,3)=t
      dSij2(1,3,1)=dt(1)
      dSij2(1,3,2)=dt(2)
      dSij2(1,3,3)=dt(3)

      call sxyz('z',Ssps,dSsps,t,dt)       !s-pz
      Sij2(1,4)=t
      dSij2(1,4,1)=dt(1)
      dSij2(1,4,2)=dt(2)
      dSij2(1,4,3)=dt(3)

      call sxyz('x',Spss,dSpss,t,dt)       !px-s
      Sij2(2,1)=t
      dSij2(2,1,1)=dt(1)
      dSij2(2,1,2)=dt(2)
      dSij2(2,1,3)=dt(3)

      call xx('x',Spps,dSpps,Sppp,dSppp,t,dt)   !px-px
      Sij2(2,2)=t
      dSij2(2,2,1)=dt(1)
      dSij2(2,2,2)=dt(2)
      dSij2(2,2,3)=dt(3)

      call xy('xy',Spps,dSpps,Sppp,dSppp,t,dt)  !px-py
      Sij2(2,3)=t
      dSij2(2,3,1)=dt(1)
      dSij2(2,3,2)=dt(2)
      dSij2(2,3,3)=dt(3)

      call xy('xz',Spps,dSpps,Sppp,dSppp,t,dt)  !px-pz
      Sij2(2,4)=t
      dSij2(2,4,1)=dt(1)
      dSij2(2,4,2)=dt(2)
      dSij2(2,4,3)=dt(3)

      call sxyz('y',Spss,dSpss,t,dt)          !py-s
      Sij2(3,1)=t
      dSij2(3,1,1)=dt(1)
      dSij2(3,1,2)=dt(2)
      dSij2(3,1,3)=dt(3)

      call xy('xy',Spps,dSpps,Sppp,dSppp,t,dt)  !py-px
      Sij2(3,2)=t
      dSij2(3,2,1)=dt(1)
      dSij2(3,2,2)=dt(2)
      dSij2(3,2,3)=dt(3)

      call xx('y',Spps,dSpps,Sppp,dSppp,t,dt)   !py-py
      Sij2(3,3)=t
      dSij2(3,3,1)=dt(1)
      dSij2(3,3,2)=dt(2)
      dSij2(3,3,3)=dt(3)

      call xy('yz',Spps,dSpps,Sppp,dSppp,t,dt)  !py-pz
      Sij2(3,4)=t
      dSij2(3,4,1)=dt(1)
      dSij2(3,4,2)=dt(2)
      dSij2(3,4,3)=dt(3)

      call sxyz('z',Spss,dSpss,t,dt)          !pz-s
      Sij2(4,1)=t
      dSij2(4,1,1)=dt(1)
      dSij2(4,1,2)=dt(2)
      dSij2(4,1,3)=dt(3)

      call xy('xz',Spps,dSpps,Sppp,dSppp,t,dt)  !pz-px
      Sij2(4,2)=t
      dSij2(4,2,1)=dt(1)
      dSij2(4,2,2)=dt(2)
      dSij2(4,2,3)=dt(3)

      call xy('yz',Spps,dSpps,Sppp,dSppp,t,dt)  !pz-py
      Sij2(4,3)=t
      dSij2(4,3,1)=dt(1)
      dSij2(4,3,2)=dt(2)
      dSij2(4,3,3)=dt(3)

      call xx('z',Spps,dSpps,Sppp,dSppp,t,dt)   !pz-pz
      Sij2(4,4)=t
      dSij2(4,4,1)=dt(1)
      dSij2(4,4,2)=dt(2)
      dSij2(4,4,3)=dt(3)

      end subroutine al_al_hd
c
      subroutine al_al_hd_mb (i,j,natom,x,y,z,r,idtype,hamil,dhamilmb,
     &   Sij2,dSij2mb,Fcng,dFcng)

      use basics
      use grad
      implicit none
      integer ip,jp,i,j,natom,idtype(natom),k,kk
      double precision hamil(subsiz,subsiz)
      double precision dhamilmb(subsiz,subsiz,natom,3),dt(natom,3)
      double precision Sij2(subsiz,subsiz)
      double precision dSij2mb(subsiz,subsiz,ndimdS2,3)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),rij,t
      double precision Fmb1,dFmb1(natom,3)
      double precision Fmb2,dFmb2(natom,3)
      double precision Fmb3,dFmb3(natom,3)
      double precision Fmb4,dFmb4(natom,3)
      double precision sss,dsss,Ssss,dSsss
      double precision sps,dsps,Ssps,dSsps
      double precision pss,dpss,Spss,dSpss
      double precision pps,dpps,Spps,dSpps
      double precision ppp,dppp,Sppp,dSppp
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision lladmm,llmimm,nn,l,m,n
      double precision Fcng(natom),dFcng(natom,natom,3)
      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      ip=idtype(i)
      jp=idtype(j)
      rij=r(i,j)

c dsss etc are derivatives w.r.t. r not (x,y,z)
      call potsss(rij,sss,dsss,Ssss,dSsss)
      call potsps(rij,sps,dsps,Ssps,dSsps)
      call potpps(rij,pps,dpps,Spps,dSpps)
      call potppp(rij,ppp,dppp,Sppp,dSppp)

      pss=-sps
      dpss=-dsps
      Spss=-Ssps
      dSpss=-dSsps

c Determine the many-body corrections and the derivatives
      call doFMB(i,j,natom,x,y,z,r,idtype,1,Fmb1,dFmb1,Fcng,dFcng)
      call doFMB(i,j,natom,x,y,z,r,idtype,2,Fmb2,dFmb2,Fcng,dFcng)
      call doFMB(i,j,natom,x,y,z,r,idtype,3,Fmb3,dFmb3,Fcng,dFcng)
      call doFMB(i,j,natom,x,y,z,r,idtype,4,Fmb4,dFmb4,Fcng,dFcng)

c need to call lmndlm again since these values overwritten by doFMB
      call lmndlm(i,j,natom,x,y,z,r)

c Project the two-center integral along the basis set.
c
      call ss_mb(i,j,sss,dsss,natom,t,dt,Fmb1,dFmb1)             !s-s
      hamil(1,1)=t
      if(dograd)then
        do 1 k=1,natom
	do 1 kk=1,3
           dhamilmb(1,1,k,kk)=dt(k,kk)
 1      continue
      endif

      call sxyz_mb(i,j,'x',natom,sps,dsps,t,dt,Fmb2,dFmb2)       !s-px
      hamil(1,2)=t
      if(dograd)then
        do 2 k=1,natom
	do 2 kk=1,3
           dhamilmb(1,2,k,kk)=dt(k,kk)
 2      continue
      endif

      call sxyz_mb(i,j,'y',natom,sps,dsps,t,dt,Fmb2,dFmb2)       !s-py
      hamil(1,3)=t
      if(dograd)then
        do 3 k=1,natom
	do 3 kk=1,3
           dhamilmb(1,3,k,kk)=dt(k,kk)
 3      continue
      endif

      call sxyz_mb(i,j,'z',natom,sps,dsps,t,dt,Fmb2,dFmb2)       !s-pz
      hamil(1,4)=t
      if(dograd)then
        do 4 k=1,natom
	do 4 kk=1,3
           dhamilmb(1,4,k,kk)=dt(k,kk)
 4      continue
      endif

      call sxyz_mb(i,j,'x',natom,pss,dpss,t,dt,Fmb2,dFmb2)       !px-s
      hamil(2,1)=t
      if(dograd)then
        do 5 k=1,natom
	do 5 kk=1,3
           dhamilmb(2,1,k,kk)=dt(k,kk)
 5      continue
      endif

      call xx_mb(i,j,'x',natom,pps,dpps,ppp,dppp,t,dt,
     &                              Fmb3,dFmb3,Fmb4,dFmb4)   !px-px
      hamil(2,2)=t
      if(dograd)then
        do 6 k=1,natom
	do 6 kk=1,3
           dhamilmb(2,2,k,kk)=dt(k,kk)
 6      continue
      endif

      call xy_mb(i,j,'xy',natom,pps,dpps,ppp,dppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !px-py
      hamil(2,3)=t
      if(dograd)then
        do 7 k=1,natom
	do 7 kk=1,3
           dhamilmb(2,3,k,kk)=dt(k,kk)
 7      continue
      endif

      call xy_mb(i,j,'xz',natom,pps,dpps,ppp,dppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !px-pz
      hamil(2,4)=t
      if(dograd)then
        do 8 k=1,natom
	do 8 kk=1,3
           dhamilmb(2,4,k,kk)=dt(k,kk)
 8      continue
      endif

      call sxyz_mb(i,j,'y',natom,pss,dpss,t,dt,Fmb2,dFmb2)          !py-s
      hamil(3,1)=t
      if(dograd)then
        do 9 k=1,natom
	do 9 kk=1,3
           dhamilmb(3,1,k,kk)=dt(k,kk)
 9      continue
      endif

      call xy_mb(i,j,'xy',natom,pps,dpps,ppp,dppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !py-px
      hamil(3,2)=t
      if(dograd)then
        do 10 k=1,natom
	do 10 kk=1,3
           dhamilmb(3,2,k,kk)=dt(k,kk)
 10     continue
      endif

      call xx_mb(i,j,'y',natom,pps,dpps,ppp,dppp,t,dt,
     &                              Fmb3,dFmb3,Fmb4,dFmb4)   !py-py
      hamil(3,3)=t
      if(dograd)then
        do 11 k=1,natom
	do 11 kk=1,3
           dhamilmb(3,3,k,kk)=dt(k,kk)
 11     continue
      endif

      call xy_mb(i,j,'yz',natom,pps,dpps,ppp,dppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !py-pz
      hamil(3,4)=t
      if(dograd)then
        do 12 k=1,natom
	do 12 kk=1,3
           dhamilmb(3,4,k,kk)=dt(k,kk)
 12     continue
      endif

      call sxyz_mb(i,j,'z',natom,pss,dpss,t,dt,Fmb2,dFmb2)          !pz-s
      hamil(4,1)=t
      if(dograd)then
        do 13 k=1,natom
	do 13 kk=1,3
           dhamilmb(4,1,k,kk)=dt(k,kk)
 13     continue
      endif

      call xy_mb(i,j,'xz',natom,pps,dpps,ppp,dppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !pz-px
      hamil(4,2)=t
      if(dograd)then
        do 14 k=1,natom
	do 14 kk=1,3
           dhamilmb(4,2,k,kk)=dt(k,kk)
 14      continue
      endif

      call xy_mb(i,j,'yz',natom,pps,dpps,ppp,dppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !pz-py
      hamil(4,3)=t
      if(dograd)then
        do 15 k=1,natom
	do 15 kk=1,3
           dhamilmb(4,3,k,kk)=dt(k,kk)
 15      continue
      endif

      call xx_mb(i,j,'z',natom,pps,dpps,ppp,dppp,t,dt,
     &                        Fmb3,dFmb3,Fmb4,dFmb4)   !pz-pz
      hamil(4,4)=t
      if(dograd)then
        do 16 k=1,natom
	do 16 kk=1,3
           dhamilmb(4,4,k,kk)=dt(k,kk)
 16      continue
      endif

      if(.not.doS)return

      call ss_mb(i,j,Ssss,dSsss,natom,t,dt,Fmb1,dFmb1)             !s-s
      hamil(1,1)=t
      if(dograd)then
        do 21 k=1,natom
	do 21 kk=1,3
           dhamilmb(1,1,k,kk)=dt(k,kk)
 21     continue
      endif

      call sxyz_mb(i,j,'x',natom,Ssps,dSsps,t,dt,Fmb2,dFmb2)       !s-px
      hamil(1,2)=t
      if(dograd)then
        do 22 k=1,natom
	do 22 kk=1,3
           dhamilmb(1,2,k,kk)=dt(k,kk)
 22     continue
      endif

      call sxyz_mb(i,j,'y',natom,Ssps,dSsps,t,dt,Fmb2,dFmb2)       !s-py
      hamil(1,3)=t
      if(dograd)then
        do 23 k=1,natom
	do 23 kk=1,3
           dhamilmb(1,3,k,kk)=dt(k,kk)
 23     continue
      endif

      call sxyz_mb(i,j,'z',natom,Ssps,dSsps,t,dt,Fmb2,dFmb2)       !s-pz
      hamil(1,4)=t
      if(dograd)then
        do 24 k=1,natom
	do 24 kk=1,3
           dhamilmb(1,4,k,kk)=dt(k,kk)
 24     continue
      endif

      call sxyz_mb(i,j,'x',natom,Spss,dSpss,t,dt,Fmb2,dFmb2)       !px-s
      hamil(2,1)=t
      if(dograd)then
        do 25 k=1,natom
	do 25 kk=1,3
           dhamilmb(2,1,k,kk)=dt(k,kk)
 25     continue
      endif

      call xx_mb(i,j,'x',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                              Fmb3,dFmb3,Fmb4,dFmb4)   !px-px
      hamil(2,2)=t
      if(dograd)then
        do 26 k=1,natom
	do 26 kk=1,3
           dhamilmb(2,2,k,kk)=dt(k,kk)
 26     continue
      endif

      call xy_mb(i,j,'xy',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !px-py
      hamil(2,3)=t
      if(dograd)then
        do 27 k=1,natom
	do 27 kk=1,3
           dhamilmb(2,3,k,kk)=dt(k,kk)
 27     continue
      endif

      call xy_mb(i,j,'xz',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !px-pz
      hamil(2,4)=t
      if(dograd)then
        do 28 k=1,natom
	do 28 kk=1,3
           dhamilmb(2,4,k,kk)=dt(k,kk)
 28     continue
      endif

      call sxyz_mb(i,j,'y',natom,Spss,dSpss,t,dt,Fmb2,dFmb2)          !py-s
      hamil(3,1)=t
      if(dograd)then
        do 29 k=1,natom
	do 29 kk=1,3
           dhamilmb(3,1,k,kk)=dt(k,kk)
 29     continue
      endif

      call xy_mb(i,j,'xy',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !py-px
      hamil(3,2)=t
      if(dograd)then
        do 30 k=1,natom
	do 30 kk=1,3
           dhamilmb(3,2,k,kk)=dt(k,kk)
 30     continue
      endif

      call xx_mb(i,j,'y',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                              Fmb3,dFmb3,Fmb4,dFmb4)   !py-py
      hamil(3,3)=t
      if(dograd)then
        do 31 k=1,natom
	do 31 kk=1,3
           dhamilmb(3,3,k,kk)=dt(k,kk)
 31     continue
      endif

      call xy_mb(i,j,'yz',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !py-pz
      hamil(3,4)=t
      if(dograd)then
        do 32 k=1,natom
	do 32 kk=1,3
           dhamilmb(3,4,k,kk)=dt(k,kk)
 32     continue
      endif

      call sxyz_mb(i,j,'z',natom,Spss,dSpss,t,dt,Fmb2,dFmb2)          !pz-s
      hamil(4,1)=t
      if(dograd)then
        do 33 k=1,natom
	do 33 kk=1,3
           dhamilmb(4,1,k,kk)=dt(k,kk)
 33     continue
      endif

      call xy_mb(i,j,'xz',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !pz-px
      hamil(4,2)=t
      if(dograd)then
        do 34 k=1,natom
	do 34 kk=1,3
           dhamilmb(4,2,k,kk)=dt(k,kk)
 34      continue
      endif

      call xy_mb(i,j,'yz',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                               Fmb3,dFmb3,Fmb4,dFmb4)  !pz-py
      hamil(4,3)=t
      if(dograd)then
        do 35 k=1,natom
	do 35 kk=1,3
           dhamilmb(4,3,k,kk)=dt(k,kk)
 35      continue
      endif

      call xx_mb(i,j,'z',natom,Spps,dSpps,Sppp,dSppp,t,dt,
     &                        Fmb3,dFmb3,Fmb4,dFmb4)   !pz-pz
      hamil(4,4)=t
      if(dograd)then
        do 36 k=1,natom
	do 36 kk=1,3
           dhamilmb(4,4,k,kk)=dt(k,kk)
 36      continue
      endif
      end subroutine al_al_hd_mb
c
      subroutine potssshh (r,V,dV,S,dS)
      use basics
      use params
      use grad
      implicit real*8(a-h,o-z) 
      double precision vsip(maxid,2)
      common /vsips/ vsip

      zeta=parZsss(icase,1,1)
      p1=zeta*r
      p2=p1*p1
      c2=1.0d0/3.0d0
      ep=dexp(-p1)
      w=1.0d0+p1+p2*c2
      S=w*ep
      V=-S*vsip(1,1)*parKsss(icase,1,1)

      if(dograd)then
	dw=1.0d0+c2*p1
	dw=dw*zeta
	dep=-zeta*ep
	dS=w*dep+dw*ep
	dV=-dS*vsip(1,1)*parKsss(icase,1,1)
      endif
      end subroutine potssshh
c
      subroutine potsss (r,V,dV,S,dS)
      use basics
      use params
      use grad
      implicit real*8(a-h,o-z) 
      double precision vsip(maxid,2)
      common /vsips/ vsip
      DATA c2,c3,c4,c5,c6/.46666666666666667D+00,.13333333333333333D+00,
     *.266666666666666667D-01,.4444444444444444D-02,.6349206349206D-03/
c
c
      c0=1d0
      c1=1d0
c      c2=7./15.
c      c3=2./15.
c      c4=2./75.
c      c5=1./225.
c      c6=1./1575.
c      zeta=1.3724d0
      zeta=parZsss(icase,3,3)
      p1=zeta*r
      p2=p1*p1
      p3=p2*p1
      p4=p3*p1
      p5=p4*p1
      p6=p5*p1
      ep=dexp(-p1)
      w=c0+p1+p2*c2+p3*c3+p4*c4+p5*c5+p6*c6
      S=w*ep
      V=S*vsip(3,1)*parKsss(icase,3,3)
c vsip(3,1)=0.3902744862

      if(dograd)then
c        dw=1.0d0+p1*c2+p2*c3+p3*c4+p4*c5+p5*c6
        dw=1.0d0+2.0d0*c2*p1+3.0d0*c3*p2+4.0d0*c4*p3
	dw=dw+5.0d0*c5*p4+6.0d0*c6*p5
	dw=dw*zeta
	dep=-zeta*ep
	dS=w*dep+dw*ep
	dV=dS*vsip(3,1)*parKsss(icase,3,3)
      endif
      end subroutine potsss

      subroutine potsps (r,V,dV,S,dS)
      use params
      use basics
      use grad
      implicit real*8(a-h,o-z) 
      double precision vsip(maxid,2)
      common /vsips/ vsip
c      DATA c2,c3,c4,c5,c6/.19245008972988D+00,.92376043070340D-01,
c     *.28226013160382D-01,.62317171912531D-02,.1099714798456D-02/
c
c      c1=1d0
      c1=1d0/dsqrt(27.0d0)
      c2=c1
      c3=(12.0d0/25.0d0)*c1
      c4=(11.0d0/75.0d0)*c1
      c5=(17.0d0/525.d0)*c1
      c6=(1.0d0/175.d0)*c1
c      zeta=1.3638d0
      zeta=parZsps(icase,3,3)
      p1=zeta*r
      p2=p1*p1
      p3=p2*p1
      p4=p3*p1
      p5=p4*p1
      p6=p5*p1
      ep=dexp(-p1)
      w=p1*c1+p2*c2+p3*c3+p4*c4+p5*c5+p6*c6
c MAI: remember that the neg sign in V and in w30310 cancel
      tmp=0.5d0*(vsip(3,1)+vsip(3,2))
c      S=w*ep
      S=-w*ep
      V=S*tmp*parKsps(icase,3,3)

      if(dograd)then
c         dw=c1+p1*c2+p2*c3+p3*c4+p4*c5+p5*c6
         dw=c1+2.0d0*c2*p1+3.0d0*c3*p2+4.0d0*c4*p3
	 dw=dw+5.0d0*c5*p4+6.0d0*c6*p5
	 dw=dw*zeta
         dep=-zeta*ep
c	 dS=w*dep+dw*ep
	 dS=-w*dep+dw*ep
	 dV=dS*tmp*parKsps(icase,3,3)
      endif 
      end subroutine potsps

      subroutine potpps (r,V,dV,S,dS)
      use grad
      use params
      use basics
      implicit real*8(a-h,o-z) 
      double precision vsip(maxid,2)
      common /vsips/ vsip
      
      DATA c2,c3,c4,c5,c6/.36000000000000D+00,.26666666666667D-01,
     *.21587301587302D-01,.82539682539683D-02,.1904761904762D-02/
c
c      c0=-1d0
c      c1=-1d0
c      c2=-9./25.
c      c3=-2./75.
c      c4=34./1575.
c      c5=13./1575.
c      c6=1d0/525
c      zeta=1.3552d0
      zeta=parZpps(icase,3,3)
      p1=zeta*r
      p2=p1*p1
      p3=p2*p1
      p4=p3*p1
      p5=p4*p1
      p6=p5*p1
      ep=dexp(-p1)
      w=-1d0-p1-p2*c2-p3*c3+p4*c4+p5*c5+p6*c6
c      S=w*ep
      S=-w*ep
      V=S*vsip(3,2)*parKpps(icase,3,3)
      if(dograd)then
c        dw=-1d0-p1*c2-p2*c3+p3*c4+p4*c5+p5*c6
        dw=-1.0d0-2.0d0*c2*p1-3.0d0*c3*p2+4.0d0*c4*p3
	dw=dw+5.0d0*c5*p4+6.0d0*c6*p5
	dw=dw*zeta
	dep=-zeta*ep
c	dS=w*dep+dw*ep
	dS=-w*dep+dw*ep
	dV=dS*vsip(3,2)*parKpps(icase,3,3)
      endif
      end subroutine potpps

      subroutine potppp (r,V,dV,S,dS)
      use grad
      use params
      use basics
      implicit real*8(a-h,o-z) 
      double precision vsip(maxid,2)
      common /vsips/ vsip
      DATA c2,c3,c4,c5/.45333333333333D+00,.12000000000000D+00,
     *.19682539682540D-01,.1904761904762D-02/
c
c      c0=1d0
c      c1=1d0
c      c2=34./75.
c      c3=3./25.
c      c4=31./1575
c      c5=1./525
c      zeta=1.3552d0
      zeta=parZppp(icase,3,3)
      p1=zeta*r
      p2=p1*p1
      p3=p2*p1
      p4=p3*p1
      p5=p4*p1
      ep=dexp(-p1)
      w=1d0+p1+p2*c2+p3*c3+p4*c4+p5*c5
      S=w*ep
      V=S*vsip(3,2)*parKppp(icase,3,3)
      if(dograd)then
c        dw=1d0+p1*c2+p2*c3+p3*c4+p4*c5
        dw=1.0+2.0*c2*p1+3.0d0*c3*p2+4.0d0*c4*p3
	dw=dw+5.0d0*c5*p4
	dw=dw*zeta
	dep=-zeta*ep
	dS=w*dep+dw*ep
	dV=dS*vsip(3,2)*parKppp(icase,3,3)
      endif
      end subroutine potppp
 

c      subroutine alalrp (ip,r,repul,drepul)
c      use grad
c      use params
c      implicit none
c      integer ip
c      double precision A,u,B,dt,r,repul,drepul(3)
c      double precision el,em,en,elladmm,ellmimm,enn
c      common /lmn/ el,em,en,elladmm,ellmimm,enn
cc
cc Repulsive parameters for two same transition metal atom.
cc
c      A=parA(icase,3,3)
c      u=paru(icase,3,3)
c      B=parB(icase,3,3)
c      call grepfm (A,B,u,r,repul,dt)
c      if(dograd)then
c         drepul(1)=dt*el
c         drepul(2)=dt*em
c         drepul(3)=dt*en
c      endif
c      end subroutine alalrp

      subroutine genrrp(ip,jp,r,repul,drepul)
      use grad
      use params
      implicit none
      integer ip,jp,n1,n2
      double precision A,u,B,dt,r,repul,drepul(3)
      double precision l,m,n,elladmm,ellmimm,enn
      double precision ecore,r0,ma,mb,rc,mcc
      common /lmn/ l,m,n,elladmm,ellmimm,enn
c
c Repulsive parameters for two same transition metal atom.
c
      n1=min(ip,jp)
      n2=max(ip,jp)
      select case(icase)
      case(25)
        if((ip.eq.1).and.(jp.eq.1))then
c MAI: Tiqing's paramters converted to au for TBPAC
c MAI: parameters taken from TB1.0.1/h_h_rp.f
            r0=1.4010d0
            rc=2.196d0
cMAI: In Tiqing's thesis, it would appear that ecore=5.294 eV
c            DATA ecore/4.279D0/
            ecore=0.1572d0
            ma=2.436d0
            mb=3.309d0
            mcc=3.653d0
            call wangma(r,ecore,r0,ma,mb,rc,mcc,repul,dt)
            if(dograd)then
	      drepul(1)=dt*l
              drepul(2)=dt*m
              drepul(3)=dt*n
	    endif
	  elseif((n1.eq.1).and.(n2.eq.2))then
c MAI: Tiqing's paramters converted to au for TBPAC
c MAI: parameters taken from TB1.0.1/chhcrp.f
            r0=3.59d0
            rc=2.06d0
cMAI: In Tiqing's thesis, it would appear that ecore=9.084 eV
c            DATA ecore/9.086D0/
            ecore=0.33390d0
            ma=3.1d0
            mb=3.1d0
            mcc=10.0d0
            call wangma(r,ecore,r0,ma,mb,rc,mcc,repul,dt)
            if(dograd)then
	      drepul(1)=dt*l
              drepul(2)=dt*m
              drepul(3)=dt*n
	    endif
	  elseif((n1.eq.2).and.(n2.eq.2))then
c MAI: Tiqing's paramters converted to au for TBPAC
c MAI: parameters taken from TB1.0.1/c_c_rp.f
            r0=2.479d0
            rc=3.59d0
            ecore=0.74806d0
            ma=2.72405d0
            mb=1.0d0
            mcc=7.00d0
            call wangma(r,ecore,r0,ma,mb,rc,mcc,repul,dt)
            if(dograd)then
	      drepul(1)=dt*l
              drepul(2)=dt*m
              drepul(3)=dt*n
	    endif
	  elseif(((n1.le.2).and.(n2.ge.4)).or.
     *       ((n1.eq.n2).and.(n1.ge.4)))then
            A=parA(icase,n1,n2)
            u=paru(icase,n1,n2)
            B=parB(icase,n1,n2)
            call grepfm (A,B,u,r,repul,dt)
            if(dograd)then
	      drepul(1)=dt*l
              drepul(2)=dt*m
              drepul(3)=dt*n
	    endif
	  else
	     Stop 'Repulsion parameters not defined.'
	  endif
      case default
        A=parA(icase,n1,n2)
        u=paru(icase,n1,n2)
        B=parB(icase,n1,n2)
        call grepfm (A,B,u,r,repul,dt)
        if(dograd)then
           drepul(1)=dt*l
           drepul(2)=dt*m
           drepul(3)=dt*n
        endif
      end select
      end subroutine genrrp

      subroutine genrrp_mb(i,j,natom,x,y,z,r,idtype,repul,drepul,
     *   Fcng,dFcng)
      use grad
      use params
      implicit none
      integer ip,jp,n1,n2,i,j,natom,idtype(natom),n
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom)
      double precision Fmb,dFmb(natom,3)
      double precision A,u,B,dt,rr,repul,drepul(natom,3)
      double precision el,em,en,elladmm,ellmimm,enn
      double precision Fcng(natom),dFcng(natom,natom,3)
      common /lmn/ el,em,en,elladmm,ellmimm,enn
c
c Repulsive parameters for two same transition metal atom.
c
      ip=idtype(i)
      jp=idtype(j)
      rr=r(i,j)
      n1=min(ip,jp)
      n2=max(ip,jp)
      A=parA(icase,n1,n2)
      u=paru(icase,n1,n2)
      B=parB(icase,n1,n2)
      drepul=0.0d0

      call grepfm(A,B,u,rr,repul,dt)
      call doFMB(i,j,natom,x,y,z,r,idtype,5,Fmb,dFmb,Fcng,dFcng)
      repul=repul*Fmb
      if(dograd)then
         drepul=0.0d0
         call lmndlm(i,j,natom,x,y,z,r)
	 drepul(i,1)=dt*el*Fmb
	 drepul(i,2)=dt*em*Fmb
	 drepul(i,3)=dt*en*Fmb
	 drepul(j,1)=drepul(j,1)-dt*el*Fmb
	 drepul(j,2)=drepul(j,2)-dt*em*Fmb
	 drepul(j,3)=drepul(j,3)-dt*en*Fmb
	 if(flag(2))then
	 do 1 n=1,natom
             drepul(n,1)=drepul(n,1)+repul*dFmb(n,1)
             drepul(n,2)=drepul(n,2)+repul*dFmb(n,2)
             drepul(n,3)=drepul(n,3)+repul*dFmb(n,3)
 1       continue
         endif
      endif
      end subroutine genrrp_mb

      subroutine grepfm (A,B,u,r,V,dV)
      use grad
      use params
      implicit none
      double precision A,B,u,r,V,dV,t1,t2

      select case(icase)
      case(25)
        t1=A*dexp(-B*r)
        V=(1.0d0/r+u)*t1
	if(dograd)dV=-t1/r/r-B*V
      case default
        if(u.ge.1.0d-5)then
           t1=dexp(-B*r)
           t2=A/(r**u)
           V=t1*t2
           if(dograd)dV=-V*((u/R)+B)
        else
           V=A*dexp(-B*r)
  	   if(dograd)dV=-B*V
        endif
      end select
      
      end subroutine grepfm

      subroutine ss(sss,dsss,hamil,dhamil)

      implicit none
      double precision sss,dsss,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      common /lmn/ l,m,n,lladmm,llmimm,nn
c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c 
      hamil=sss
      dhamil(1)=dsss*l
      dhamil(2)=dsss*m
      dhamil(3)=dsss*n
      end subroutine ss
c
      subroutine ss_mb(i,j,sss,dsss,natom,hamil,dhamil,Fmb,dFmb)

      use grad
      implicit none
      integer natom,i,j,k
      double precision sss,dsss,hamil,dhamil(natom,3)
      double precision Fmb,dFmb(natom,3)
      double precision l,m,n,lladmm,llmimm,nn
      common /lmn/ l,m,n,lladmm,llmimm,nn
c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c 
      hamil=sss*Fmb
      if(dograd)then
c        dhamil=dFmb*sss
	do k=1,natom
	 dhamil(k,1)=dFmb(k,1)*sss
	 dhamil(k,2)=dFmb(k,2)*sss
	 dhamil(k,3)=dFmb(k,3)*sss
        enddo
	dhamil(i,1)=dhamil(i,1)+dsss*l*Fmb
	dhamil(i,2)=dhamil(i,2)+dsss*m*Fmb
	dhamil(i,3)=dhamil(i,3)+dsss*n*Fmb
	dhamil(j,1)=dhamil(j,1)-dsss*l*Fmb
	dhamil(j,2)=dhamil(j,2)-dsss*m*Fmb
	dhamil(j,3)=dhamil(j,3)-dsss*n*Fmb
      endif
      end subroutine ss_mb
c

      subroutine sxyz(c,sps,dsps,hamil,dhamil)
      implicit none
      character*1 c
      double precision sps,dsps,el,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,dx,dy,dz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if(c.eq.'x') then
        el=l
        dx=dlx
        dy=dly
        dz=dlz
      else if(c.eq.'y')then
        el=m
        dx=dmx
        dy=dmy
        dz=dmz
      else if(c.eq.'z')then
        el=n
        dx=dnx
        dy=dny
        dz=dnz
      else
        stop "Wrong in subroutine sxyz."
      endif
c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c 

      hamil=el*sps

      dhamil(1)=el*dsps*l+dx*sps
      dhamil(2)=el*dsps*m+dy*sps
      dhamil(3)=el*dsps*n+dz*sps
      end subroutine sxyz
c
      subroutine sxyz_mb(i,j,c,natom,sps,dsps,hamil,dhamil,Fmb,dFmb)
      use grad
      implicit none
      character*1 c
      integer natom,i,j,k
      double precision sps,dsps,el,hamil,dhamil(natom,3)
      double precision Fmb,dFmb(natom,3)
      double precision l,m,n,lladmm,llmimm,nn,dx,dy,dz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if(c.eq.'x') then
        el=l
        dx=dlx
        dy=dly
        dz=dlz
      else if(c.eq.'y')then
        el=m
        dx=dmx
        dy=dmy
        dz=dmz
      else if(c.eq.'z')then
        el=n
        dx=dnx
        dy=dny
        dz=dnz
      else
        stop "Wrong in subroutine sxyz."
      endif
c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c 

      hamil=el*sps*Fmb

      if(dograd)then
        do k=1,natom
	   dhamil(k,1)=el*sps*dFmb(k,1)
	   dhamil(k,2)=el*sps*dFmb(k,2)
	   dhamil(k,3)=el*sps*dFmb(k,3)
        enddo
	dhamil(i,1)=dhamil(i,1)+(el*dsps*l+dx*sps)*Fmb
	dhamil(i,2)=dhamil(i,2)+(el*dsps*m+dy*sps)*Fmb
	dhamil(i,3)=dhamil(i,3)+(el*dsps*n+dz*sps)*Fmb
	dhamil(j,1)=dhamil(j,1)-(el*dsps*l+dx*sps)*Fmb
	dhamil(j,2)=dhamil(j,2)-(el*dsps*m+dy*sps)*Fmb
	dhamil(j,3)=dhamil(j,3)-(el*dsps*n+dz*sps)*Fmb
      endif

      end subroutine sxyz_mb
c
      subroutine xx(c,pps,dpps,ppp,dppp,hamil,dhamil)
      implicit none
      character*1 c
      double precision pps,dpps,ppp,dppp,el,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,temp,dtemp
      double precision delx,dely,delz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if(c(1:1).eq.'x') then
        el=l
        delx=dlx
        dely=dly
        delz=dlz
      else if(c(1:1).eq.'y')then
        el=m
        delx=dmx
        dely=dmy
        delz=dmz
      else if(c(1:1).eq.'z') then
        el=n
        delx=dnx
        dely=dny
        delz=dnz
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      temp=pps-ppp
      dtemp=dpps-dppp

      hamil=el*el*temp+ppp

      dhamil(1)=2.0*el*delx*temp+(el*el*dtemp+dppp)*l
      dhamil(2)=2.0*el*dely*temp+(el*el*dtemp+dppp)*m
      dhamil(3)=2.0*el*delz*temp+(el*el*dtemp+dppp)*n

      end subroutine xx
c
      subroutine xx_mb(i,j,c,natom,pps,dpps,ppp,dppp,hamil,dhamil,
     &  Fmb3,dFmb3,Fmb4,dFmb4)
      use grad
      implicit none
      character*1 c
      integer natom,k,i,j,mm
      double precision pps,dpps,ppp,dppp,el,hamil,dhamil(natom,3)
      double precision Fmb3,dFmb3(natom,3)
      double precision Fmb4,dFmb4(natom,3)
      double precision l,m,n,lladmm,llmimm,nn,temp,dt,dtemp(3)
      double precision delx,dely,delz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if(c(1:1).eq.'x')then
        el=l
        delx=dlx
        dely=dly
        delz=dlz
      elseif(c(1:1).eq.'y')then
        el=m
        delx=dmx
        dely=dmy
        delz=dmz
      elseif(c(1:1).eq.'z')then
        el=n
        delx=dnx
        dely=dny
        delz=dnz
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      temp=pps*Fmb3-ppp*Fmb4

      hamil=el*el*temp+ppp*Fmb4

      if(dograd)then
      
      do k=1,natom
      do mm=1,3
         dhamil(k,mm)=el*el*(pps*dFmb3(k,mm)-ppp*dFmb4(k,mm))
     *      +ppp*dFmb4(k,mm)
      enddo
      enddo
      dhamil(i,1)=dhamil(i,1)+2.0d0*el*delx*temp+(dppp*Fmb4+
     +  el*el*(dpps*Fmb3-dppp*Fmb4))*l
      dhamil(i,2)=dhamil(i,2)+2.0d0*el*dely*temp+(dppp*Fmb4+
     +  el*el*(dpps*Fmb3-dppp*Fmb4))*m
      dhamil(i,3)=dhamil(i,3)+2.0d0*el*delz*temp+(dppp*Fmb4+
     +  el*el*(dpps*Fmb3-dppp*Fmb4))*n
      dhamil(j,1)=dhamil(j,1)-2.0d0*el*delx*temp-(dppp*Fmb4+
     +  el*el*(dpps*Fmb3-dppp*Fmb4))*l
      dhamil(j,2)=dhamil(j,2)-2.0d0*el*dely*temp-(dppp*Fmb4+
     +  el*el*(dpps*Fmb3-dppp*Fmb4))*m
      dhamil(j,3)=dhamil(j,3)-2.0d0*el*delz*temp-(dppp*Fmb4+
     +  el*el*(dpps*Fmb3-dppp*Fmb4))*n
      endif 

      end subroutine xx_mb
c
      subroutine xy(c,pps,dpps,ppp,dppp,hamil,dhamil)
      implicit none
      character*2 c
      double precision pps,dpps,ppp,dppp,el,em,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,temp,dtemp
      double precision delx,dely,delz,demx,demy,demz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if(c(1:1).eq.'x') then
        if(c(2:2).eq.'y') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
        else if(c(2:2).eq.'z') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      else if(c(1:1).eq.'y')then
        if(c(2:2).eq.'z') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      endif

      temp=pps-ppp
      dtemp=dpps-dppp

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      hamil=el*em*temp

      dhamil(1)=(delx*em+el*demx)*temp+el*em*dtemp*l
      dhamil(2)=(dely*em+el*demy)*temp+el*em*dtemp*m
      dhamil(3)=(delz*em+el*demz)*temp+el*em*dtemp*n

      end subroutine xy

      subroutine xy_mb(i,j,c,natom,pps,dpps,ppp,dppp,hamil,dhamil,
     &  Fmb3,dFmb3,Fmb4,dFmb4)
      use grad
      implicit none
      character*2 c
      integer natom,k,i,j,mm
      double precision pps,dpps,ppp,dppp,el,em,hamil,dhamil(natom,3)
      double precision Fmb3,dFmb3(natom,3)
      double precision Fmb4,dFmb4(natom,3)
      double precision l,m,n,lladmm,llmimm,nn,temp,dtemp,dt
      double precision delx,dely,delz,demx,demy,demz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if(c(1:1).eq.'x') then
        if(c(2:2).eq.'y') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
        else if(c(2:2).eq.'z') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      else if(c(1:1).eq.'y')then
        if(c(2:2).eq.'z') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
      temp=pps*Fmb3-ppp*Fmb4

      hamil=el*em*temp

      if(dograd)then

      do k=1,natom
      do mm=1,3
        dhamil(k,mm)=el*em*(pps*dFmb3(k,mm)-ppp*dFmb4(k,mm))
      enddo
      enddo

      dhamil(i,1)=dhamil(i,1)+temp*(el*demx+em*delx)
      dhamil(i,2)=dhamil(i,2)+temp*(el*demy+em*dely)
      dhamil(i,3)=dhamil(i,3)+temp*(el*demz+em*delz)
      dhamil(j,1)=dhamil(j,1)-temp*(el*demx+em*delx)
      dhamil(j,2)=dhamil(j,2)-temp*(el*demy+em*dely)
      dhamil(j,3)=dhamil(j,3)-temp*(el*demz+em*delz)

      dhamil(i,1)=dhamil(i,1)+el*em*(dpps*Fmb3-dppp*Fmb4)*l
      dhamil(i,2)=dhamil(i,2)+el*em*(dpps*Fmb3-dppp*Fmb4)*m
      dhamil(i,3)=dhamil(i,3)+el*em*(dpps*Fmb3-dppp*Fmb4)*n
      dhamil(j,1)=dhamil(j,1)-el*em*(dpps*Fmb3-dppp*Fmb4)*l
      dhamil(j,2)=dhamil(j,2)-el*em*(dpps*Fmb3-dppp*Fmb4)*m
      dhamil(j,3)=dhamil(j,3)-el*em*(dpps*Fmb3-dppp*Fmb4)*n
      endif

      end subroutine xy_mb

c
c This is a subroutine to compute the overlap integral between s
c orbital and dxy (dyz or dzx) orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c sds is the two-center integral between the s orbital and d orbital when the
c line connecting the two atoms is the z axis, and dpps is the first derivative
c of sds with respect to the distance between the two atoms.
c
c In sds the first s means s orbital (angular quantum number is 0),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c For the input the character c is xy, yz, and zx reprenting the overlap
c integral between s orbital and dxy, or dyz, or dzx respectively.
c

      subroutine sxy(c,sds,dsds,hamil,dhamil)

      implicit none
      character*2 c
      double precision sds,dsds,el,em,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,sqrt3
      double precision delx,dely,delz,demx,demy,demz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(sqrt3=1.73205080757d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c      sqrt3=sqrt(3.0)

      if(c(1:1).eq.'x') then
        if(c(2:2).eq.'y') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
        endif
      else if(c(1:1).eq.'y')then
        if(c(2:2).eq.'z') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      else if(c(1:1).eq.'z') then
        if(c(2:2).eq.'x') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      hamil=sqrt3*el*em*sds

      dhamil(1)=sqrt3*((delx*em+el*demx)*sds+el*em*dsds*l)
      dhamil(2)=sqrt3*((dely*em+el*demy)*sds+el*em*dsds*m)
      dhamil(3)=sqrt3*((delz*em+el*demz)*sds+el*em*dsds*n)

      end subroutine sxy

c
c This is a subroutine to compute the overlap integral between s
c orbital and dxxyy orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In sds the first s means s orbital (angular quantum number is 0),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c

      subroutine sxxyy(sds,dsds,hamil,dhamil)

      implicit none
      double precision sds,dsds,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you want to compute the integral between dxxyy and s, just replace 
c sds and dsds with dss and dsss.
c

c      hsqrt3=sqrt(3.0)/2.0

      hamil=hsqrt3*llmimm*sds

      dhamil(1)=hsqrt3*(llmimm*dsds*l+2.0*(l*dlx-m*dmx)*sds)
      dhamil(2)=hsqrt3*(llmimm*dsds*m+2.0*(l*dly-m*dmy)*sds)
      dhamil(3)=hsqrt3*(llmimm*dsds*n+2.0*(l*dlz-m*dmz)*sds)

      end subroutine sxxyy

c
c This is a subroutine to compute the overlap integral between s
c orbital and dxxyy orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In sds the first s means s orbital (angular quantum number is 0),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c

      subroutine szz (sds,dsds,hamil,dhamil)

      implicit none
      double precision sds,dsds,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you want to compute the integral between dxxyy and s, just replace
c sds and dsds with dss and dsss.
c

      hamil=(1.5*nn-0.5)*sds

      dhamil(1)=(1.5*nn-0.5)*dsds*l+3.0*n*dnx*sds
      dhamil(2)=(1.5*nn-0.5)*dsds*m+3.0*n*dny*sds
      dhamil(3)=(1.5*nn-0.5)*dsds*n+3.0*n*dnz*sds

      end subroutine szz

c
c This is a subroutine to compute the overlap integral between px (py, pz)
c orbital and dxy(dyz or dzx) orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c For the input the character c is xy, xz, yz, yx, zy, and zx reprenting the 
c overlap integral between px and dxy, px and dzx, py and dxy, py and dyz, 
c pz and dyz, and pz and dzx respectively.
c

      subroutine xxy(c,pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      character*2 c
      double precision pds,dpds,pdp,dpdp,el,em,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,sqrt3,tmp,dtmp
      double precision delx,dely,delz,demx,demy,demz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(sqrt3=1.73205080757d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c      sqrt3=dsqrt(3.0d0)

      if(c(1:1).eq.'x') then
        if(c(2:2).eq.'y') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
        else if(c(2:2).eq.'z') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
      else if(c(1:1).eq.'y')then
        if(c(2:2).eq.'z') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
        endif
        if(c(2:2).eq.'x') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=l
          demx=dlx
          demy=dly
          demz=dlz
        endif
      else if(c(1:1).eq.'z')then
        if(c(2:2).eq.'y') then
          el=n
          delx=dnx
          dely=dny
          delz=dnz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
        endif
        if(c(2:2).eq.'x') then
          el=n
          delx=dnx
          dely=dny
          delz=dnz
          em=l
          demx=dlx
          demy=dly
          demz=dlz
        endif
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dxy and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

      tmp=sqrt3*pds-2.0*pdp
      dtmp=sqrt3*dpds-2.0*dpdp

      hamil=em*(el*el*tmp+pdp)

      dhamil(1)=demx*(el*el*tmp+pdp)+em*(2.0*el*delx*tmp
     +    +(el*el*dtmp+dpdp)*l)    

      dhamil(2)=demy*(el*el*tmp+pdp)+em*(2.0*el*dely*tmp
     +    +(el*el*dtmp+dpdp)*m)    

      dhamil(3)=demz*(el*el*tmp+pdp)+em*(2.0*el*delz*tmp
     +    +(el*el*dtmp+dpdp)*n)    

      end subroutine xxy

c
c This is a subroutine to compute the overlap integral between px (py, pz)
c orbital and px (py or pz) orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c This is for px and dyz, py and dzx, or pz and dxy.
c

      subroutine xyz(pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      double precision pds,dpds,pdp,dpdp,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,sqrt3,temp,dtemp
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(sqrt3=1.73205080757d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dyz and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      sqrt3=sqrt(3.0)

      temp=sqrt3*pds-2.0*pdp
      dtemp=sqrt3*dpds-2.0*dpdp

      hamil=l*m*n*temp

      dhamil(1)=(dlx*m*n+l*dmx*n+l*m*dnx)*temp+l*m*n*dtemp*l
      dhamil(2)=(dly*m*n+l*dmy*n+l*m*dny)*temp+l*m*n*dtemp*m
      dhamil(3)=(dlz*m*n+l*dmz*n+l*m*dnz)*temp+l*m*n*dtemp*n

      end subroutine xyz

c
c This is a subroutine to compute the overlap integral between px
c orbital and dx2-y2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c

      subroutine xxxyy(pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      double precision pds,dpds,pdp,dpdp,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3,tmp,dtmp
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      hsqrt3=sqrt(3.0)/2.0

      tmp=hsqrt3*pds-pdp
      dtmp=hsqrt3*dpds-dpdp

      hamil=l*(llmimm*tmp+pdp)

      dhamil(1)=dlx*(llmimm*tmp+pdp)+l*(2.0*(l*dlx-m*dmx)*tmp
     +    +(llmimm*dtmp+dpdp)*l)

      dhamil(2)=dly*(llmimm*tmp+pdp)+l*(2.0*(l*dly-m*dmy)*tmp
     +    +(llmimm*dtmp+dpdp)*m)

      dhamil(3)=dlz*(llmimm*tmp+pdp)+l*(2.0*(l*dlz-m*dmz)*tmp
     +    +(llmimm*dtmp+dpdp)*n)

      end subroutine xxxyy

c
c This is a subroutine to compute the overlap integral between px (or py)
c orbital and dz2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c The input character c with x, y representing px, py with dz2.
c

      subroutine xzz(c,pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      character*1 c
      double precision pds,dpds,pdp,dpdp,el,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,delx,dely,delz,sqrt3
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz,tmp,dtmp
      parameter(sqrt3=1.73205080757d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if (c.eq.'x') then
        el=l
        delx=dlx
        dely=dly
        delz=dlz
      else if (c.eq.'y') then
        el=m
        delx=dmx
        dely=dmy
        delz=dmz
      else
        stop "Wrong for input to subroutine xzz."
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dz2 and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      sqrt3=sqrt(3.0)

      tmp=1.5*pds-sqrt3*pdp
      dtmp=1.5*dpds-sqrt3*dpdp

      hamil=el*(nn*tmp-0.5*pds)

      dhamil(1)=delx*(nn*tmp-0.5*pds)+el*(2.0*n*dnx*tmp
     +    +(nn*dtmp-0.5*dpds)*l)

      dhamil(2)=dely*(nn*tmp-0.5*pds)+el*(2.0*n*dny*tmp
     +    +(nn*dtmp-0.5*dpds)*m)

      dhamil(3)=delz*(nn*tmp-0.5*pds)+el*(2.0*n*dnz*tmp
     +    +(nn*dtmp-0.5*dpds)*n)

      end subroutine xzz

c
c This is a subroutine to compute the overlap integral between py
c orbital and dx2-y2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c

      subroutine yxxyy(pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      double precision pds,dpds,pdp,dpdp,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3,tmp,dtmp
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and py replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      hsqrt3=sqrt(3.0)/2.0

      tmp=hsqrt3*pds-pdp
      dtmp=hsqrt3*dpds-dpdp

      hamil=m*(llmimm*tmp-pdp)

      dhamil(1)=dmx*(llmimm*tmp-pdp)+m*(2.0*(l*dlx-m*dmx)*tmp
     +    +(llmimm*dtmp-dpdp)*l)

      dhamil(2)=dmy*(llmimm*tmp-pdp)+m*(2.0*(l*dly-m*dmy)*tmp
     +    +(llmimm*dtmp-dpdp)*m)

      dhamil(3)=dmz*(llmimm*tmp-pdp)+m*(2.0*(l*dlz-m*dmz)*tmp
     +    +(llmimm*dtmp-dpdp)*n)

      end subroutine yxxyy

c
c This is a subroutine to compute the overlap integral between pz
c orbital and dx2-y2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c

      subroutine zxxyy(pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      double precision pds,dpds,pdp,dpdp,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3,temp,dtemp
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and pz replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      hsqrt3=sqrt(3.0)/2.0

      temp=hsqrt3*pds-pdp
      dtemp=hsqrt3*dpds-dpdp

      hamil=n*llmimm*temp

      dhamil(1)=(dnx*llmimm+n*2.0*(l*dlx-m*dmx))*temp+n*llmimm*dtemp*l
      dhamil(2)=(dny*llmimm+n*2.0*(l*dly-m*dmy))*temp+n*llmimm*dtemp*m
      dhamil(3)=(dnz*llmimm+n*2.0*(l*dlz-m*dmz))*temp+n*llmimm*dtemp*n

      end subroutine zxxyy

c
c This is a subroutine to compute the overlap integral between pz
c orbital and dz2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In pds the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In pdp the first p means p orbital (angular quantum number is 1),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c

      subroutine zzz(pds,dpds,pdp,dpdp,hamil,dhamil)

      implicit none
      double precision pds,dpds,pdp,dpdp,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,sqrt3,tmp,dtmp
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      parameter(sqrt3=1.73205080757d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      sqrt3=sqrt(3.0)

      tmp=-0.5*pds+sqrt3*pdp
      dtmp=-0.5*dpds+sqrt3*dpdp

      hamil=n*(nn*pds+lladmm*tmp)

      dhamil(1)=dnx*(nn*pds+lladmm*tmp)+n*((nn*dpds+lladmm*dtmp)*l
     +    +2.0*(n*dnx*pds+(l*dlx+m*dmx)*tmp))

      dhamil(2)=dny*(nn*pds+lladmm*tmp)+n*((nn*dpds+lladmm*dtmp)*m
     +    +2.0*(n*dny*pds+(l*dly+m*dmy)*tmp))

      dhamil(3)=dnz*(nn*pds+lladmm*tmp)+n*((nn*dpds+lladmm*dtmp)*n
     +    +2.0*(n*dnz*pds+(l*dlz+m*dmz)*tmp))

      end subroutine zzz

c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dxy orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c
c Character c xy representing dxy and dxy, yz dyz and dyz, zx dzx and dzx.
c

      subroutine xyxy(c,dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      character*2 c
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,el,em,en
      double precision delx,dely,delz,demx,demy,demz,denx,deny,denz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,tmpb,dtmpa,dtmpb

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if (c(1:2).eq.'xy') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
          en=n
          denx=dnx
          deny=dny
          denz=dnz
      else if (c(1:2).eq.'yz') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
          en=l
          denx=dlx
          deny=dly
          denz=dlz
      else if (c(1:2).eq.'zx') then
          el=n
          delx=dnx
          dely=dny
          delz=dnz
          em=l
          demx=dlx
          demy=dly
          demz=dlz
          en=m
          denx=dmx
          deny=dmy
          denz=dmz
      else
        stop "Wrong for input to subroutine xyxy."
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

      tmpa=3.0*dds-4.0*ddp+ddd
      dtmpa=3.0*ddds-4.0*dddp+dddd
      tmpb=ddp-ddd
      dtmpb=dddp-dddd

      hamil=el*el*em*em*tmpa+(el*el+em*em)*tmpb+ddd

      dhamil(1)=2.0*(el*delx*em*em+el*el*em*demx)*tmpa
     +         +(el*el*em*em*dtmpa+dddd+(el*el+em*em)*dtmpb)*l
     +         +2.0*(el*delx+em*demx)*tmpb

      dhamil(2)=2.0*(el*dely*em*em+el*el*em*demy)*tmpa
     +         +(el*el*em*em*dtmpa+dddd+(el*el+em*em)*dtmpb)*m
     +         +2.0*(el*dely+em*demy)*tmpb

      dhamil(3)=2.0*(el*delz*em*em+el*el*em*demz)*tmpa
     +         +(el*el*em*em*dtmpa+dddd+(el*el+em*em)*dtmpb)*n
     +         +2.0*(el*delz+em*demz)*tmpb

      end subroutine xyxy

c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dyz orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c
c Character c xz representing dxy and dyz or dyz and dxy, yz dxy and dzx or 
c dzx and dxy, xy dyz and dzx or dzx and dyz.
c

      subroutine xyyz (c,dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      character*2 c
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,el,em,en
      double precision delx,dely,delz,demx,demy,demz,denx,deny,denz
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,tmpb,dtmpa,dtmpb

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      if (c(1:2).eq.'xz'.or.c(1:2).eq.'zx') then
          el=l
          delx=dlx
          dely=dly
          delz=dlz
          em=m
          demx=dmx
          demy=dmy
          demz=dmz
          en=n
          denx=dnx
          deny=dny
          denz=dnz
      else if (c(1:2).eq.'zy'.or.c(1:2).eq.'yz') then
          el=n
          delx=dnx
          dely=dny
          delz=dnz
          em=l
          demx=dlx
          demy=dly
          demz=dlz
          en=m
          denx=dmx
          deny=dmy
          denz=dmz
      else if (c(1:2).eq.'yx'.or.c(1:2).eq.'xy') then
          el=m
          delx=dmx
          dely=dmy
          delz=dmz
          em=n
          demx=dnx
          demy=dny
          demz=dnz
          en=l
          denx=dlx
          deny=dly
          denz=dlz
      else
        stop "Wrong for input to subroutine xyyz."
      endif

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      tmpa=3.0*dds-4.0*ddp+ddd
      dtmpa=3.0*ddds-4.0*dddp+dddd
      tmpb=ddp-ddd
      dtmpb=dddp-dddd

      hamil=el*en*(em*em*tmpa+tmpb)

      dhamil(1)=(delx*en+el*denx)*(em*em*tmpa+tmpb)
     +    +el*en*(2.0*em*demx*tmpa+(em*em*dtmpa+dtmpb)*l)

      dhamil(2)=(dely*en+el*deny)*(em*em*tmpa+tmpb)
     +    +el*en*(2.0*em*demy*tmpa+(em*em*dtmpa+dtmpb)*m)

      dhamil(3)=(delz*en+el*denz)*(em*em*tmpa+tmpb)
     +    +el*en*(2.0*em*demz*tmpa+(em*em*dtmpa+dtmpb)*n)

      end subroutine xyyz

c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dx2_y2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine xyxxyy (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      tmpa=1.5*dds-2.0*ddp+0.5*ddd
      dtmpa=1.5*ddds-2.0*dddp+0.5*dddd

      hamil=l*m*llmimm*tmpa

      dhamil(1)=(dlx*m*llmimm+l*dmx*llmimm+l*m*2.0*(l*dlx-m*dmx))*tmpa
     +    +l*m*llmimm*dtmpa*l

      dhamil(2)=(dly*m*llmimm+l*dmy*llmimm+l*m*2.0*(l*dly-m*dmy))*tmpa
     +    +l*m*llmimm*dtmpa*m

      dhamil(3)=(dlz*m*llmimm+l*dmz*llmimm+l*m*2.0*(l*dlz-m*dmz))*tmpa
     +    +l*m*llmimm*dtmpa*n

      end subroutine xyxxyy

c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dz2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine xyzz (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

c      hsqrt3=sqrt(3.0)/2.0

      tmpa=hsqrt3*(3.0*dds-4.0*ddp+ddd)
      dtmpa=hsqrt3*(3.0*ddds-4.0*dddp+dddd)
      tmpb=hsqrt3*(dds-ddd)
      dtmpb=hsqrt3*(ddds-dddd)

      hamil=l*m*(nn*tmpa-tmpb)

      dhamil(1)=(dlx*m+l*dmx)*(nn*tmpa-tmpb)
     +  +l*m*(2.0*n*dnx*tmpa+(nn*dtmpa-dtmpb)*l)

      dhamil(2)=(dly*m+l*dmy)*(nn*tmpa-tmpb)
     +  +l*m*(2.0*n*dny*tmpa+(nn*dtmpa-dtmpb)*m)

      dhamil(3)=(dlz*m+l*dmz)*(nn*tmpa-tmpb)
     +  +l*m*(2.0*n*dnz*tmpa+(nn*dtmpa-dtmpb)*n)

      end subroutine xyzz

c
c This is a subroutine to compute the overlap integral between dyz
c orbital and dx2_y2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine yzxxyy (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

      tmpa=1.5*dds-2.0*ddp+0.5*ddd
      dtmpa=1.5*ddds-2.0*dddp+0.5*dddd
      tmpb=ddp-ddd
      dtmpb=dddp-dddd

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      hamil=m*n*(llmimm*tmpa-tmpb)

      dhamil(1)=(dmx*n+m*dnx)*(llmimm*tmpa-tmpb)
     +    +m*n*(2.0*(l*dlx-m*dmx)*tmpa+(llmimm*dtmpa-dtmpb)*l)

      dhamil(2)=(dmy*n+m*dny)*(llmimm*tmpa-tmpb)
     +    +m*n*(2.0*(l*dly-m*dmy)*tmpa+(llmimm*dtmpa-dtmpb)*m)

      dhamil(3)=(dmz*n+m*dnz)*(llmimm*tmpa-tmpb)
     +    +m*n*(2.0*(l*dlz-m*dmz)*tmpa+(llmimm*dtmpa-dtmpb)*n)

      end subroutine yzxxyy

c
c This is a subroutine to compute the overlap integral between dyz
c orbital and dz2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine yzzz (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

c      hsqrt3=sqrt(3.0)/2.0

      tmpa=-hsqrt3*(3.0*dds-4.0*ddp+ddd)
      dtmpa=-hsqrt3*(3.0*ddds-4.0*dddp+dddd)
      tmpb=hsqrt3*(dds-ddp)*2.0
      dtmpb=hsqrt3*(ddds-dddp)*2.0

      hamil=m*n*(lladmm*tmpa+tmpb)

      dhamil(1)=(dmx*n+m*dnx)*(lladmm*tmpa+tmpb)
     +  +m*n*(2.0*(l*dlx+m*dmx)*tmpa+(lladmm*dtmpa+dtmpb)*l)

      dhamil(2)=(dmy*n+m*dny)*(lladmm*tmpa+tmpb)
     +  +m*n*(2.0*(l*dly+m*dmy)*tmpa+(lladmm*dtmpa+dtmpb)*m)

      dhamil(3)=(dmz*n+m*dnz)*(lladmm*tmpa+tmpb)
     +  +m*n*(2.0*(l*dlz+m*dmz)*tmpa+(lladmm*dtmpa+dtmpb)*n)

      end subroutine yzzz
c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dxy orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine zxxxyy (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      tmpa=1.5*dds-2.0*ddp+0.5*ddd
      dtmpa=1.5*ddds-2.0*dddp+0.5*dddd
      tmpb=ddp-ddd
      dtmpb=dddp-dddd

      hamil=n*l*(llmimm*tmpa+tmpb)

      dhamil(1)=(dnx*l+n*dlx)*(llmimm*tmpa+tmpb)
     +    +n*l*(2.0*(l*dlx-m*dmx)*tmpa+(llmimm*dtmpa+dtmpb)*l)

      dhamil(2)=(dny*l+n*dly)*(llmimm*tmpa+tmpb)
     +    +n*l*(2.0*(l*dly-m*dmy)*tmpa+(llmimm*dtmpa+dtmpb)*m)

      dhamil(3)=(dnz*l+n*dlz)*(llmimm*tmpa+tmpb)
     +    +n*l*(2.0*(l*dlz-m*dmz)*tmpa+(llmimm*dtmpa+dtmpb)*n)

      end subroutine zxxxyy

c
c This is a subroutine to compute the overlap integral between dzx
c orbital and dz2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine zxzz (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,hsqrt3
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb
      parameter(hsqrt3=0.866025403785d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

c      hsqrt3=sqrt(3.0)/2.0

      tmpa=-hsqrt3*(3.0*dds-4.0*ddp+ddd)
      dtmpa=-hsqrt3*(3.0*ddds-4.0*dddp+dddd)
      tmpb=hsqrt3*(dds-ddp)*2.0
      dtmpb=hsqrt3*(ddds-dddp)*2.0

      hamil=l*n*(lladmm*tmpa+tmpb)

      dhamil(1)=(dlx*n+l*dnx)*(lladmm*tmpa+tmpb)
     +  +l*n*(2.0*(l*dlx+m*dmx)*tmpa+(lladmm*dtmpa+dtmpb)*l)

      dhamil(2)=(dly*n+l*dny)*(lladmm*tmpa+tmpb)
     +  +l*n*(2.0*(l*dly+m*dmy)*tmpa+(lladmm*dtmpa+dtmpb)*m)

      dhamil(3)=(dlz*n+l*dnz)*(lladmm*tmpa+tmpb)
     +  +l*n*(2.0*(l*dlz+m*dmz)*tmpa+(lladmm*dtmpa+dtmpb)*n)

      end subroutine zxzz

c
c This is a subroutine to compute the overlap integral between dx2-y2
c orbital and dx2-y2 orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine xxyy_2 (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz


      tmpa=(3.0*dds-4.0*ddp+ddd)/4.0
      dtmpa=(3.0*ddds-4.0*dddp+dddd)/4.0
      tmpb=ddp-ddd
      dtmpb=dddp-dddd

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

      hamil=llmimm*llmimm*tmpa+lladmm*tmpb+ddd

      dhamil(1)=4.0*llmimm*(l*dlx-m*dmx)*tmpa+llmimm*llmimm*dtmpa*l
     +         +2.0*(l*dlx+m*dmx)*tmpb+(lladmm*dtmpb+dddd)*l

      dhamil(2)=4.0*llmimm*(l*dly-m*dmy)*tmpa+llmimm*llmimm*dtmpa*m
     +         +2.0*(l*dly+m*dmy)*tmpb+(lladmm*dtmpb+dddd)*m

      dhamil(3)=4.0*llmimm*(l*dlz-m*dmz)*tmpa+llmimm*llmimm*dtmpa*n
     +         +2.0*(l*dlz+m*dmz)*tmpb+(lladmm*dtmpb+dddd)*n

      end subroutine xxyy_2

c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dxy orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine xxyyzz (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn,qsqrt3
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb
      parameter(qsqrt3=0.433012701892d0)

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c
c If you have to calculate the overlap integrel between dx2-y2 and px replace
c pds and pdp with dps and dpp and then reverse the sign the results.
c

c      qsqrt3=sqrt(3.0)/4.0

      tmpa=qsqrt3*(3.0*dds-4.0*ddp+ddd)
      dtmpa=qsqrt3*(3.0*ddds-4.0*dddp+dddd)
      tmpb=-qsqrt3*(dds-ddd)
      dtmpb=-qsqrt3*(ddds-dddd)

      hamil=llmimm*(nn*tmpa+tmpb)

      dhamil(1)=2.0*(l*dlx-m*dmx)*(nn*tmpa+tmpb)
     +    +llmimm*(2.0*n*dnx*tmpa+(nn*dtmpa+dtmpb)*l)

      dhamil(2)=2.0*(l*dly-m*dmy)*(nn*tmpa+tmpb)
     +    +llmimm*(2.0*n*dny*tmpa+(nn*dtmpa+dtmpb)*m)

      dhamil(3)=2.0*(l*dlz-m*dmz)*(nn*tmpa+tmpb)
     +    +llmimm*(2.0*n*dnz*tmpa+(nn*dtmpa+dtmpb)*n)

      end subroutine xxyyzz

c
c This is a subroutine to compute the overlap integral between dxy
c orbital and dxy orbital when the directional cosines of the two
c atoms is l, m, and n.
c
c In dds the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third s
c means sigma bonding (the magnetic quantum number for the two orbitals is 0,
c otherwise the sps is 0).
c
c In ddp the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 1
c or -1, otherwise the ppp is 0).
c
c In ddd the first d means d orbital (angular quantum number is 2),
c the second d means d orbital (angular quantum number is 2), and the third p
c means sigma bonding (the magnetic quantum number for the two orbitals is 2
c or -2, otherwise the ppp is 0).
c

      subroutine zz_2 (dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil)

      implicit none
      double precision dds,ddds,ddp,dddp,ddd,dddd,hamil,dhamil(3)
      double precision l,m,n,lladmm,llmimm,nn
      double precision dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      double precision tmpa,dtmpa,tmpb,dtmpb

c
c The following common blocks give the directional cosines and some
c combinations of the directional cosines, and the first derivatives of the
c directional cosines, which are generated by a subroutine lmndlm.
c

      common /lmn/ l,m,n,lladmm,llmimm,nn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz

c
c The following codes uses Slater-Koster scheme to build Hamiltonian
c Interaction elements.  The reference:  J.C. Slater and G.F. Koster,
c Phys. Rev. 94, 1498-1524 (1954).  Especially Table 1, pp. 1503.
c

      tmpa=0.75*(3.0*dds-4.0*ddp+ddd)
      dtmpa=0.75*(3.0*ddds-4.0*dddp+dddd)
      tmpb=3.0*(dds-ddp)
      dtmpb=3.0*(ddds-dddp)

      hamil=lladmm*(lladmm*tmpa-tmpb)+dds

      dhamil(1)=2.0*(l*dlx+m*dmx)*(lladmm*tmpa-tmpb)+ddds*l
     +    +lladmm*(2.0*(l*dlx+m*dmx)*tmpa+(lladmm*dtmpa-dtmpb)*l)

      dhamil(2)=2.0*(l*dly+m*dmy)*(lladmm*tmpa-tmpb)+ddds*m
     +    +lladmm*(2.0*(l*dly+m*dmy)*tmpa+(lladmm*dtmpa-dtmpb)*m)

      dhamil(3)=2.0*(l*dlz+m*dmz)*(lladmm*tmpa-tmpb)+ddds*n
     +    +lladmm*(2.0*(l*dlz+m*dmz)*tmpa+(lladmm*dtmpa-dtmpb)*n)

      end subroutine zz_2

      subroutine lmndlm(i,j,natom,x,y,z,rr)
      implicit real*8(a-h,o-z)
      double precision r,rr(natom,natom),x(natom)
      double precision y(natom),z(natom)
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      common /dlmn/ dlx,dly,dlz,dmx,dmy,dmz,dnx,dny,dnz
      
      r=rr(i,j)
      dx=x(i)-x(j)
      dy=y(i)-y(j)
      dz=z(i)-z(j)

      el=dx/r
      em=dy/r
      en=dz/r

      elladmm=el*el+em*em
      ellmimm=el*el-em*em
      enn=en*en

      dlx=(1.0-el*el)/r
      dly=-el*em/r
      dlz=-el*en/r
      dmx=dly
      dmy=(1.0-em*em)/r
      dmz=-em*en/r
      dnx=dlz
      dny=dmz
      dnz=(1.0-en*en)/r
      end subroutine lmndlm

      subroutine genrhd(ip,jp,r,hamil,dhamil,Sij2,dSij2)
      use basics
      implicit none
      integer ip,jp
      double precision hamil(subsiz,subsiz),dhamil(subsiz,subsiz,3),r
      double precision Sij2(subsiz,subsiz),dSij2(subsiz,subsiz,3)

      if(ip.eq.1)then
        if(jp.eq.1)then
          call h_h_hd(r,hamil,dhamil,Sij2,dSij2)
        elseif (jp.eq.2)then
          call h_c_hd(r,hamil,dhamil)
        elseif(jp.eq.3)then
c          call h_al_hd(j,hamil,dhamil)
           stop 'Al-H not yet implemented'
        else
          call h_tr_hd(jp,r,hamil,dhamil)
        endif
      elseif(ip.eq.2)then
        if(jp.eq.1)then
          call c_h_hd(r,hamil,dhamil)
        elseif(jp.eq.2)then
          call c_c_hd(r,hamil,dhamil)
        elseif(jp.eq.3)then
c          call c_al_hd(jp,hamil,dhamil)
          stop 'Al-C not yet implemented'
        else
          call c_tr_hd(jp,r,hamil,dhamil)
        endif
      elseif(ip.eq.3)then
        if(jp.eq.1)then
c          call al_h_hd(i,hamil,dhamil)
          stop 'Al-H not yet implemented'
        elseif (jp.eq.2)then
c          call al_c_hd(i,hamil,dhamil)
          stop 'Al-C not yet implemented'
        elseif(jp.eq.3)then
            call al_al_hd(ip,r,hamil,dhamil,Sij2,dSij2)
        else
            stop "The parameters for the two elements are unavailable."
	endif    
      else
        if(jp.eq.1)then
	  call tr_h_hd(ip,r,hamil,dhamil)
	elseif(jp.eq.2)then
	  call tr_c_hd(ip,r,hamil,dhamil)
	elseif(jp.eq.3)then
            stop "The parameters for the two elements are unavailable."
	elseif(jp.eq.ip)then
	  call tr_tr_hd(ip,r,hamil,dhamil)
	else
            stop "The parameters for the two elements are unavailable."
        endif
      endif

      return
      end subroutine genrhd
c
      subroutine genrhd_mb(i,j,natom,x,y,z,r,idtype,hamil,dhamilmb,
     &  Sij2,dSij2mb,Fcng,dFcng)
      use basics
      use grad
      implicit none
      integer ip,jp,i,j,natom,idtype(natom)
      double precision hamil(subsiz,subsiz)
      double precision dhamilmb(subsiz,subsiz,natom,3)
      double precision Sij2(subsiz,subsiz)
      double precision dSij2mb(subsiz,subsiz,ndimdS2,3)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),rij
      double precision Fcng(natom),dFcng(natom,natom,3)

      ip=idtype(i)
      jp=idtype(j)
      rij=r(i,j)
      
      if(ip.eq.1)then
c        if(jp.eq.1)then
c          call h_h_hd(ip,rij,hamil,dhamil)
c        else if (j.eq.2) then
c          call h_c_hd(hamil,dhamil)
c        elseif(jp.eq.3)
c          call h_al_hd(j,hamil,dhamil)
c        else
            stop "The parameters for the two elements are unavailable."
c        endif
c      else if (i.eq.2) then
c        if (j.eq.1) then
c          call c_h_hd(hamil,dhamil)
c        else if (j.eq.2) then
c          call c_c_hd(hamil,dhamil)
c        else
c          call c_al_hd(j,hamil,dhamil)
c        endif
      elseif(ip.eq.3)then
c        if(jp.eq.1)then
c          call al_h_hd(i,hamil,dhamil)
c        else if (j.eq.2) then
c          call al_c_hd(i,hamil,dhamil)
c        elseif(jp.eq.2)then
        if(jp.eq.3)then
            call al_al_hd_mb(i,j,natom,x,y,z,r,idtype,hamil,dhamilmb,
     &            Sij2,dSij2mb,Fcng,dFcng)
        else
            stop "The parameters for the two elements are unavailable."
	endif    
      else
            stop "The parameters for the two elements are unavailable."
c          endif
c        endif
      endif

      end subroutine genrhd_mb
c
c
c Arrange all the valence electrons to the necessary molecular orbitals 
c so that the potential energy of the system is minimized.
c
      subroutine filloc(natom,ndim,nElect,eva,etb,evec,nocc,dhamlt,dSij,
     & dhamltmb,dSijmb,dEdx,dEdy,dEdz,x,y,z,r,idtype)
c
      use basics
      use params
      use grad
      use printing
      implicit real*8(a-h,o-z)
      logical lal2
      parameter(lal2=.true.)
c      external function natm
      integer idtype(natom),natm(ndim)
      dimension eva(ndim),nrp(ndim*ndim+1),nrm(ndim*ndim+1)
      dimension nrpd(ndim*ndim+1),nrmd(ndim*ndim+1)
      dimension nocc(ndim),ch(natom),q(ndim),qp(ndim),qn(natom)
      dimension r(natom,natom),evec(ndim,ndim),exj(2*ndim*ndim+1)
      double precision x(natom),y(natom),z(natom)
      dimension dch(natom,natom,3),dqp(ndim,natom,3),dcult(natom,3)
      dimension dgam(ndimat,ndimat,3),dexj(2*ndim*ndim+1,natom,3)
      dimension gam(natom,natom),dtmp(3)
      dimension dexjmax(natom,3),de(natom,3),dq(ndim,natom,3)
      dimension dEdx(natom),dEdy(natom),dEdz(natom)
      dimension dhamlt(ndimdH,ndimdH,3),dc(natom,3)
      dimension dhamltmb(ndimdH,ndimdH,natom,3)
      double precision dSij(ndimdS1,ndimdS1,3)
      double precision HS(ndimdH,ndimdH,3),Ci(2*ndim*ndim+1)
      double precision lambda,sum1,sum2,dCi(2*ndim*ndim+1,natom,3)
      double precision dsum(natom,3)

c      double precision FC(ndimdH,ndimdH),G(ndimdH,ndimdH,3)
c      double precision dC(ndimdH,ndimdH,natom,3),CFC(ndimdH,ndimdH)
c      integer jci,ici
c      common /cmat/ jci,ici

      j=0
      do i=1,natom
	 do k=1,norbit(idtype(i))
	    natm(j+k)=i
	 enddo
	 j=j+norbit(idtype(i))
      enddo

c      write(*,*)'debug: natm'
c      write(*,*)(natm(i),i=1,ndim)

c      do i=1,ndim
c      nocc(i)=0
c      enddo
      nexcit=natom

cMAI: in the singles-only case, ncsf=0, else defined in obsasd2
      ncsfd=0

      select case(icase)
      case(1:4,8)
c        call obsa4(nElect,natom,nexcit,ndim,eva,nocc,nrp,nrm,
c     &nobsmax,ncsf,maxocc)
        call obsa4(nElect,natom,nexcit,ndim,nocc,nrp,nrm,
     &nobsmax,ncsf,maxocc)
      case(5:7)
        call obsasd2(nElect,natom,nexcit,ndim,nocc,nrp,nrm,nrpd,
     &nrmd,nobsmax,ncsf,ncsfd,maxocc)
      case(9:25)
        call TBocc(ndim,nElect,eva,nocc,maxocc)
      case default
        Stop 'Wrong icase passed on to subroutine filloc'
      end select

c      write(*,*)'debug ncsf+ncsfd 2*ndim*ndim+1:',ncsf+ncsfd,
c     *   2*ndim*ndim+1
c
c   calculate band energy of basis occupation, ep
c   
         ep=0d0
	 select case(icase)
	 case(:8,10,15:20,23)
c i.e. those cases where the penalty energy is zero
            do  i=1,maxocc
              ep=ep+eva(i)*nocc(i)
            enddo
	 case default
	    upen=parUpen(icase)
	    do i=1,maxocc
              ep=ep+eva(i)*nocc(i)
	      if(nocc(i).eq.2)ep=ep+upen
	    enddo
	 end select

	 if(dograd)then
	 select case(icase)
	 case(14:17,21:22)
c i.e. MBTB
c	    nrdim=0
c	    do 201 i=1,natom
c	       ncdim=0
c	       do 202 j=1,natom
c	          if(i.eq.j)goto 209
c		  Fx=0.0d0
c		  Fy=0.0d0
c		  Fz=0.0d0
		  do 203 k=1,maxocc
c		  do 203 ii=1,norbit(idtype(i))
c		  do 203 jj=1,norbit(idtype(j))
		  do 203 ii=1,ndim
		  do 203 jj=1,ndim
c		     tmp=evec(nrdim+ii,k)*evec(ncdim+jj,k)*nocc(k)
c		     Fx=Fx+tmp*dhamlt(nrdim+ii,ncdim+jj,i,1)
c		     Fy=Fy+tmp*dhamlt(nrdim+ii,ncdim+jj,i,2)
c		     Fz=Fz+tmp*dhamlt(nrdim+ii,ncdim+jj,i,3)
		     tmp=evec(ii,k)*evec(jj,k)*nocc(k)
c		     tmp=2.0d0*evec(ii,k)*evec(jj,k)*nocc(k)
c		     tmp=2.0d0*evec(nrdim+ii,k)*evec(ncdim+jj,k)*nocc(k)
c N.B. the 2.0d0 came from the old expressions dEdx(i)=..._2.0d0*Fx
		     do n=1,natom
c		       dEdx(n)=dEdx(n)+tmp*dhamltmb(nrdim+ii,ncdim+jj,n,1)
c		       dEdy(n)=dEdy(n)+tmp*dhamltmb(nrdim+ii,ncdim+jj,n,2)
c		       dEdz(n)=dEdz(n)+tmp*dhamltmb(nrdim+ii,ncdim+jj,n,3)
		       dEdx(n)=dEdx(n)+tmp*dhamltmb(ii,jj,n,1)
		       dEdy(n)=dEdy(n)+tmp*dhamltmb(ii,jj,n,2)
		       dEdz(n)=dEdz(n)+tmp*dhamltmb(ii,jj,n,3)
		     enddo
 203              continue
c                  dEdx(i)=dEdx(i)+2.0d0*Fx
c	          dEdy(i)=dEdy(i)+2.0d0*Fy
c	          dEdz(i)=dEdz(i)+2.0d0*Fz
c 209              ncdim=ncdim+norbit(idtype(j))
c 202           continue
c               nrdim=nrdim+norbit(idtype(i))
c 201        continue
	 case(18:20)
c i.e. MB-NOTB
	    nrdim=0
	    do 211 i=1,natom
	       ncdim=0
	       do 212 j=1,natom
	          if(i.eq.j)goto 219
		  Fx=0.0d0
		  Fy=0.0d0
		  Fz=0.0d0
		  do 213 k=1,maxocc
c		  do 203 ii=1,norbit(idtype(i))
c		  do 203 jj=1,norbit(idtype(j))
		  do 213 ii=1,ndim
		  do 213 jj=1,ndim
c		     tmp=evec(nrdim+ii,k)*evec(ncdim+jj,k)*nocc(k)
c		     Fx=Fx+tmp*dhamlt(nrdim+ii,ncdim+jj,i,1)
c		     Fy=Fy+tmp*dhamlt(nrdim+ii,ncdim+jj,i,2)
c		     Fz=Fz+tmp*dhamlt(nrdim+ii,ncdim+jj,i,3)
		     tmp=2.0d0*evec(ii,k)*evec(jj,k)*nocc(k)
c N.B. the 2.0d0 came from the old expressions dEdx(i)=..._2.0d0*Fx
		     do n=1,natom
		      dEdx(n)=dEdx(n)+tmp*(dhamltmb(ii,jj,n,1)-dSijmb(ii,jj,n,1))
		      dEdy(n)=dEdy(n)+tmp*(dhamltmb(ii,jj,n,2)-dSijmb(ii,jj,n,1))
		      dEdz(n)=dEdz(n)+tmp*(dhamltmb(ii,jj,n,3)-dSijmb(ii,jj,n,1))
		     enddo
 213              continue
c                  dEdx(i)=dEdx(i)+2.0d0*Fx
c	          dEdy(i)=dEdy(i)+2.0d0*Fy
c	          dEdz(i)=dEdz(i)+2.0d0*Fz
 219              ncdim=ncdim+norbit(idtype(j))
 212           continue
               nrdim=nrdim+norbit(idtype(i))
 211        continue
	 case(23:24)
c i.e. NOTB-WH
	    nrdim=0
	    do 221 i=1,natom
	       ncdim=0
	       do 222 j=1,natom
	          if(i.eq.j)goto 229
		  Fx=0.0d0
		  Fy=0.0d0
		  Fz=0.0d0
		  do 223 k=1,maxocc
		  do 223 ii=1,norbit(idtype(i))
		  do 223 jj=1,norbit(idtype(j))
		     tmp=evec(nrdim+ii,k)*evec(ncdim+jj,k)*nocc(k)
		     Fx=Fx+tmp*(dhamlt(nrdim+ii,ncdim+jj,1)-
     *                    dSij(nrdim+ii,ncdim+jj,1))
		     Fy=Fy+tmp*(dhamlt(nrdim+ii,ncdim+jj,2)-
     *                    dSij(nrdim+ii,ncdim+jj,2))
		     Fz=Fz+tmp*(dhamlt(nrdim+ii,ncdim+jj,3)-
     *                    dSij(nrdim+ii,ncdim+jj,3))
 223              continue
                  dEdx(i)=dEdx(i)+2.0d0*Fx
	          dEdy(i)=dEdy(i)+2.0d0*Fy
	          dEdz(i)=dEdz(i)+2.0d0*Fz
 229              ncdim=ncdim+norbit(idtype(j))
 222           continue
               nrdim=nrdim+norbit(idtype(i))
 221        continue
	 case default
c i.e. TB/TBCI
	    nrdim=0
	    do 101 i=1,natom
	       ncdim=0
	       do 102 j=1,natom
	          if(i.eq.j)goto 109
		  Fx=0.0d0
		  Fy=0.0d0
		  Fz=0.0d0
		  do 103 k=1,maxocc
		  do 103 ii=1,norbit(idtype(i))
		  do 103 jj=1,norbit(idtype(j))
		     tmp=evec(nrdim+ii,k)*evec(ncdim+jj,k)*nocc(k)
		     Fx=Fx+tmp*dhamlt(nrdim+ii,ncdim+jj,1)
		     Fy=Fy+tmp*dhamlt(nrdim+ii,ncdim+jj,2)
		     Fz=Fz+tmp*dhamlt(nrdim+ii,ncdim+jj,3)
 103              continue
                  dEdx(i)=dEdx(i)+2.0d0*Fx
	          dEdy(i)=dEdy(i)+2.0d0*Fy
	          dEdz(i)=dEdz(i)+2.0d0*Fz
 109              ncdim=ncdim+norbit(idtype(j))
 102           continue
               nrdim=nrdim+norbit(idtype(i))
 101        continue
	 end select
	 endif
	 
	 select case(icase)
	 case(9:25)
	    etb=ep
c  the density matrix Pjj is stored in qp(j)
            do j = 1, ndim
            qp(j)=0.0
            do i = 1, ndim
            qp(j) = qp(j) +nocc(i)*evec(j,i)*evec(j,i)
            enddo
            enddo

            nrdim=0
            do i=1,natom
            qn(i)=dble(nelem(idtype(i)))
            do j=1,norbit(idtype(i))
            qn(i)=qn(i)-qp(nrdim+j)
            enddo
            nrdim=nrdim+norbit(idtype(i))
            enddo
c If required, print the MO
      if(printlev.ge.2)call printMO(natom,ndim,nElect,nocc,eva,evec,qp)

c If needed, print the partial atomic charges
            if(printlev.ge.2)call printQ(natom,qn)
c TB models end here
	    return
	 case default
c If required, print the MO
            if(printlev.ge.2)call printMO(natom,ndim,nElect,nocc,eva,
     &          evec,qp)
	 end select
c
c Set TBCI parameters
      delta=pardelta(icase)
      lambda=4*delta*delta

c      write(*,*)'debugG1 dEdx(1) = ',dEdx(1)

c   Determine and store the Coulomb Integrals gamma(a,b)
       do i=1,natom-1
          call dogamAA(gam(i,i),idtype(i))
	  if(dograd)then
	     do k=1,3
	        dgam(i,i,k)=0.0d0
	     enddo
	  endif
	  do j=i+1,natom
	     call dogamAB(i,j,natom,x,y,z,r,idtype,gam(i,j),dtmp)
             gam(j,i)=gam(i,j) 
	     if(dograd)then
	        do k=1,3
		   dgam(i,j,k)=dtmp(k)
		   dgam(j,i,j)=-dtmp(k)
		enddo
	     endif
	  enddo
       enddo
       call dogamAA(gam(natom,natom),idtype(natom))
       if(dograd)then
          do k=1,3
	     dgam(natom,natom,k)=0.0d0
	  enddo
       endif


c       do i=1,natom
c       do j=i,natom
c         write(*,*)'debug gam(i,j)',i,j,gam(i,j)
c       enddo
c       enddo

c   to avoid too big  numbers the coefficients
c   |c(j)|**2 are scalled
c
c  calculate and store 
c  exponents,exj(*), in coefficients
c  |c(j)|**2, to find their maximal value
c  
c  calculate Coulomb term of basis occupation, cult
c
c  the density matrix Pjj is stored in qp(j)
c
            do j = 1, ndim
            qp(j)=0.0
            do i = 1, ndim
            qp(j) = qp(j) +nocc(i)*evec(j,i)*evec(j,i)
            enddo
            enddo
	    
	    if(dograd)then
	      dqp=0.0d0
	      do 1001 j=1,ndim
	      do 1001 i=1,ndim
	        call dCijn(j,i,natom,ndim,evec,eva,natm,dhamlt,dC)
	        do 1000 n=1,natom
	        do 1000 m=1,3
		   dqp(j,n,m)=dqp(j,n,m)+2.0d0*nocc(i)*evec(j,i)*dC(n,m)
c		   write(*,*)'debugG13 i,j,n,m,dC(n,m):',i,j,n,m,dC(n,m)
 1000           continue
 1001         continue
	    endif

c	    etb=qp(1)
c	    if(dograd)then
c	      do n=1,natom
c	         dEdx(n)=dqp(1,n,1)
c	         dEdy(n)=dqp(1,n,2)
c	         dEdz(n)=dqp(1,n,3)
c	      enddo
c	    endif
c	    return

            if(dograd)dch=0.0d0
            nrdim=0
            do i=1,natom
c            ch(i)=3.0
            ch(i)=dble(nelem(idtype(i)))
c            do j=1,4
            do j=1,norbit(idtype(i))
            ch(i)=ch(i)-qp(nrdim+j)
	    if(dograd)then
	       do 113 n=1,natom
	       do 113 m=1,3
	          dch(i,n,m)=dch(i,n,m)-dqp(nrdim+j,n,m)
c		  write(*,*)'debugG12 i nrdim+j,n,m,dqp(..):',
c     *               i,nrdim+j,n,m,dqp(nrdim+j,n,m)
 113           continue
	    endif
            enddo
c            nrdim=nrdim+4
            nrdim=nrdim+norbit(idtype(i))
            enddo

c          write(*,*)'debugging ch'
c	  etb=ch(1)
c	  if(dograd)then
c	     do n=1,natom
c	        dEdx(n)=dch(1,n,1)
c	        dEdy(n)=dch(1,n,2)
c	        dEdz(n)=dch(1,n,3)
ccc		write(*,*)'debug9 n dch(1,n,m): ',n,(dch(1,n,m),m=1,3)
c	     enddo
c	  endif
c	  return

          cult=0d0
	  dcult=0.0d0
          do i=1,natom-1
            cult=cult+ch(i)*ch(i)*gam(i,i)

	    if(dograd)then
	       do 114 n=1,natom
	       do 114 m=1,3
	          dcult(n,m)=dcult(n,m)+2.0d0*ch(i)*dch(i,n,m)*gam(i,i)
c		write(*,*)'debugG11 i,n,m dch(i,n,m):',n,m,dch(i,n,m)
c		write(*,*)'debugG10 n,m dcult(n,m):',n,m,dcult(n,m)
 114           continue
	    endif
            if(icase.ne.8)then
	     do j=i+1,natom
              cult=cult+ch(j)*ch(i)*gam(i,j)

	      if(dograd)then
		 do m=1,3
		    t1=dgam(i,j,m)*ch(i)*ch(j)
		    dcult(i,m)=dcult(i,m)+t1
		    dcult(j,m)=dcult(j,m)-t1
		    do n=1,natom
		       t2=ch(j)*dch(i,n,m)*gam(i,j)
		       t3=ch(i)*dch(j,n,m)*gam(i,j)
		       dcult(n,m)=dcult(n,m)+t2+t3
		    enddo
		 enddo
	      endif

             enddo
	    endif
          enddo
          cult=cult+ch(natom)*ch(natom)*gam(natom,natom)

	  if(dograd)then
	     do 115 n=1,natom
	     do 115 m=1,3
	        dcult(n,m)=dcult(n,m)+2.0d0*ch(natom)*dch(natom,n,m)
     +              *gam(natom,natom)
 115         continue
	  endif

          exj(1)=-cult/delta
          exjmax=exj(1)

	  if(dograd)then
	     do 116 n=1,natom
	     do 116 m=1,3
	        dexj(1,n,m)=dcult(n,m)
c		write(*,*)'debugG9 n,m dexj(1,n,m):',n,m,dexj(1,n,m)
c                dexjmax(n,m)=dexj(1,n,m)
 116         continue
	  endif

c	  etb=cult
c	  if(dograd)then
c	     do n=1,natom
c	        dEdx(n)=dcult(n,1)
c	        dEdy(n)=dcult(n,2)
c	        dEdz(n)=dcult(n,3)
c	     enddo
c	  endif
c	  return
c
 6667 do 1 jp=2,ncsf
c
c km gives the number of orbital from which the electron is taken
c lp gives the number of new occupied orbital
c     
c e gives the difference in energy between the basic 
c   and the current configuration
c
      km=nrm(jp)
      lp=nrp(jp)
      e=-eva(km)+eva(lp)

      if(dograd)then
         de=0.0d0
	 do 1100 n=1,natom
	 do 1100 m=1,3
	    do 1101 i=1,ndim
	       natmi=natm(i)
	       tmplp=0.0d0
	       tmpkm=0.0d0
	       do 1102 j=1,ndim
	          natmj=natm(j)
		  if(natmj.eq.natmi)goto 1102
		  if(natmi.eq.n)then
		     tmplp=tmplp+dhamlt(i,j,m)*evec(j,lp)
		     tmpkm=tmpkm+dhamlt(i,j,m)*evec(j,km)
		  elseif(natmj.eq.n)then
		     tmplp=tmplp-dhamlt(i,j,m)*evec(j,lp)
		     tmpkm=tmpkm-dhamlt(i,j,m)*evec(j,km)
		  endif
 1102          continue
               de(n,m)=de(n,m)+evec(i,lp)*tmplp
     &                        -evec(i,km)*tmpkm
 1101       continue
 1100    continue
      endif
c
          do j = 1, ndim
          q(j)=qp(j)-evec(j,km)*evec(j,km)+evec(j,lp)*evec(j,lp)
          enddo

	  if(dograd)then
	    dq=0.0d0
	    do 1002 j=1,ndim
	       call dCijn(j,km,natom,ndim,evec,eva,natm,dhamlt,dC)
	       do 1003 n=1,natom
	       do 1003 m=1,3
	          dq(j,n,m)=dqp(j,n,m)-2.0d0*evec(j,km)*dC(n,m)
 1003          continue
	       call dCijn(j,lp,natom,ndim,evec,eva,natm,dhamlt,dC)
	       do 1004 n=1,natom
	       do 1004 m=1,3
	          dq(j,n,m)=dq(j,n,m)+2.0d0*evec(j,lp)*dC(n,m)
 1004          continue
 1002       continue
	  endif

          nrdim=0
	  dch=0.0d0
          do i=1,natom
c            ch(i)=3.0
            ch(i)=dble(nelem(idtype(i)))
c            do j=1,4
            do j=1,norbit(idtype(i))
              ch(i)=ch(i)-q(nrdim+j)

	      if(dograd)then
	         do 143 n=1,natom
		 do 143 m=1,3
		    dch(i,n,m)=dch(i,n,m)-dq(nrdim+j,n,m)
 143             continue
	      endif
            enddo
c            nrdim=nrdim+4
            nrdim=nrdim+norbit(idtype(i))
          enddo

          cult=0d0
	  dcult=0.0d0
          do i=1,natom-1
            cult=cult+ch(i)*ch(i)*gam(i,i)

	    if(dograd)then
	       do 144 n=1,natom
	       do 144 m=1,3
	          dcult(n,m)=dcult(n,m)+2.0d0*ch(i)*dch(i,n,m)*gam(i,i)
 144           continue
	    endif
            if(icase.ne.8)then
            do j=i+1,natom
              cult=cult+ch(j)*ch(i)*gam(i,j)

	      if(dograd)then
		 do 145 m=1,3
		    t1=dgam(i,j,m)*ch(i)*ch(j)
		    dcult(i,m)=dcult(i,m)+t1
		    dcult(j,m)=dcult(j,m)-t1
		    do 146 n=1,natom
		       t2=ch(j)*dch(i,n,m)*gam(i,j)
		       t3=ch(i)*dch(j,n,m)*gam(i,j)
		       dcult(n,m)=dcult(n,m)+t2+t3
 146                continue
 145             continue
	      endif

            enddo
	    endif
          enddo
          cult=cult+ch(natom)*ch(natom)*gam(natom,natom)

	    if(dograd)then
	       do 147 n=1,natom
	       do 147 m=1,3
	          dcult(n,m)=dcult(n,m)+2.0d0*ch(natom)*dch(natom,n,m)
     +                 *gam(natom,natom)
 147           continue
	    endif

          enj=-(e+cult)/delta
          exj(jp)=enj
          if(enj.gt.exjmax)exjmax=enj

	  if(dograd)then
	     do 151 n=1,natom
	     do 151 m=1,3
	        dexj(jp,n,m)=de(n,m)+dcult(n,m)
c                if(enj.gt.exjmax)dexjmax(n,m)=dexj(jp,n,m)
 151         continue
	  endif

   1      continue

c
c  some double excitations
c
      if(ncsfd.ne.0)then
      do 11 jp=1,ncsfd
      jpn=jp+ncsf
c
c km gives the number of orbital from which the electron is taken
c lp gives the number of new occupied orbital
c     
c e gives the difference in energy between the basic 
c   and the current configuration
c
      km=nrmd(jp)
      lp=nrpd(jp)
      e=-2.0d0*eva(km)+2.0d0*eva(lp)

      if(dograd)then
         de=0.0d0
	 do 1300 n=1,natom
	 do 1300 m=1,3
	    do 1301 i=1,ndim
	       natmi=natm(i)
	       tmplp=0.0d0
	       tmpkm=0.0d0
	       do 1302 j=1,ndim
	          natmj=natm(j)
		  if(natmj.eq.natmi)goto 1302
		  if(natmi.eq.n)then
		     tmplp=tmplp+dhamlt(i,j,m)*evec(j,lp)
		     tmpkm=tmpkm+dhamlt(i,j,m)*evec(j,km)
		  elseif(natmj.eq.n)then
		     tmplp=tmplp-dhamlt(i,j,m)*evec(j,lp)
		     tmpkm=tmpkm-dhamlt(i,j,m)*evec(j,km)
		  endif
 1302          continue
               de(n,m)=de(n,m)+evec(i,lp)*tmplp
     &                        -evec(i,km)*tmpkm
 1301       continue
C Let's not forget about the 2 constant
            de(n,m)=de(n,m)*2.0d0
 1300    continue
      endif

      do j = 1, ndim
        q(j)=qp(j)-2.0d0*evec(j,km)*evec(j,km)+
     & 2.0d0*evec(j,lp)*evec(j,lp)
      enddo

      if(dograd)then
	  dq=0.0d0
	  do 1312 j=1,ndim
	     call dCijn(j,km,natom,ndim,evec,eva,natm,dhamlt,dC)
	     do 1313 n=1,natom
	     do 1313 m=1,3
	        dq(j,n,m)=dqp(j,n,m)-4.0d0*evec(j,km)*dC(n,m)
 1313        continue
	     call dCijn(j,lp,natom,ndim,evec,eva,natm,dhamlt,dC)
	     do 1314 n=1,natom
	     do 1314 m=1,3
	        dq(j,n,m)=dq(j,n,m)+4.0d0*evec(j,lp)*dC(n,m)
 1314        continue
 1312     continue
      endif

      nrdim=0
      dch=0.0d0
      do i=1,natom
c        ch(i)=3.0
        ch(i)=dble(nelem(idtype(i)))
c        do j=1,4
        do j=1,norbit(idtype(i))
          ch(i)=ch(i)-q(nrdim+j)

	  if(dograd)then
	     do 1315 n=1,natom
	     do 1315 m=1,3
		  dch(i,n,m)=dch(i,n,m)-dq(nrdim+j,n,m)
 1315        continue
	  endif

        enddo
c        nrdim=nrdim+4
        nrdim=nrdim+norbit(idtype(i))
      enddo

          cult=0d0
	  dcult=0.0d0
          do i=1,natom-1
            cult=cult+ch(i)*ch(i)*gam(i,i)

	    if(dograd)then
	       do 1344 n=1,natom
	       do 1344 m=1,3
	          dcult(n,m)=dcult(n,m)+2.0d0*ch(i)*dch(i,n,m)*gam(i,i)
 1344          continue
	    endif

            do j=i+1,natom
              cult=cult+ch(j)*ch(i)*gam(i,j)

	      if(dograd)then
		 do 1345 m=1,3
		    t1=dgam(i,j,m)*ch(i)*ch(j)
		    dcult(i,m)=dcult(i,m)+t1
		    dcult(j,m)=dcult(j,m)-t1
		    do 1346 n=1,natom
		       t2=ch(j)*dch(i,n,m)*gam(i,j)
		       t3=ch(i)*dch(j,n,m)*gam(i,j)
		       dcult(n,m)=dcult(n,m)+t2+t3
 1346               continue
 1345            continue
	      endif

            enddo
          enddo
          cult=cult+ch(natom)*ch(natom)*gam(natom,natom)

	    if(dograd)then
	       do 1347 n=1,natom
	       do 1347 m=1,3
	          dcult(n,m)=dcult(n,m)+2.0d0*ch(natom)*dch(natom,n,m)
     +                *gam(natom,natom)
 1347          continue
	    endif

          enj=-(e+cult)/delta
          exj(jpn)=enj
          if(enj.gt.exjmax)exjmax=enj

	  if(dograd)then
	     do 1351 n=1,natom
	     do 1351 m=1,3
	        dexj(jpn,n,m)=de(n,m)+dcult(n,m)
c                if(enj.gt.exjmax)dexjmax(n,m)=dexj(jpn,n,m)
 1351        continue
	  endif

c	  if(jpn.eq.32)then
c	     etb=cult
c	     if(dograd)then
c	       do n=1,natom
c	        dEdx(n)=dcult(n,1)
c	        dEdy(n)=dcult(n,2)
c	        dEdz(n)=dcult(n,3)
c	       enddo
c	     endif
c	     return
c	  endif

 11     continue
        endif
cc
cc
cc  calculate sums, norms, charges  
cc
        do 2 jp=1,ncsf+ncsfd
c	write(*,*)'debug, jp = ',jp,exj(jp)
   2    exj(jp)=exj(jp)-exjmax
c        write(*,*)'debug exjmax=',exjmax
        sklad=dexp(exj(1))
	Ci(1)=sklad
        snorm=sklad
        sener=-sklad*exj(1)*delta
c                do m=1,ndim
                nrdim=0
                do m=1,natom
c		   ch(m)=3.0d0
		   ch(m)=nelem(idtype(i))
c		   do mm=1,4
		   do mm=1,norbit(idtype(i))
		      ch(m)=ch(m)-qp(nrdim+mm)
		   enddo
c		   nrdim=nrdim+4
		   nrdim=nrdim+norbit(idtype(i))
                enddo
c MAI c          if(lal2)rewind(66)
	  if(lal2)write(66,*)'Reference CSF'
	  if(lal2)write(66,666)0,0,ch(1),ch(2),exj(jp),sklad
	  if(lal2)write(66,*)'Single Excitations'
 666      format(1X,I3,1X,I3,2(1X,F7.4),2(1X,F12.5))
		do m=1,natom
                  qn(m)=sklad*ch(m)
		enddo
c        do 3 jp=2,nprzyp
        do 3 jp=2,ncsf
        sklad=dexp(exj(jp))
	Ci(jp)=sklad
        snorm=snorm+sklad
c MAI: remember that exj(jp)=-(e+cult)/delta and thus -sklad...
        sener=sener-sklad*exj(jp)*delta
      km=nrm(jp)
      lp=nrp(jp)
          do j = 1, ndim
          q(j)=qp(j)-evec(j,km)*evec(j,km)+evec(j,lp)*evec(j,lp)
          enddo
	  nrdim=0
	  do i=1,natom
c	    ch(i)=3.0d0
	    ch(i)=dble(nelem(idtype(i)))
c	    do j=1,4
	    do j=1,norbit(idtype(i))
	      ch(i)=ch(i)-q(nrdim+j)
	    enddo
c	    nrdim=nrdim+4
	    nrdim=nrdim+norbit(idtype(i))
	  enddo
	  if(lal2)write(66,666)km,lp,ch(1),ch(2),exj(jp),sklad
cc                do m=1,ndim
                do m=1,natom
c                qn(m)=qn(m)+sklad*q(m)
                qn(m)=qn(m)+sklad*ch(m)
                enddo
    3  continue

c   add contribution from double excitation
      if(ncsfd.ne.0)then
      write(66,*)'Double Excitations'
        do 33 jp=1,ncsfd
      jpn=jp+ncsf
        sklad=dexp(exj(jpn))
	Ci(jpn)=sklad
        snorm=snorm+sklad
        sener=sener-sklad*exj(jpn)*delta
      km=nrmd(jp)
      lp=nrpd(jp)
          do j = 1, ndim
          q(j)=qp(j)-2.0d0*evec(j,km)*evec(j,km)+
     & 2.0d0*evec(j,lp)*evec(j,lp)
          enddo
 	  nrdim=0
	  do i=1,natom
c	    ch(i)=3.0d0
	    ch(i)=dble(nelem(idtype(i)))
c	    do j=1,4
	    do j=1,norbit(idtype(i))
	      ch(i)=ch(i)-q(nrdim+j)
	    enddo
c	    nrdim=nrdim+4
	    nrdim=nrdim+norbit(idtype(i))
	  enddo
	  if(lal2)write(66,666)km,lp,ch(1),ch(2),exj(jpn),sklad
                do m=1,natom
                qn(m)=qn(m)+sklad*ch(m)
                enddo
   33  continue
       endif

       do n=1,natom
          qn(n)=qn(n)/snorm
       enddo

c If needed, print the partial atomic charges
       if(printlev.ge.2)call printQ(natom,qn)

c not quite!      if(dograd)then
c not quite!	 do 161 n=1,natom
c not quite!            Fx=0.0d0
c not quite!	    Fy=0.0d0
c not quite!	    Fz=0.0d0
c not quite!	    do 162 j=1,ncsf+ncsfd
c not quite!	       Fx=Fx+dexp(exj(j))*dexj(j,n,1)
c not quite!	       Fy=Fy+dexp(exj(j))*dexj(j,n,2)
c not quite!	       Fz=Fz+dexp(exj(j))*dexj(j,n,3)
c not quite! 162        continue
c not quite!            Fx=Fx/snorm
c not quite!            Fy=Fy/snorm
c not quite!            Fz=Fz/snorm
c not quite!            dEdx(n)=dEdx(n)+Fx
c not quite!            dEdy(n)=dEdy(n)+Fy
c not quite!            dEdz(n)=dEdz(n)+Fz
c not quite! 161     continue
c not quite!      endif

c Normalize Ci and return exj to Eval+Eci
       sum2=0.0d0
       do n=1,ncsf+ncsfd
	  exj(n)=-(exj(n)+exjmax)*delta
c          exj(n)=-exj(n)*delta
c          write(*,*)'debug3 i exj(i) exjmax)=',n,exj(n),exjmax
	  Ci(n)=dexp(-exj(n)/delta)
	  sum2=sum2+Ci(n)
       enddo

       do n=1,ncsf+ncsfd
          Ci(n)=Ci(n)/sum2
c	  write(*,*)'debug4 j Ci(j) =',n,Ci(n)
       enddo

c       do n=1,ndim
cc          write(*,*)'debug5 j eva(j) = ',n,eva(n)
c       enddo
c
c       do n=1,natom
c          write(*,*)'debug6 n dexj(2)/dxyz ',n,(dexj(2,n,k),k=1,3)
c       enddo

c       write(*,*)'debug snorm sum2 = ',snorm,sum2

       if(dograd)then
        dCi=0.0d0
	  do 4445 n=1,natom
	  do 4445 m=1,3
	     sum1=0.0d0
	     do 4447 k=1,ncsf+ncsfd
	         sum1=sum1+dexp(-exj(k)/delta)*dexj(k,n,m)
 4447        continue
             do 4444 j=1,ncsf+ncsfd
              if(Ci(j).ge.cutEj)then
	        dCi(j,n,m)=(sum1/sum2)-dexj(j,n,m)
		dCi(j,n,m)=dCi(j,n,m)*Ci(j)/delta
              endif
 4444        continue
 4445     continue
       endif

c       write(*,*)'debug1 Ci(1) =',Ci(1)
c       etb=Ci(1)
c       if(dograd)then
c       do n=1,natom
c         dEdx(n)=dCi(1,n,1)
c         dEdy(n)=dCi(1,n,2)
c         dEdz(n)=dCi(1,n,3)
c	 write(*,*)'debug5 i dEdxyz: ',n,dEdx(n),dEdy(n),dEdz(n)
c       enddo
c       endif
c       return

c Step 2: Do sums
       etb=0.d0
       do 440 j=1,ncsf+ncsfd
          if(Ci(j).lt.cutEj)goto 440
          sum=0.0d0
	  dsum=0.0d0
	  do 441 i=1,ncsf+ncsfd
	    t1=exj(i)-exj(j)
	    t2=dsqrt(t1*t1+lambda)
	    sum=sum+t1-t2
	    if(dograd)then
	      do 4450 n=1,natom
	      do 4450 m=1,3
	        dt1=dexj(i,n,m)-dexj(j,n,m)
c		write(*,*)'debugG8 i j n m dexj(i,n,m) dexj(j,n,m)',
c     *           i,j,n,m,dexj(i,n,m),dexj(j,n,m)
		dsum(n,m)=dsum(n,m)+dt1*(1.0d0-(t1/t2))
c		write(*,*)'debugG7 i n m dsum(n,m)',i,n,m,dsum(n,m)
 4450         continue
	    endif
 441      continue
          sum=exj(j)+0.5d0*sum
          etb=etb+Ci(j)*sum
c	  write(56,*)'DEBUG j Ci sum Ci*sum:',j,Ci(j),sum,Ci(j)*sum
	  if(dograd)then
	     do 4451 n=1,natom
	     do 4451 m=1,3
	        dsum(n,m)=dexj(j,n,m)+0.5d0*dsum(n,m)
 4451        continue
c      write(*,*)'debugG4 dEdx(1) = ',dEdx(1)
             do n=1,natom
	        dEdx(n)=dEdx(n)+dCi(j,n,1)*sum+Ci(j)*dsum(n,1)
c      write(*,*)'debugG5 adding = ',dCi(j,n,1)*sum+Ci(j)*dsum(n,1)
c      write(*,*)'debugG6 j n dCi(j,n,1) Ci(j) dsum(n,1):',
c     *   j,n,dCi(j,n,1),Ci(j),dsum(n,1)
c      write(*,*)'debugG3 dEdx(1) = ',dEdx(1)
	        dEdy(n)=dEdy(n)+dCi(j,n,2)*sum+Ci(j)*dsum(n,2)
	        dEdz(n)=dEdz(n)+dCi(j,n,3)*sum+Ci(j)*dsum(n,3)
	     enddo
c		write(57,*)'DEBUG2 grad comp',j,dCi(j,1,1)*sum+Ci(j)*dsum(1,1)
c		write(59,*)j,dCi(j,1,1),sum,Ci(j),dsum(1,1)
	  endif
 440   continue

c      write(*,*)'debugG2 dEdx(1) = ',dEdx(1)

c Step 3: Get energy
       etb=etb+ep

c If needed, print the reference and dominant CSFs
      if(printlev.ge.2)call printCSF(natom,ndim,nocc,eva,evec,
     *    ncsf,ncsfd,nrm,nrp,nrmd,nrpd,Ci,exj,ep)

      end subroutine filloc

      subroutine TBocc(ndim,nElect,eva,nocc,maxocc)
      use params
      implicit none
      integer ndim,nElect,nocc(ndim),maxocc
      integer i,nBottom
      double precision eva(ndim),upen

      upen=parUpen(icase)

      nocc=0
      
      if(nElect.gt.2*ndim)Stop 'There are not enough MOs'
      
      nBottom=nElect/2
      if(nElect.eq.1)then
         nocc(1)=1
	 maxocc=1
	 return
      else
         do i=1,nElect/2
	    nocc(i)=2
	 enddo
	 if(mod(nElect,2).eq.1)then
	    nocc(i)=1
	    maxocc=nBottom+2
	 else
	    maxocc=nBottom+1
	 endif
      endif

c      write(2,*)'debug block'
c      write(2,*)'parUpen(icase) =',parUpen(icase)
c      write(2,*)'icase =',icase
c      write(2,*)'nBottom =',nBottom
c      write(2,*)'maxocc =',maxocc
c      write(2,*)'upen =',upen/0.03674901d0
c      write(2,*)'eva(nBottom) =',eva(nBottom)/0.03674901d0
c      write(2,*)'eva(nBottom)+upen =',(eva(nBottom)+upen)/0.03674901d0
c      write(2,*)'eva(maxocc) =',eva(maxocc)/0.03674901d0
c      write(2,*)'debug block'

      if(nBottom.eq.0)goto 102
      if(maxocc.gt.ndim)goto 102

 101  if(eva(nBottom)+upen.gt.eva(maxocc))then
         nocc(maxocc)=1
	 maxocc=maxocc+1
	 nocc(nBottom)=1
	 nBottom=nBottom-1

	 if(maxocc.gt.ndim)goto 102
	 if(nBottom.eq.0)goto 102

	 goto 101
	 
      endif

 102  continue

      end subroutine TBocc
      
c
c      subroutine obsa4(nElect,natom,nexcit,ndim,eva,noc,nrp,nrm,
c     &nobsmax,ncsf,nobs1)
      subroutine obsa4(nElect,natom,nexcit,ndim,noc,nrp,nrm,
     &nobsmax,ncsf,nobs1)
      implicit real*8(a-h,o-z)
      logical ldone
      dimension eva(ndim)
      dimension noc(ndim),nrp(ndim*ndim+1),nrm(ndim*ndim+1)
      parameter(cut=1.0d-4)

c nobs = highest doubly-occupied MO
c nobs1 = HOMO/SOMO
      nobs=nElect/2
      nobs1=nobs
      if(2*(nElect/2).ne.nElect)nobs1=nobs1+1
      nobsmax=nobs1+nexcit
      
cc check for degeneracy of highest virtual MO in excitation scheme
c      ldone=.false.
c      nhigh=nexcit
c      do while(.not.ldone)
c	 if(nobsmax.eq.ndim)then
c	   ldone=.true.
c	   goto 22
c	 elseif(nobsmax.gt.ndim)then
c	    ldone=.true.
c	    nobsmax=ndim
c	    goto 22
c	 endif
c         diff=abs(eva(nobsmax+1)-eva(nobsmax))
c	 if(diff.le.cut)then
c	    nobsmax=nobsmax+1
c	    nhigh=nhigh+1
c	 else
c	    ldone=.true.
c	 endif
c 22     continue
c      enddo

c I don''t think I want to included the SOMO in the counting of MOs
c      nobss=nobs1-nexcit
      nobss=nobs-nexcit+1
      
c check for degeneracy of lowest occupied MO in excitation scheme
c      ldone=.false.
c      nlow=nexcit
c      do while(.not.ldone)
c	 if(nobss.eq.1)then
c	    ldone=.true.
c	    goto 23
c	 endif
c	 if(nobss.le.0)then
c	    ldone=.true.
c            nobss=1
c	    goto 23
c	 endif
c         diff=eva(nobss)-eva(nobss-1)
c	 if(diff.le.cut)then
c	    nobss=nobss-1
c	    nlow=nlow+1
c	 else
c	    ldone=.true.
c	 endif
c 23     continue
c      enddo
c
       nobss=1
       nobssmax=ndim
       nlow=nobs1
       nhigh=ndim-nobs1

c      do i=1,nobsmax
c      noc(i)=0
c      enddo
      noc=0
      do i=1,nobs
      noc(i)=2
      enddo     
      if(nobs1.ne.nobs)noc(nobs1)=1
      nrm(1)=nobs1
      nrp(1)=nobs1
      j1=1
      do k=1,nlow
      if(2*(nElect/2).ne.nElect.and.k.ne.nlow)then
      j2=0
      j3=nhigh
      elseif((2*(nElect/2).ne.nElect).and.(k.eq.nlow))then
      j2=1
      j3=nhigh
      elseif((2*(nElect/2)).eq.nElect)then
      j2=1
      j3=nhigh
      endif
      do j=j2,j3
      j1=j1+1
      nrm(j1)=nobss+k-1
      nrp(j1)=nobs1+j
      enddo
 1    enddo
      ncsf=j1
      return
      end

      subroutine obsasd2(nElect,natom,nexcit,ndim,noc,nrp,nrm,
     *nrpd,nrmd,nobsmax,ncsf,ncsfd,nobs1)
      implicit real*8(a-h,o-z)
      logical ldone
      parameter(cut=1.0d-3)
      dimension noc(ndim),nrp(ndim*ndim+1),nrm(ndim*ndim+1)
      dimension nrpd(ndim*ndim+1),nrmd(ndim*ndim+1)
      nobs=nElect/2
      nobs1=nobs
      if(2*(nElect/2).ne.nElect)nobs1=nobs1+1
      nobsmax=nobs1+nexcit
      
cc check for degeneracy of highest virtual MO in excitation scheme
c      ldone=.false.
c      nhigh=nexcit
c      do while(.not.ldone)
c	 if(nobsmax.eq.ndim)then
c	   ldone=.true.
c	   goto 22
c	 elseif(nobsmax.gt.ndim)then
c	    ldone=.true.
c	    nobsmax=ndim
c	    goto 22
c	 endif
c         diff=abs(eva(nobsmax+1)-eva(nobsmax))
c	 if(diff.le.cut)then
c	    nobsmax=nobsmax+1
c	    nhigh=nhigh+1
c	 else
c	    ldone=.true.
c	 endif
c 22     continue
c      enddo

c I don''t think I want to included the SOMO in the counting of MOs
c      nobss=nobs1-nexcit
      nobss=nobs-nexcit+1
      
cc check for degeneracy of lowest occupied MO in excitation scheme
c      ldone=.false.
c      nlow=nexcit
c      do while(.not.ldone)
c	 if(nobss.eq.1)then
c	    ldone=.true.
c	    goto 23
c	 endif
c	 if(nobss.le.0)then
c	    ldone=.true.
c            nobss=1
c	    goto 23
c	 endif
c         diff=abs(eva(nobss)-eva(nobss-1))
c	 if(diff.le.cut)then
c	    nobss=nobss-1
c	    nlow=nlow+1
c	 else
c	    ldone=.true.
c	 endif
c 23     continue
c      enddo

       nobss=1
       nobssmax=ndim
       nlow=nobs1
       nhigh=ndim-nobs1

      noc=0
      do i=1,nobs
      noc(i)=2
      enddo     
      if(nobs1.ne.nobs)noc(nobs1)=1
      nrm(1)=nobs1
      nrp(1)=nobs1
c      nrmd(1)=nobs1
c      nrpd(1)=nobs1

      j1=1
      do k=1,nlow
      if(2*(nElect/2).ne.nElect.and.k.ne.nlow)then
      j2=0
      j3=nhigh
      elseif((2*(nElect/2).ne.nElect).and.(k.eq.nlow))then
      j2=1
      j3=nhigh
      elseif((2*(nElect/2).eq.nElect).and.(k.ne.nlow))then
      j2=1
      j3=nhigh
      elseif((2*(nElect/2)).eq.nElect)then
      j2=1
      j3=nhigh
      endif
      do j=j2,j3
      j1=j1+1
      nrm(j1)=nobss+k-1
      nrp(j1)=nobs1+j
      enddo
 1    enddo
      ncsf=j1

      j1=0
      if(2*(nElect/2).eq.nElect)then
      do i=2,ncsf
      nrmd(i-1)=nrm(i)
      nrpd(i-1)=nrp(i)
      j1=j1+1
      enddo
      else
      do k=0,nlow-1
      do j=1,nhigh
      j1=j1+1
      nrmd(j1)=nobss+k
      nrpd(j1)=nobs1+j
      enddo
      enddo
      endif
      ncsfd=j1
      end

      subroutine dogamAB(i,j,natom,x,y,z,r,idtype,gam,dgam)

      use params
      use grad
      implicit none

      integer i,j,natom,idtype(natom),ip,jp,lpr
      double precision gam,dgam(3),rij,r2,d,alp2,t1,t2,te,tt
      double precision alphaI,alphaJ,den
      double precision x(natom),y(natom),z(natom),r(natom,natom)
      double precision el,em,en,elladmm,ellmimm,enn
      common /lmn/ el,em,en,elladmm,ellmimm,enn

      ip=min(idtype(i),idtype(j))
      jp=max(idtype(i),idtype(j))

      select case(icase)
      case(1:8)
         alphaI=parAlpha(icase,ip)
         alphaJ=parAlpha(icase,jp)
         d=pard(icase,ip,jp)
         alp2=alphaI*alphaJ
         rij=r(i,j)
         r2=rij*rij
   
         den=dsqrt(r2+alp2*dexp(-r2/(d*alp2)))
         gam=1.0d0/den

	 if(dograd)then
            call lmndlm(i,j,natom,x,y,z,r)
            te=dexp(-r2/(d*alp2))
            t1=alp2*te+r2
            t1=1.0d0/dsqrt(t1*t1*t1)
            t2=(te/d)-1.0d0
            tt=rij*t1*t2
            dgam(1)=tt*el
            dgam(2)=tt*em
            dgam(3)=tt*en
	 endif
      case default
         write(*,*)'icase ',icase,'undefined in subroutine dogamAB'
	 stop
      end select

      end subroutine dogamAB

      subroutine dogamAA(gam,id)

      use params
      implicit none
      integer id
      double precision gam

      select case(icase)
      case(1:8)
         gam=1.0d0/parAlpha(icase,id)
      case default
         write(*,*)'icase ',icase,'undefined in subroutine dogamAA'
	 stop
      end select

      end subroutine dogamAA
c
c
c      subroutine genrrp(i,j,rij,repul,drepul)
c
c      implicit none
c      integer i,j
c      double precision repul,drepul(3),rij
cc
cc Repulsion: Hydrogen --- other elements.
cc
cc      if (i.eq.1) then
cc        if (j.eq.1) then
cc          call h_h_rp(repul,drepul)
cc        else if (j.eq.2) then
cc          call chhcrp(repul,drepul)
cc        else 
cc          call htrhrp(j,repul,drepul)
cc        endif
cc
cc Repulsion: Carbon   --- other elements.
cc
cc      else if (i.eq.2) then
cc        if (j.eq.1) then
cc          call chhcrp(repul,drepul)
cc        else if (j.eq.2) then
cc          call c_c_rp(repul,drepul)
cc        else
cc          call ctrcrp(j,repul,drepul)
cc        endif
ccc
ccc Repulsion:  Al  --- C, H, and itself.
ccc
cc      else
cc        if (j.eq.1) then
cc          call htrhrp(i,repul,drepul)
cc        else if (j.eq.2) then
cc          call ctrcrp(i,repul,drepul)
cc        else
c          if (i.eq.j) then
c            call alalrp(i,rij,repul,drepul)
c          else
c            stop "The parameters for the two elements are unavailable."
c          endif
cc        endif
cc      endif
c
c      return
c      end

c      integer function natm(a)
c      implicit none
c      integer a,val
c      
c      val=(a-1)/4
c      natm=val+1
c
c      end function natm

      subroutine dCijn (i,j,natom,ndim,evec,eva,natm,dham,dCn)

      implicit none
      integer i,j,n,natom,ndim
      double precision evec(ndim,ndim),eva(ndim)
      double precision dCn(natom,3),dham(ndim,ndim,3)

      double precision summ,suml,sumk,tmp
      integer k,l,m,nn
      integer natm(ndim)

      do 1 n=1,natom
      do 1 nn=1,3
         sumk=0.0d0
	 do 2 k=1,ndim
c	   if((k.eq.j).or.(dabs(eva(j)-eva(k)).le.1.0d-10))goto 2
	   if((k.eq.j).or.(eva(j).eq.eva(k)))goto 2
c	   if(k.eq.j)goto 2
	   suml=0.0d0
	   do 3 l=1,ndim
	      summ=0.0d0
	      do 4 m=1,ndim
	         if((natm(l).eq.n).and.(natm(m).ne.n))then
		    summ=summ+dham(l,m,nn)*evec(m,j)
c		    summ=summ-dham(m,l,nn)*evec(j,m)
	         elseif((natm(l).ne.n).and.(natm(m).eq.n))then
		    summ=summ-dham(l,m,nn)*evec(m,j)
c		    summ=summ+dham(m,l,nn)*evec(j,m)
		 endif
 4            continue
c              suml=suml+evec(k,l)*summ
              suml=suml+evec(l,k)*summ
 3         continue
c           sumk=sumk+evec(i,k)*suml/(eva(k)-eva(j))
           sumk=sumk+evec(i,k)*suml/(eva(j)-eva(k))
c	   write(*,*)'debugG14 j i k eva(j) eva(k) diff:',j,i,k,eva(j),
c     *       eva(k),eva(j)-eva(k)
c           sumk=sumk+evec(k,i)*suml/(eva(k)-eva(j))
c           sumk=sumk+evec(k,i)*suml/(eva(j)-eva(k))
 2       continue
         dCn(n,nn)=sumk
 1    continue
      end subroutine dCijn

c 88888888888888888888888888888888888888888888888888888888888888888888888
c The following function is taken from
c Y. Wang and C.H. Mak, Chem. Phys. Lett. 235, 37-46 (1995).
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine wangma (r,t0,r0,na,nb,rt,nc,t,dt)

      implicit none
      double precision t0,r0,na,nb,rt,nc,t,dt,r,tmp

      tmp=(r/rt)**nc

      t=t0*(r0/r)**na*(exp(-tmp+(r0/rt)**nc))**nb
      dt=(-na-nb*nc*tmp)*t/r

      end subroutine wangma
      
c 88888888888888888888888888888888888888888888888888888888888888888888888
c  This formula is taken from:
c  N.N. Lathiotakis, A.N. Andriotis, M. Menon, and J. Connolly, J. Chem. 
c  Phys. 104, 992-1003 (1996).
c 88888888888888888888888888888888888888888888888888888888888888888888888
c
      subroutine lathio (r,eta,rd,d,tau,alpha,V,dV)

      implicit none
      double precision eta,rd,d,tau,alpha,V,dV,r
      double precision hbar2_me
c hbar2_me equals (hbar)^2 / me = 7.62 eV.Ang^-2 = 1.000 au
      parameter(hbar2_me=1.0000d0)

c      V=eta*7.62d0*rd**tau/d**(tau+2.0)*exp(-alpha*(r-d))
      V=eta*rd**tau/d**(tau+2.0)*exp(-alpha*(r-d))
      dV=-alpha*V

      end subroutine lathio

C This subroutine is an interface to call two subroutines to compute the 
C overlap integrals (one has the same zeta values, the other has different
C zeta values.
      subroutine ovlcon(r,Np,Lp,zetap,N,L,M,zeta,intgr,dintgr)

      implicit none
      integer Np,Lp,N,L,M
      double precision zetap,zeta,intgr,dintgr,r

      if(Np.le.Lp .or. N.le.L)then
        intgr=0.0 
        dintgr=0.0 
        return
      endif

      if (abs(zetap-zeta) .lt. 0.001) then
        zeta=(zeta+zetap)/2.0
        call ovlapd(r,Np,Lp,zeta,N,L,M,intgr,dintgr)
      else
        call dovlap(r,Np,Lp,zetap,N,L,M,zeta,intgr,dintgr)
      endif
      end subroutine ovlcon

C The program is coded for Equation (8) in reference:
C   H.W. Jones, Int. J. Quantum Chem. 19, 567 (1981).
C The program basically can work for any combinations of the quantum numbers,
C but the C matrix coefficients provided in the data block preclude that kind
C of job with the principal quantum number bigger than 4.
C For the same zeta.

      subroutine ovlapd(r,CN,CL,zeta,n,l,M,S,dS)
      use basics 
      use cmatrix
      implicit none
      integer CN,CL,n,l,M,i,j,t,u,v,k,w,tmp
      double precision zeta,S,dS,r,p,Keba
      double precision tmpa,tmpb,tmpc

c is r being converted from Ang to au? If so, r already in au!!
c      a=r/0.52917706
c      p=zeta*a
      p=zeta*r

c MAI: orig had r.gt.10 but then r was in Ang instead of au
c      if (r.gt.10.0) then
      if (r.gt.20.0) then
        S=0.0
        dS=0.0
        return
      endif

      Keba=2**(CN+n)*(-1)**M 

      tmpa=(2*CL+1)*(2*l+1)
      tmp=l+M
      tmpa=tmpa*fact(tmp)
      tmp=CL-M
      tmpa=tmpa*fact(tmp)
      tmp=2*CN
      tmpa=tmpa/fact(tmp)
      tmp=2*n
      tmpa=tmpa/fact(tmp)
      tmp=CL+M
      tmpa=tmpa/fact(tmp)
      tmp=l-M
      tmpa=tmpa/fact(tmp)

      Keba=Keba*sqrt(tmpa)

      S=0.0
      dS=0.0

      do 1 i=0,n+CL+l
        do 2 j=0,n+CL
          t=j+CN-CL
          u=j+CN-2*CL-l+i
          v=i-CL-l-1
          S=S+cmatrx(CL,n,l,M,i,j)*
     &       ((-1)**j*p**u/(t+1)-fact(t)*p**v/2**(t+1))
          dS=dS+cmatrx(CL,n,l,M,i,j)*zeta*
     &       (u*(-1)**j*p**(u-1)/(t+1)-v*fact(t)*p**(v-1)/2**(t+1))
          tmpa=0.0
          tmpb=0.0
          do 3 k=0,t
            tmp=t-k
            w=t-k+i-l-CL-1
c           print 99,t,u,v,w
c99    format("t,u,v,and w ",4(I2,1x))
            tmpa=tmpa+fact(t)/fact(tmp)*p**w/2**(k+1)
            tmpb=tmpb+w*fact(t)*zeta/fact(tmp)*p**(w-1)/2**(k+1)
 3        continue
c         print *,"tmpa tmpb ",tmpa,tmpb
          S=S+cmatrx(CL,n,l,M,i,j)*(-1)**i*tmpa
          dS=dS+cmatrx(CL,n,l,M,i,j)*(-1)**i*tmpb
 2      continue
 1    continue

      dS=Keba*(exp(-p)*dS-zeta*exp(-p)*S)*(-1)**M
      S=Keba*exp(-p)*S*(-1)**M

cc
cc Convert from bohr -1 to A -1
cc MAI: but TBPAC works in au!!
c      dS=dS/0.52917706

      end subroutine ovlapd

C The program is coded for Equation (8) in reference:
C   H.W. Jones, Int. J. Quantum Chem. 18, 709 (1980).
C The program basically can work for any combinations of the quantum numbers,
C but the C matrix coefficientd provided in the data block preclude that kind
C of job with the principal quantum number bigger than 4.

      subroutine dovlap(r,Nprime,Lprime,zetapm,N,L,M,zeta,S,dS)
      use basics
      use cmatrix
      implicit none
      integer Nprime, Lprime,N,L,M,ns,k,i,j,tmp              !ns lower n
      double precision S,Keba
      double precision zeta,zetapm,tmpa,tmpb,ratioz,azeta,azetap
      double precision expzet,expzpm,azeadd,azminu,Kbrati
      double precision dS,dtempa,dtempb,r

      ratioz=(zetapm/zeta)**(Nprime+0.50)

c MAI: no need to convert to au since r already in au
c      a=r/0.52917706

      if (r.gt.10.0) then
        S=0.0
        dS=0.0
        return
      endif

      azetap=r*zetapm
      azeta=r*zeta

      expzet=dexp(-azeta)
      expzpm=dexp(-azetap)

      azeadd=azetap+azeta
      azminu=azetap-azeta

      Keba=2**(Nprime+N)*(-1)**M

      tmpa=(2*L+1)*(2*Lprime+1)
      tmp=L+M
      tmpa=tmpa*fact(tmp)
      tmp=Lprime-M
      tmpa=tmpa*fact(tmp)
      tmp=2*Nprime
      tmpa=tmpa/fact(tmp)
      tmp=2*N
      tmpa=tmpa/fact(tmp)
      tmp=Lprime+M
      tmpa=tmpa/fact(tmp)
      tmp=L-M
      tmpa=tmpa/fact(tmp)

      keba=Keba*dsqrt(tmpa)

      S=0.0
      dS=0.0

      do 1 i=0,(N+L+Lprime)
        do 2 j=0,(N+Lprime)
          ns=Nprime-Lprime+j
          tmpa=0.0
          dtempa=0.0
          do 3 k=0,ns
            tmpb=(-1)**j/azminu**(k+1)
            tmpb=(-1)**i/azeadd**(k+1)-tmpb 
            tmp=ns-k
            tmpb=tmpb/fact(tmp)
C Prepare to compute the first derivative
c            dtempb=-(k+1)*tmpb/a
            dtempb=-(k+1)*tmpb/r
            tmpa=tmpa+tmpb
            dtempa=dtempa+dtempb
 3        continue   
          tmpa=tmpa*expzpm
          dtempa=dtempa*expzpm-zetapm*tmpa
C
          tmpb=1.0/azeadd**(ns+1)
          tmpb=(-1)**j/azminu**(ns+1)-tmpb
c          dtempb=-(ns+1)*tmpb/a
          dtempb=-(ns+1)*tmpb/r
          tmpb=tmpb*expzet
          tmpa=tmpa+tmpb
          dtempb=dtempb*expzet-zeta*tmpb
          dtempa=dtempa+dtempb

          tmp=Nprime-2*Lprime-L+i+j
          tmpb=fact(ns)*cmatrx(Lprime,N,L,M,i,j)*azeta**tmp
c          dtempb=tmp*tmpb/a
          dtempb=tmp*tmpb/r

          S=S+tmpa*tmpb
          dS=dS+tmpa*dtempb+dtempa*tmpb

 2      continue
 1    continue
 
      Kbrati=Keba*ratioz

      S=S*Keba*ratioz*(-1)**M
      dS=dS*Keba*ratioz*(-1)**M
c
cc Convert from bohr -1 to A -1
cc MAI: no need since TBPAC works in au
c      dS=dS/0.52917706
      end subroutine dovlap

      subroutine printMO(natom,ndim,nElect,nocc,eva,evec,qp)

      use printing

      implicit none
      
      integer natom,ndim,nElect
      integer nocc(ndim),i,j,na,nb
      double precision eva(ndim),evec(ndim,ndim),co,qp(ndim)

      write(funit,*)'********************************************',
     &     '***********************'
      write(funit,*)'Molecular Orbital Occupancies, Energies and ',
     &     'Partial Orbital Charges'
      write(funit,*)'********************************************',
     &     '***********************'
      write(funit,*)
      i=index(unitesym,' ')
      write(funit,*)'============================================',
     *  '=================='
      write(funit,*)'  M.O.     Energy (',unitesym(1:i-1),
     *   ')     Occupancy    Partial Orbital Charge'
      write(funit,*)'--------------------------------------------',
     *  '------------------'
      do i=1,ndim
         write(funit,10)i,eva(i)/unite,nocc(i),qp(i)
      enddo
      write(funit,*)'============================================',
     *  '=================='
      write(funit,*)'Number of electrons: ',nElect
      write(funit,*)

      if(printlev.ge.3)then
        write(funit,*)
        write(funit,*)'*************************************'
	write(funit,*)'Description of the Molecular Orbitals'
        write(funit,*)'*************************************'
        write(funit,*)
	do i=1,ndim
	   write(funit,*)'====='
	   write(funit,300)i,eva(i)/unite,nocc(i)
	   write(funit,*)'====='
           write(funit,105)'j','atom','Cij'
	   do j=1,ndim
            co=evec(j,i)
c            co=evec(i,j)
	    if(dabs(co).ge.cutMO)then
	      na=(j+3)/4
	      nb=mod(j+3,4)
	      select case(nb)
	      case(0)
	         write(funit,104)j,na,'s',co
	      case(1)
	         write(funit,104)j,na,'px',co
	      case(2)
	         write(funit,104)j,na,'py',co
	      case(3)
	         write(funit,104)j,na,'pz',co
	      end select
	    endif  
           enddo
	enddo
      endif
 300  format('MO ',I2,' Energy = ',F10.5,' Occupancy = ',I1)
 105  format(4X,A1,4X,A4,3X,A6)
 104  format(2X,I3,2x,I3,X,A2,X,F11.5)
 10   format(2X,I4,2X,F10.5,14X,I1,14X,F8.4)

      end subroutine printMO

      subroutine printHS(natom,ndim,H,S)

      use grad
      use printing

      implicit none

      integer natom,ndim,i,j,k
      double precision H(ndim,ndim),S(ndimS,ndimS)

      write(funit,*)'**************************************'
      write(funit,*)'Hamiltonian Matrix Elements in ',unitesym
      write(funit,*)'**************************************'
      do i=0,ndim/8
        if(i.lt.ndim/8)then
          do k=1,ndim
            write(funit,100)k,(H(i*8+j,k)/unite,j=1,8)
          enddo
        else if (mod(ndim,8).ne.0) then
          do k=1,ndim
            write(funit,100)k,(H(j,k)/unite,j=8*i+1,ndim)
          enddo
        endif
      enddo
      write(funit,*)

      if(doS)then
      write(funit,*)'**********************************'
      write(funit,*)'Overlap Matrix Elements in ',unitesym
      write(funit,*)'**********************************'
      do i=0,ndim/8
        if(i.lt.ndim/8)then
          do k=1,ndim
            write(funit,100)k,(S(i*8+j,k),j=1,8)
          enddo
        else if (mod(ndim,8).ne.0) then
          do k=1,ndim
            write(funit,100)k,(S(j,k),j=8*i+1,ndim)
          enddo
        endif
      enddo
      endif
      write(funit,*)
      write(funit,*)
 100  format(T1,I3,8(f9.4))
      end subroutine printHS

      subroutine printCSF(natom,ndim,nocc,eva,evec,ncsf,ncsfd,nrm,nrp,
     +   nrmd,nrpd,Ci,exj,Eval0)

      use printing

      implicit none

      integer natom,ndim
      integer nocc(ndim),i,j,na,nb,ii
      double precision eva(ndim),evec(ndim,ndim),co
      integer ncsf,ncsfd,nmo,ls
      integer nrp(ndim*ndim+1),nrm(ndim*ndim+1)
      integer nrpd(ndim*ndim+1),nrmd(ndim*ndim+1)
      double precision Ci(2*ndim*ndim+1),exj(2*ndim*ndim+1)
      double precision Eval0,ep

      ls=index(unitesym,' ')-1
      write(funit,*)'******************************************'
      write(funit,*)'   Configuration State Functions (CSFs)'
      write(funit,*)'******************************************'
      write(funit,*)
      write(funit,*)
      write(funit,*)'Reference CSF'
      write(funit,*)
      write(funit,103)'|Ci|^2',Ci(1)
      write(funit,103)'Eval(0)',ep/unite,unitesym(1:ls)
      write(funit,103)'Eci(0)',(exj(1)-ep)/unite,unitesym(1:ls)

      do 2 i=2,ncsf
         if(Ci(i).ge.cutCi)then
	   write(funit,*)
	   write(funit,108)'CSF',i
	   write(funit,103)'|Ci|^2',Ci(i)
           write(funit,103)'(Eval(i)-Eval(0))+Eci(i)',exj(i)/unite,
     *         unitesym(1:ls)
	   write(funit,106)nrm(i),eva(nrm(i))/unite,unitesym(1:ls),nrp(i),
     *       eva(nrp(i))/unite,unitesym(1:ls)
           write(funit,*)'Primary Orbital Contributions to Occuplied MO'
           write(funit,105)'j','atom','Cj'
	   nmo=nrm(i)
           do j=1,ndim
              co=evec(j,nmo)
              if(abs(co).ge.cutMO)then
	         na=(j+3)/4
	         nb=mod(j+3,4)
	         select case(nb)
	         case(0)
	            write(funit,104)j,na,'s',co
	         case(1)
	            write(funit,104)j,na,'px',co
	         case(2)
	            write(funit,104)j,na,'py',co
	         case(3)
	            write(funit,104)j,na,'pz',co
	         end select
	      endif
           enddo
           write(funit,*)'Primary Orbital Contributions to Virtual MO'
           write(funit,105)'j','atom','Cj'
	   nmo=nrp(i)
           do j=1,ndim
              co=evec(j,nmo)
              if(abs(co).ge.cutMO)then
	         na=(j+3)/4
	         nb=mod(j+3,4)
	         select case(nb)
	         case(0)
	            write(funit,104)j,na,'s',co
	         case(1)
	            write(funit,104)j,na,'px',co
	         case(2)
	            write(funit,104)j,na,'py',co
	         case(3)
	            write(funit,104)j,na,'pz',co
	         end select
	      endif
           enddo
	 endif
 2    continue

      do 3 i=1,ncsfd
         ii=i+ncsf
         if(Ci(ii).gt.cutCi)then
	   write(funit,108)'CSF',ii
	   write(funit,103)'|Ci|^2',Ci(ii)
           write(funit,103)'(Eval(i)-Eval(0))+Eci(i)',exj(i)/unite,
     *          unitesym
	   write(funit,107)nrmd(i),eva(nrmd(i))/unite,unitesym,nrpd(i),
     *       eva(nrpd(i))/unite,unitesym
           write(funit,*)'Primary Orbital Contributions to Occuplied MO'
           write(funit,105)'j','atom','Cj'
	   nmo=nrmd(i)
           do j=1,ndim
              co=evec(j,nmo)
              if(abs(co).gt.cutMO)then
	         na=(j+3)/4
	         nb=mod(j+3,4)
	         select case(nb)
	         case(0)
	            write(funit,104)j,na,'s',co
	         case(1)
	            write(funit,104)j,na,'px',co
	         case(2)
	            write(funit,104)j,na,'py',co
	         case(3)
	            write(funit,104)j,na,'pz',co
	         end select
	      endif
           enddo
           write(funit,*)'Primary Orbital Contributions to Virtual MO'
           write(funit,105)'j','atom','Cj'
	   nmo=nrpd(i)
           do j=1,ndim
              co=evec(j,nmo)
              if(abs(co).gt.cutMO)then
	         na=(j+3)/4
	         nb=mod(j+3,4)
	         select case(nb)
	         case(0)
	            write(funit,104)j,na,'s',co
	         case(1)
	            write(funit,104)j,na,'px',co
	         case(2)
	            write(funit,104)j,na,'py',co
	         case(3)
	            write(funit,104)j,na,'pz',co
	         end select
	      endif
           enddo
	 endif
 3    continue
      write(funit,*)
      write(funit,*)
     +'****************************************************************'
 1    continue

 103  format(A,' = ',F12.5,' ',A)
 104  format(2X,I3,2x,I3,X,A2,X,F11.5)
 105  format(4X,A1,4X,A4,3X,A6)
 106  format('Exciting an electron from orbital ',
     *       I5,' (e(i) = ',F10.5,' ',A,') to orbital ',I5,
     *       ' (e(j) = ',F10.5,' ',A,')')
 107  format('Exciting TWO electrons from orbital ',
     *       I5,' (e(i) = ',F10.5,' ',A,') to orbital ',I5,
     *       ' (e(j) = ',F10.5,' ',A,')')
 108  format(A,' = ',I6)
      end subroutine printCSF

      subroutine printQ(natom,qn)

      use printing

      implicit none

      integer natom,i
      double precision qn(natom)

      write(funit,*)
      write(funit,*)'**********************'
      write(funit,*)'Partial Atomic Charges'
      write(funit,*)'**********************'
      write(funit,*)
      write(funit,*)'================='
      write(funit,*)'  Atom     Charge'
      write(funit,*)'-----------------'
      do i=1,natom
         write(funit,101)i,qn(i)
      enddo
      write(funit,*)'================='
      write(funit,*)

 101  format(2X,I4,2X,F8.4)

      end subroutine printQ
      subroutine doFMB(i,j,natom,x,y,z,r,idtype,v,Fmb,dFmb,Fcng,dFcng)
!c234567
      use grad
      use params
      implicit none
      integer a,i,natom,j,v,idtype(natom)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),Fmb,dFmb(natom,3)
      double precision Fcng(natom),dFcng(natom,natom,3)
      
      select case (icase)
         case(14:17,18:20)
            call doFs(i,j,natom,x,y,z,r,idtype,v,Fmb,dFmb)
         case(21)
            call doFcn(i,j,natom,x,y,z,r,idtype,v,Fmb,dFmb,Fcng,dFcng)
         case(22)
            call doFba(i,j,natom,x,y,z,r,idtype,v,Fmb,dFmb)
         case default
            Fmb=1.0d0
	    dFmb=0.0d0
         end select
      end subroutine doFMB
      subroutine doFs(a,b,natom,x,y,z,r,idtype,v,Fs,dFs)
!c34567
      use basics
      use params
      use grad 
      implicit none
      integer a,b,v,k,natom,idtype(natom),d,f,g,n,m
      double precision sum,bb(3),e,ee,eee,Xi,rho,drho,lad(3),rb3
      double precision x(natom),y(natom),z(natom),lab(3),lbd(3)
      double precision r(natom,natom),Fs,dFs(natom,3),dXi(natom,3)
      double precision el,em,en,elladmm,ellmimm,enn,tmp,t1,t2
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      
!c v determines which parameter set to use
!c V(li-alpha,lj-beta,lambda)
!c    v=1 => V000
!c    v=2 => V010
!c    v=3 => V110
!c    v=4 => V111
!c Repulsive Interaction
!c    v=5: Vrep(alpha,beta)
!c V(l) in H(ii)(aa)
!c    v=6 => V0 (l=0)
!c    v=7 => V1 (l=1)
!c       b(i,v,h,al) (i=1,3) (v=1,3) !beta(1) beta(2) beta(3) for ea. V
!c234567
      if(a.eq.b)write(*,*)'With v=',v
      if(a.eq.b)write(*,*)'where a=b=',a
      if(a.eq.b)Stop 'Bad call to doFs: a=b'
      Fs=0.0
      d=min(idtype(a),idtype(b))
      f=max(idtype(a),idtype(b))
      do 12 g=1,3
         bb(g)=parBeta(icase,d,f,g,v)
 12   continue
      Xi=0.0
      dFs=0.0
      dXi=0.0
!c first check to see whether Fmb term has been deemed significant
      if(bb(1).eq.0.0d0)then
         Fs=1.0
	 flag(2)=.false.
      else
       flag(2)=.true.
       Fs=0.0
       do 10 d=1,natom
          if((d.ne.a).and.(d.ne.b))then
             rho=(r(a,d)+r(b,d))/r(a,b)
	     rb3=rho**bb(3)
c	     write(2,*)'debug rho**b3 =',rho**bb(3)
             ee=dexp(-bb(2)*rb3)
	     if(dograd)tmp=ee*rb3/r(a,b)
             Xi=Xi+ee
c	     write(2,*)'debug i j k ee:',a,b,d,ee
	     if(dograd)then
                do 100 n=1,natom
		  call lmndlm(a,d,natom,x,y,z,r)
		  if(a.eq.n)then
		     lad(1)=el
		     lad(2)=em
		     lad(3)=en
		  elseif(d.eq.n)then
		     lad(1)=-el
		     lad(2)=-em
		     lad(3)=-en
		  else
		     lad(1)=0.0d0
		     lad(2)=0.0d0
		     lad(3)=0.0d0
		  endif
		  call lmndlm(a,b,natom,x,y,z,r)
		  if(a.eq.n)then
		     lab(1)=el
		     lab(2)=em
		     lab(3)=en
		  elseif(b.eq.n)then
		     lab(1)=-el
		     lab(2)=-em
		     lab(3)=-en
		  else
		     lab(1)=0.0d0
		     lab(2)=0.0d0
		     lab(3)=0.0d0
		  endif
		  call lmndlm(b,d,natom,x,y,z,r)
		  if(b.eq.n)then
		     lbd(1)=el
		     lbd(2)=em
		     lbd(3)=en
		  elseif(d.eq.n)then
		     lbd(1)=-el
		     lbd(2)=-em
		     lbd(3)=-en
		  else
		     lbd(1)=0.0d0
		     lbd(2)=0.0d0
		     lbd(3)=0.0d0
		  endif
		  do 101 m=1,3
		     t1=(lad(m)+lbd(m))/rho
		     t1=t1-lab(m)
		     dXi(n,m)=dXi(n,m)+tmp*t1
c		     t1=r(a,d)+r(b,d)
c		     t1=-t1*lab(m)/(r(a,b)*r(a,b))
c		     t2=(lad(m)+lbd(m))/r(a,b)
c		     drho=t1+t2
c		     dXi(n,m)=dXi(n,m)+ee*tmp*drho
 101              continue
 100            continue
             endif
          endif !if((d.ne.a)...
 10    continue
       Xi=Xi*bb(1)
       if(dograd)dXi=-dXi*bb(2)*bb(3)*bb(1)

c       Fs=Xi
c       if(dograd)then
c       do n=1,natom
c       do m=1,3
c         dFs(n,m)=dXi(n,m)
c       enddo
c       enddo
c       endif
c       return
cc       write(2,*)'debug Xi = ',Xi

       tmp=mtanh(Xi)
       Fs=1.0d0-tmp

       if(dograd)then
c d(-tanh) = -sech^2
c          tmp=-msech2(Xi)
          tmp=1.0d0-tmp*tmp
	  do 110 n=1,natom
	  do 110 m=1,3
	     dFs(n,m)=-tmp*dXi(n,m)
 110      continue
       endif
      endif
c      if(debug2)write(2,*)'In Fs v=',v,' i=',a,' j=',b,' Fs(i,j)=',Fs
      end subroutine doFs
      subroutine doFba(a,b,natom,x,y,z,r,idtype,v,Fba,dFba)
!c234567
      use params
      use grad

      implicit none
      integer a,b,g,d,f,v,i,natom,idtype(natom),n,m
      double precision k(7),e,ee,eee,Rag,Rdb,Fba,dFba(natom,3)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),chi,dchi(natom,3)
      double precision lag(3),lbd(3),tmp,schi
      double precision el,em,en,elladmm,ellmimm,enn
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      
!c v determines which parameter set to use
!c V(li-alpha,lj-beta,lambda)
!c    v=1 => V000
!c    v=2 => V010
!c    v=3 => V110
!c    v=4 => V111
!c Repulsive Interaction
!c    v=5: Vrep(alpha,beta)
!c V(l) in H(ii)(aa)
!c    v=6 => V0 (l=0)
!c    v=7 => V1 (l=1)
!c k(4) is a submatrix of the overall kappa matrix in data_BA
!c234567
      d=min(idtype(a),idtype(b))
      f=max(idtype(a),idtype(b))
      do 12 g=1,4
         k(g)=parKappa(d,f,g,v)
 12   continue
      dFba=0.0
      dchi=0.0d0
      k(5)=k(3)-1.0
      k(6)=k(4)-1.0
      k(7)=k(1)*k(2)*k(3)*k(4)
c      write(*,*)'Kappa1=',k(1)

!c first check to see whether Fmb term has been deemed significant
      if(k(1).eq.(0.0d0))then
         Fba=1.0
	 flag(2)=.false.
      else !if k1.eq.0.0
       flag(2)=.true.
       chi=0.0d0
       do 10 g=1,natom
        if((g.ne.a).and.(g.ne.b))then
          do 11 d=1,natom
             if((d.ne.a).and.(d.ne.b))then
                Rag=r(a,g)
                Rdb=r(d,b)
                e=(Rag**k(3))+(Rdb**k(3))
                ee=dexp(-k(2)*e)
c		write(*,*)'e=',e,' ee=',ee,'Rag=',Rag,'Rbd=',Rdb
                chi=chi+ee
c       write(*,*)'Chi = ',chi
		if(dograd)then
                   do 20 n=1,natom
		      call lmndlm(a,g,natom,x,y,z,r)
		      if(a.eq.n)then
		         lag(1)=el
		         lag(2)=em
		         lag(3)=en
		      elseif(g.eq.n)then
		         lag(1)=-el
		         lag(2)=-em
		         lag(3)=-en
		      else
		         lag(1)=0.0d0
		         lag(2)=0.0d0
		         lag(3)=0.0d0
		      endif
		      call lmndlm(b,d,natom,x,y,z,r)
		      if(b.eq.n)then
		         lbd(1)=el
		         lbd(2)=em
		         lbd(3)=en
		      elseif(d.eq.n)then
		         lbd(1)=-el
		         lbd(2)=-em
		         lbd(3)=-en
		      else
		         lbd(1)=0.0d0
		         lbd(2)=0.0d0
		         lbd(3)=0.0d0
		      endif
		      do 13 m=1,3
c		         write(*,*)'m=',m,' lag=',lag(m),'lbd=',lbd(m)
                         eee=lag(m)*(Rag**k(5))
			 eee=eee+lbd(m)*(Rdb**k(5))
c			 write(*,*)'ee=',ee,' eee=',eee
                         dchi(n,m)=dchi(n,m)+ee*eee
 13                   continue
 20                continue
                endif
             endif !if d.ne.a and d.ne.b
 11       continue
        endif !if g.ne.a and g.ne.b
 10    continue

c       Fba=chi
c       do 111 n=1,natom
c       do 111 m=1,3
c           dFba(n,m)=-dchi(n,m)*k(2)*k(3)
c 111   continue
c       return
      
       chi=chi*k(1)
       e=dtanh(chi)
       Fba=1.0d0-(e**k(4))
       if(dograd)then
          ee=dexp(chi)
	  eee=1.0d0/ee
	  schi=2.0d0/(ee+eee)
	  schi=schi*schi
	  tmp=e**k(6)
	  tmp=tmp*k(7)*schi
          do 14 n=1,natom
          do 14 m=1,3
             dFba(n,m)=tmp*dchi(n,m)
 14       continue
       endif
      endif !if k1.eq.0.0
      end
      subroutine doFcn(a,b,natom,x,y,z,r,idtype,v,Fcn,dFcn,Fcng,dFcng)
!c34567
      use params
      use grad
      
      implicit none
      integer a,b,natom,v,idtype(natom),m,n,o,i
      double precision g(0:2),gam,d,Fcng(natom),Ha,Hb
      double precision dFcng(natom,natom,3),dHa(natom,3)
      double precision dHb(natom,3),tmp
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom)
      double precision Fcn,dFcn(natom,3)

c      save
c      save Fcng,dFcng
      
!c v determines which parameter set to use
!c V(li-alpha,lj-beta,lambda)
!c    v=1 => V000
!c    v=2 => V010
!c    v=3 => V110
!c    v=4 => V111
!c Repulsive Interaction
!c    v=5: Vrep(alpha,beta)
!c V(l) in H(ii)(aa)
!c    v=6 => V0 (l=0)
!c    v=7 => V1 (l=1)
!c234567
      m=min(idtype(a),idtype(b))
      n=max(idtype(a),idtype(b))

      do 12 o=0,2
         g(o)=pargee(m,n,o)
 12   continue
      gam=parFcn(m,n,2,v)
      d=parFcn(m,n,1,v)

c      if(.not.flag(1))call Fcnsetup(natom,x,y,z,r,g(1),g(2),Fcng,dFcng)
c      write(*,*)'Fcng(1) = ',Fcng(1)

      if(d.eq.0.0d0)then
         Fcn=1.0d0
	 dFcn=0.0d0
	 flag(2)=.false.
	 return
      endif
      flag(2)=.true.

      do 2 i=1,natom
      do 2 m=1,3
         dFcn(i,m)=dFcng(a,i,m)
c Borrowing dFcn to use as a dummy variable - will for real define later
 2    continue
      call doHa(a,b,natom,x,y,z,r,Fcng(a),dFcn,g(0),g(1),g(2),
     &   gam,Ha,dHa)

c      Fcn=Ha
c      if(dograd)then
c         do 111 n=1,natom
c	 do 111 m=1,3
c	    dFcn(n,m)=dHa(n,m)
c 111     continue
c      endif
c      return
     
c      write(*,*)'Found Ha'
      do 3 i=1,natom
      do 3 m=1,3
         dFcn(i,m)=dFcng(b,i,m)
c Borrowing dFcn to use as a dummy variable - will for real define later
 3    continue
      call doHa(b,a,natom,x,y,z,r,Fcng(b),dFcn,g(0),g(1),g(2),
     &   gam,Hb,dHb)
c      write(*,*)'Found Hb'

      Fcn=1.0d0-d*(1.0d0-Ha*Hb)
c      write(*,*)'Ha=',Ha,'Hb=',Hb,'dHaHb=',d*Ha*Hb

      dFcn=0.0d0
      if(dograd)then
         do 1 n=1,natom
	 do 1 m=1,3
	    tmp=Ha*dHb(n,m)+Hb*dHa(n,m)
	    dFcn(n,m)=d*tmp
 1       continue
      endif

      write(*,*)'Fcn v = ',v,' Fcn = ',Fcn

      end subroutine doFcn

      subroutine doFg(i,j,natom,x,y,z,r,g1,g2,Fg,dFg)
      use grad
      implicit none
      integer i,j,natom
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),g1,g2,e,den
      double precision Fg,dFg(2,3),rij
      double precision el,em,en,elladmm,ellmimm,enn,tmp,t1,t2
      common /lmn/ el,em,en,elladmm,ellmimm,enn
      
      dFg=0.0d0
      rij=r(i,j)
      if(rij.lt.g2)then
         e=(g1*g2)/(rij-g2)
         Fg=dexp(g1+e)
	 if(dograd)then
	    call lmndlm(i,j,natom,x,y,z,r)
	    e=g1*g2*Fg
	    den=rij-g2
	    den=den*den
	    e=-e/den
	    dFg(1,1)=e*el
	    dFg(1,2)=e*em
	    dFg(1,3)=e*en
	    dFg(2,1)=-e*el
	    dFg(2,2)=-e*em
	    dFg(2,3)=-e*en
	 endif
      else
         Fg=0
      endif
      end subroutine doFg
     
      subroutine Fcnsetup(natom,x,y,z,r,Fcng,dFcng)

      use grad
      use params
      implicit none
      integer i,j,m,natom
      double precision Fcng(natom),Fg,dFg(2,3)
      double precision dFcng(natom,natom,3)
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom),g1,g2

      flag(1)=.true.
      Fcng=0.0d0
      dFcng=0.0d0

c For now just use Al values for gamma1 and gamma2
      g1=pargee(3,3,1)
      g2=pargee(3,3,2)
      
      do 1 i=1,natom
      do 2 j=1,natom
         if(i.eq.j)goto 2
	 call doFg(i,j,natom,x,y,z,r,g1,g2,Fg,dFg)
	 Fcng(i)=Fcng(i)+Fg
	 if(dograd)then
	    do m=1,3
	       dFcng(i,i,m)=dFcng(i,i,m)+dFg(1,m)
	       dFcng(i,j,m)=dFcng(i,j,m)+dFg(2,m)
	    enddo
	 endif
 2    continue
 1    continue

      end subroutine Fcnsetup

      subroutine doHa(a,b,natom,x,y,z,r,ga,dga,g0,g1,g2,gam,Ha,dHa)

      use grad
      implicit none
      integer natom,n,m,a,b
      double precision ga,dga(natom,3),g0,gam,Ha,dHa(natom,3)
      double precision Fg,dFg(2,3),t1,t2,g1,g2,t3
      double precision x(natom),y(natom),z(natom)
      double precision r(natom,natom)

      dHa=0.0d0

      call doFg(a,b,natom,x,y,z,r,g1,g2,Fg,dFg)
      t3=(ga-Fg)/g0
      t1=t3**gam
      Ha=1.0d0/(1.0d0+t1)
c      write(*,*)'ga=',ga,'Fg=',Fg,'t1=',t1,'Ha=',Ha
      if(dograd)then
         t1=t3**(gam-1.0d0)
	 t2=1.0d0+t3**gam
	 t2=1.0d0/(t2*t2)
	 t1=-gam*t1*t2/g0
	 do 1 n=1,natom
	 do 1 m=1,3
	    if(n.eq.a)then
	       t2=dga(n,m)-dFg(1,m)
	       dHa(n,m)=t1*t2
	    elseif(n.eq.b)then
	       t2=dga(n,m)-dFg(2,m)
	       dHa(n,m)=t1*t2
	    else
	       dHa(n,m)=t1*dga(n,m)
	    endif
 1       continue 
      endif
      end subroutine doHa
